##################
 Nuitka Changelog
##################

In this document, we track the per version changes and comments. This
becomes a document on the website, as well as individual posts on the
Nuitka blog.

********************
 Nuitka Release 2.0
********************

This release had focus on new features and new optimization. There is a
really large amount of compatibility with things newly added, but also
massive amounts of new features, and esp. for macOS and Windows, lot of
platform specified new abilities and corrections.

Bug Fixes
=========

-  Fix, workaround for private functions as Qt slots not having names
   mangled. Fixed in 1.9.1 already.

-  Fix, when using Nuitka with ``pdm`` it was not detected as using pip
   packages. Fixed in 1.9.1 already.

-  Fix, for ``pydantic`` our lazy loader parser didn't handle all cases
   properly yet. Fixed in 1.9.1 already.

-  Standalone: Added data files for ``pyocd`` package. Fixed in 1.9.1
   already.

-  Standalone: Added DLL for ``cmsis_pack_manager`` package. Fixed in
   1.9.1 already.

-  Standalone: Fix, the specs expanded at run time in some causes could
   contain random characters. Fixed in 1.9.2 already.

-  Fix, ``{"a":b, ...}.get("b")`` could crash at runtime. Fixed in 1.9.2
   already.

-  Standalone: Added data files for ``pyproj`` package. Fixed in 1.9.2
   already.

-  Standalone: Added more metadata requirements for ``transformers``
   package. Fixed in 1.9.2 already.

-  Plugins: Fix, could crash when including packages from the command
   line, if they had yaml configuration that requires checking the using
   module, e.g. anti-bloat work. Fixed in 1.9.3 already.

-  Standalone: Added support for ``delphifmx`` package. Fixed in 1.9.4
   already.

-  Android: Fix, cannot exclude ``libz`` on that platform, it's not a
   full Linux OS. Fixed in 1.9.3 already.

-  Standalone: Add needed DLLs for ``bitsandbytes`` package. Fixed in
   1.9.3 already.

-  Windows: Fix, newer ``joblib`` was not working anymore. Fixed in
   1.9.3 already.

-  Windows: Fix, could crash when working with junctions that switch
   drives. Fixed in 1.9.3 already.

-  Fix, was crashing with poetry installed environments. Fixed in 1.9.3
   already.

-  Standalone: Added support for newer ``chromadb`` package. Fixed in
   1.9.3 already.

-  Fix, could crash in report creation on modules excluded that were
   asked via command line for inclusion. Fixed in 1.9.3 already.

-  Anti-Bloat: Fix for newer ``streamlit``, it was causing
   ``SyntaxError`` for the compilation. Fixed in 1.9.4 already.

-  Arch: Added support for their OS release file location too. Fixed in
   1.9.4 already.

-  Windows: Fix, MinGW64 doesn't accept chinese module names a C source
   files. Use short paths for these instead. Fixed in 1.9.4 already.

-  Standalone: Added missing DLL for ``libusb_package`` package. Fixed
   in 1.9.4 already.

-  Fix, properly skip directories with non-module top level names when
   trying to find top level packages of distributions. Fixed in 1.9.4
   already.

-  Fix, avoid memory leak bug in triggered by ``rich`` package. Fixed in
   1.9.4 already.

-  Python3.11+: Fix, didn't detect non-keywords on star dict calls in
   some cases. Fixed in 1.9.4 already.

-  Fix, avoid crashes due to unrecognized installers on macOS and
   Windows, some packages that are built via legacy fallbacks of certain
   pip versions do not leave any indication of their origin at all.
   Fixed in 1.9.4 already.

-  Windows: Fix, need to indicate that the program is long path aware or
   else it cannot work with the paths. Fixed in 1.9.4 already.

-  Debian: The ``extern`` namespace might not exist in the
   ``pkg_resources`` module, make the code work with versions that
   remove it and use the proper external package names then. Fixed in
   1.9.6 already.

-  Compatibility: Fix, need to also have ``.exists`` method in our files
   reader objects. Fixed in 1.9.5 already.

-  macOS: Fix, PyQt5 standalone can fail due to ``libqpdf`` too.

-  Compatibility: Make ``dill-compat`` plugin support module mode too,
   previously this only worked for executables only. Fixed in 1.9.6
   already.

-  Standalone: Added data file for ``curl_cffi`` package. Fixed in 1.9.6
   already.

-  Windows: Fix warnings given by MinGW64 in debug mode for onefile
   compilation. Fixed in 1.9.6 already.

-  Python2: The handling of DLL permission changes was not robust
   against using unicode filenames. Fixed in 1.9.7 already.

-  Python2: Fix, could crash on Debian packages when detecting their
   installer. Fixed in 1.9.7 already.

-  Standalone: Added required data file for ``astor`` package. Fixed in
   1.9.7 already.

-  Reports: Fix, in case of build crashes during optimization, the bug
   report creation could be crashing because the module is not in the
   list of done modules yet. Fixed in 1.9.7 already.

-  Python2: Fix, ``unittest.mock`` was not yet available, code
   attempting to use it was crashing the compilation. Fixed in 1.9.7
   already.

-  Accelerated: Fix, tensorflow configuration removing ``site`` usage
   needs to apply only to standalone mode. Fixed in 1.9.7 already.

-  Plugins: Fix, the ``get_dist_name`` Nuitka package configuration
   function could crash in some rare configurations. Fixed in 1.9.7
   already.

-  Standalone: Added necessary data file for ``pygame`` package. Added
   in 1.9.7 already.

-  Standalone: Fix, was not properly handling standard library
   overloading module names for decisions. Inclusion and compilation
   mode were made as if the module was part of the standard library,
   rather than user code. This is now properly checking if it's also an
   actual standard library module.

-  Plugins: Fix, crashing on missing absence message with no UPX binary
   was found.

-  Windows: Fix, couldn't load extension modules from UNC paths, so
   standalone distributions failed to launch from network drives. This
   now works again and was a regression from adding support for symlinks
   on Windows.

-  Standalone: Added support for non-legacy ``pillow`` in ``imageio``
   package.

-  Standalone: Added required ``easyOCR`` data file.

-  Nuitka-Python: Fix, do not demote to non-LTO for "too many" modules
   there in the default auto mode, it doesn't work without it.

-  Fix, ``python setup.py install`` could fail. Apparently it tries to
   lookup Nuitka during installation, which then could fail, due to
   hacks we due to make sure wheels are platform dependent. That hack is
   of course not really needed for install, since no collision is going
   to happen there.

-  macOS: Fix, the standard ``matplotlib`` plugin that uses native UI
   was not included yet, and it was also not working due to bindings
   requiring uncompiled functions, which is now worked around.

-  Compatibility: Add back PySide6 workaround for overloading names like
   ``update`` with slots.

-  Standalone: Added ``geopandas`` data files.

-  Python2: Fix, code objects must be made from ``str`` exactly,
   ``unicode`` however was used in some configurations after recent
   improvements to the run time path handling.

-  Standalone: Added missing data files for ``boto``, the predecessor of
   ``boto3`` as well.

-  Standalone: Added missing DLL for ``tensorflow`` factorization
   module.

-  Compatibility: Fix, PySide2 and PySide6 signal disconnection without
   arguments were not working yet.

-  Standalone: Added support for ``toga``.

-  Scons: Fix, need to Avoid picking up ``clang`` from PATH on Windows
   with ``--clang`` provided, as only our winlibs version is really
   working.

-  Fix, version of ``setuptools`` when included (which we try to avoid
   very much) was ``None`` which breaks some users of it, now it's the
   correct version so checks of e.g. ``setuptools_scm`` can succeed.

-  Fix, icon options for platforms were conflated, so what should be
   windows only icon could get used on other platforms as well.

-  Fix, could not create compiled methods from compiled methods. Also
   now errors out for invalid types given properly.

New Features
============

-  Plugins: Added support for module decisions, these are ``parameters``
   provided by the user which can be used to influence the Nuitka per
   package configuration with a new ``get_parameter`` function. We are
   using these to control important choices in the user, sometimes
   warning it to make that decision, if the default can be considered
   problematic.

-  Plugins: Added support for ``variables`` in Nuitka package
   configurations. We can now query at compile time, values from
   installed packages and use them, e.g. to know what backend is to be
   used.

-  Standalone: Added module decision to disable Torch JIT. This is
   generally the right idea, but the decision is still asked for since
   some packages and programs want to do Torch Tracing, and that is then
   disabled as well. This makes a bunch of transformers programs work.

-  Standalone: Added module decision to disable Numba JIT. This makes
   ``numba`` work in some cases, but not all. Some packages go very deep
   with JIT integration, but simpler uses will now compile.

-  New option ``--include-onefile-external-data`` allows you to specify
   file patterns that you included by other data files others, but to
   put those files not inside, but on the outside of the onefile binary.
   This makes it easier to create deployments fully within Nuitka
   project configuration, and to change your mind back and forth without
   adding/removing the data file option.

-  macOS: Added new value ``auto`` for detecting signing identity, if
   only one is available in the system.

-  macOS: Added support for ``--copyright`` and ``--trademark``
   information to be in app bundles as well, this was previously Windows
   only.

-  Windows: Added support for using junctions in the Python environment,
   these are used e.g. when installing via ``scoop``. Added in 1.9.2
   already.

-  Added option ``--cf-protection`` to select the control flow
   protection mode for the GCC compiler and deviate from default values
   of some environments to less strict values.

-  Reports: Added output filename to report, mainly intended for
   automatically locating the compilation result independent of options
   used.

-  Plugins: Now provides a checksum for yaml files, but not yet verifies
   them at runtime, to ask the user to run the checker tool to update it
   when they make modifications.

-  Windows: Detect when we create too large compiled executables. There
   is a limit of 2GB that you might e.g. violate by attempting to embed
   very large files. This doesn't cover onefile yet.

-  Watch: The tool can now create PRs with the changes in Nuitka-Watch
   for merging, this is for using it in the CI.

-  Watch: Scanning for Python versions now requires ``pipenv`` to be
   installed in them to be found.

-  Watch: Added ability to create branch and PR from watch run results.

-  Plugins: Added ``overridden-environment-variables`` feature to
   package configuration. These are environment variable changes that
   only last during the import of that module and are undone later.

-  Plugins: Added ``force-environment-variables`` feature to package
   configuration. These are environment variable changes done on module
   import that are not undone.

-  Nuitka-Action: Nuitka options that can be given multiple times,
   cannot be specified multiple times in your workflow. As a workaround,
   Nuitka now allows in Actions, to use new lines as separator. This is
   best done with this kind of quoting a multiline string.

   .. code:: yaml

      include-data-dir: |
         a=b
         c=d

-  The Nuitka package configuration ``no-auto-follow`` now applies
   recursively, i.e. that a top level package can have it, and not every
   sub-package that uses a package but should not be automatically
   followed, does have to say this. With this e.g. ``networkx``
   configuration became simpler, and yet covered automatically older
   versions as well, and future changes too.

-  Windows: Added support for compiling in case sensitive folders. When
   this option is enabled, using ``os.path.normcase`` can make filenames
   not found, so with a few cleanups, for lazy code that wasn't really
   using the APIs designed for comparisons and filename suffix testing,
   this works now better.

-  The ``__compiled__`` value has a new attribute ``containing_dir``
   that allows to find where a module, accelerate executable, a
   standalone dist folder, a macOS app bundle, or the onefile binary
   lives in a consistent fashion. This allows esp. better use than
   ``sys.argv[0]`` which points deep into the ``.app`` bundle, and can
   be used cross platform.

Optimization
============

-  Scalability: Avoid variables that are not shared to be treated as if
   they were, marking their type shape as ``tshape_unknown`` in the
   first micro pass. These micro passes are not visible, but basically
   constitute a full visit of the module tree over and over, until no
   more optimization is changing it. This can lead to quicker
   resolution, as that unknown type shape effectively disallowed all
   optimization for variables and reduce the number of necessary micro
   passes by one.

-  Escaped variables did provide a type shape ``tshape_unknown`` and
   while a lot of optimization looks for value knowledge, and gets by
   the escaped nature of the value, sometimes, this was seriously
   inhibiting some of the type based optimization.

-  Loop type shape analysis now succeeds in detecting the types for this
   code example, which is sort of a break-through for future performance
   enhancements in generated code.

   .. code:: python

      # Initial the value of "i" is "NUITKA_NINT_UNASSIGNED" in its
      # indicator part. The C compiler will remove that assignment
      # as it's only checked in the assignment coming up.
      i = 0
      # Assignment from a constant, produces a value where both the C
      # and the object value are value. This is indicated by a value
      # of "NUITKA_NINT_BOTH_VALID". The code generation will assign
      # both the object member from a prepared value, and the clong
      # member to 0.

      # For the conditional check, "NUITKA_NINT_CLONG_VALID" will
      # always be set, and therefore function will resort to comparing
      # that clong member against 9 simply, that will always be very
      # fast. Depending on how well the C compiler can tell if an overflow
      # can even occur, such that an object might get created, it can even
      # optimize that statically. In this case it probably could, but we
      # do not rely on that to be fast.
      while i < 9:  # RICH_COMPARE_LT_CBOOL_NINT_CLONG
         # Here, we might change the type of the object. In Python2,
         # this can change from ``int`` to ``long``, and our type
         # analysis tells us that. We can consider another thing,
         # not "NINT", but "NINTLONG" or so, to special case that
         # code. We ignore Python2 here, but multiple possible types
         # will be an issue, e.g. list or tuple, float or complex.
         # So this calls a function, that returns a value of type
         # "NINT" (actually it will become an in-place operation
         # but lets ignore that too).
         # That function is "BINARY_OPERATION_ADD_NINT_NINT_CLONG"(i, 1)
         # and it is going to check if the CLONG is valid, add the one,
         # and set to result to a new int. It will reset the
         # "NUITKA_NINT_OBJECT_VALID" flag, since the object will not be
         # bothered to create.
         i = i + 1

      # Since "NUITKA_INT_OBJECT_VALID" not given, need to create the
      # PyObject and return it.
      return i

-  Python3.11+: Use ``tomllib`` from standard library for our distutils
   integration into pyproject based builds.

-  Avoid late specialization for ``None`` returns in generators and do
   it during tree building already, to remove noise.

-  Added successful detection of static libpython for self compiled
   Python Linux and macOS. This makes it work with ``pyenv`` as well.

-  Standalone: Avoid including ``.pyx`` files when scanning for data
   files, these are code files too, in this case source files that are
   definitely unused most of the time.

-  macOS: Make static libpython default with CPython for more compact
   standalone distribution and faster binaries.

-  Remove non-existent entries from ``sys.path``, avoiding many file
   system lookups during import scans.

-  Anti-Bloat: Avoid using ``triton`` in ``torch`` package in more
   cases. Added in 1.9.2 already.

-  Anti-Bloat: Avoid using ``pytest`` in ``knetworkx`` package in more
   cases. Added in 1.9.2 already.

-  Anti-Bloat: Avoid using ``IPython`` in ``distributed`` package. Added
   in 1.9.3 already.

-  Anti-Bloat: Avoid using ``dask`` in ``skimage``. Added in 1.9.3
   already.

-  Anti-Bloat: Avoid using ``triton`` in the ``bitsandbytes`` package.
   Added in 1.9.3 already.

-  Anti-Bloat: Avoid ``IPython`` in ``tf_keras`` package as well. Added
   in 1.9.6 already.

-  Anti-Bloat: Avoid ``unittest`` in ``mock.mock`` module. Added in
   1.9.7 already.

-  Avoid importing ``setuptools_scm`` during compilation when using the
   ``tqdm`` inline copy, this also avoids a warning on Ubuntu. Added in
   1.9.7 already.

-  Anti-Bloat: Avoid ``doctest`` in ``skimage`` in their ``tifffile``
   inline copy as well. Added in 1.9.7 already.

-  Anti-Bloat: Avoid ``h5py.tests`` with older ``h5py`` as well. Added
   in 1.9.7 already.

-  Anti-Bloat: Using ``distributed.utils_test`` is also considered using
   ``pytest``.

-  Anti-Bloat: Avoid ``IPython`` in the ``pip`` package.

-  Anti-Bloat: Avoid ``site`` module for older ``tensorflow`` versions
   too.

-  Anti-Bloat: Avoid more ``unittest`` usages in ``tensorflow``
   packages.

-  Anti-Bloat: Avoid ``nose`` in ``skimage`` package.

-  Anti-Bloat: Avoid ``nose`` in ``networkx`` package.

-  Anti-Bloat: Avoid ``nose`` in ``pywt`` package.

Organisational
==============

-  UI: Change template paths over from ``%VAR%`` to ``{VAR}``.

   The old spec values are migrated transparently and continue to work,
   but get a warning when used.

   The new code detects unknown variable names and more formatting
   issues than before.

   Using only the ``{PID}`` value for process ID, is now making it
   temporary value for onefile, that was previously a bug.

   The main benefit and reason of doing this, is that Windows
   ``CMD.EXE`` does expand those values before Nuitka sees them as even
   with quoting ``%TEMP%`` is the current one on the building machine, a
   recipe for disaster. As some people still use that, and e.g.
   ``os.system`` or ``subprocess`` with ``shell=True`` will use it too,
   this is just not sustainable for a good user experience.

   As a result, compile time and run time variables now clash, there is
   e.g. ``{VERSION}`` (program version information given) and
   ``{Version}`` (Nuitka version), and we should clean that up too.

-  Project: Added Code of Conduct. Adapted from the one used in the
   Linux kernel.

-  UI: Warnings given by Nuitka used to be in red color, changed those
   to be yellow for consistency.

-  User Manual: Added pointer for Nuitka-Action `Nuitka-Action
   <https://github.com/Nuitka/Nuitka-Action>`__ for users interested in
   using Nuitka in GitHub workflows.

-  Added ``.gitignore`` to build folder that just causes these folders
   to be ignored by git.

-  User Manual: Added information on how to debug fork bombs from
   created binaries.

-  Debugging: The output of ``--experimental=--report-refcounts`` that
   we use to show leaks of compiled time objects at program exit, now
   counts and reports on functions, generator objects and compiled cells
   as well.

-  Quality: Warnings from ``yamllint`` not disabled are errors. These
   were only output, but didn't cause the autoformat to error exit yet.

-  UI: Enhanced formatting of info traces, drop the ``:INFO`` part that
   shouts, and reserve that for errors and warnings. Also format info
   messages to make sure they fit into the line.

-  UI: Changed ``--show-source-changes`` to accept module pattern to
   make it easier to only see the ones currently being worked on. To get
   the old behavior of showing everything, use ``*`` as a pattern.

-  UI: Allow using ``~`` in data files source path for command line
   options and expand it properly.

-  Quality: Enhanced schema for our package configuration yaml files to
   detect suffixes with leading dots, that is not wanted. These now fail
   checks, but we also tolerate them now.

-  Quality: Check module names used in the package configuration yaml
   files for validity, this catches e.g. trailing dots.

-  Quality: Make sure to really prefer ``clang-format`` from Visual Code
   and MSVC for formatting C code, otherwise a system installed one
   could be used that gives slightly different outputs.

-  Scons: Allow disabling to enforce no warnings for C compilation

   Currently only for gcc, where we need it until loop tracing is
   better, we can now use ``--experimental=allow-c-warnings`` options to
   make ``--debug`` work for some known currently unavoidable warnings.

-  macOS: Make ``--macos-create-app-bundle`` imply standalone mode, it's
   not working or useful for accelerated mode anyway.

-  Standalone: Added support for using self-compiled Python versions
   that are not installed on Linux and macOS. This avoids having to do
   ``make install`` and can ease debugging with changes made in Python
   core itself. Added in 1.9.6 already.

-  Release: Added ability to simple re-date hotfixes. Previously the
   version bump commit needed to be dropped, now a fixup commit is easy
   to generate.

-  Release: Man pages are no longer built during package builds, but are
   available statically in the git, which should make it easier.

-  Release: Disable verbose output in package installation of Nuitka, it
   never was any use, and just makes things hard to read.

-  UI: Check user yaml file present immediately. Otherwise it was
   crashing when parsing yaml files first time with less comprehensible
   exceptions. Added in 1.9.7 already.

-  Quality: Updated to latest ``rstfmt``, ``black`` and ``isort``
   versions.

-  Debian: Remove references to PDF documentation that no longer exists.

-  Quality: Do not crash when collecting modified files due to deleted
   files.

-  UI: Detect the Alpine flavor of Python as well.

-  UI: Detect ``manylinux`` Pythons as a Python flavors as well.

-  UI: Detect self compiled uninstalled Python as a dedicated flavor.

Cleanups
========

-  For the Nuitka-Action part of the available options is now generated
   from Nuitka option definitions itself, adding some previously missing
   options as a result. As a result, adding
   ``--include-onefile-external-data`` was automatic this time.

-  The warnings for onefile only options without onefile mode provided
   have been moved to common code, and in some cases were having wrong
   texts corrected.

-  Use enum definitions in the Nuitka package configuration schema
   rather than manual ``oneOf`` types.

-  The User Manual was proof read and had a bunch of wordings improved.

-  Cleanup, avoid "unused but set variable" warning from the C compiler
   for hard some forms of hard imports.

-  Prefer ``os.getenv`` over ``os.environ.get`` for readability.

-  Changed parts of the C codes that ``clang-format`` had a hard time
   with to something more normal.

Tests
=====

-  When locating the standalone binary created, use a compilation report
   and resolve the path specified there. This allows macOS app bundles
   to be used in these tests as well.

-  Made the PyQt tests executable on macOS too adding necessary options.

-  Added reference test case for unpacking into a list, this was not
   covered but under suspect of reference leaking which turns out to be
   wrong.

-  Much enhanced usage of ``virtualenv`` in the ``distutils`` test
   cases. We make more sure to delete them even in case of issues. We
   disable warnings during Nuitka package installation. The code to
   execute a case was factored out and became more clear. We now handle
   errors in execution with stating what case actually failed, this was
   a bit hard to tell previously. Also do not install Nuitka when a
   pyproject case is used, since the build tool installs Nuitka itself.

Summary
=======

This release deserves the 2.0 marker, as it is ground breaking in many
ways. The loop type analysis stands out on the optimization front. This
will open an avenue for much optimized code at least for some benchmark
examples this summer.

The new features for package configuration, demonstrate abilities to
avoid plugins for Nuitka, where those previously would have been used.
The new ``variables`` and ``parameters`` made it unnecessary to have
them, and still add compile time variable use and user decisions and
information, without them.

The scope of supported Python configurations got expanded a bit, and the
the usual slew of anti-bloat work and new packages supported, makes
Nuitka an ever more round package.

The improved user dialog with less noisy messages and slightly better
coloring, continues a trend, where Nuitka becomes more and more easy to
use.

********************
 Nuitka Release 1.9
********************

This release has had a focus on improved startup time and compatibility
with lazy loaders which has resulted in some optimization. There are
also the usual amounts of bug fixes. For macOS and Linux there are lots
of improvements that should make standalone mode for them robust with
many more configurations.

Bug Fixes
=========

-  Nuitka Action: Fix, the parsing code intended for the github action
   was not working as advertised. Fixed in 1.8.1 already.

-  Standalone: Follow ``soundfile`` change for their DLL names. Fixed in
   1.8.1 already.

-  MSYS: Fix, the recent change to detect their Python flavor with 3.11
   was done wrong. Fixed in 1.8.1 already.

-  Windows: Ignore MS API DLLs found from ``%PATH%``. We only ignored
   them because they come from the Windows system folder, but if any
   program has them, then we did include them. Fixed in 1.8.1 already.

-  Standalone: Fix, ``calendar`` is used by ``time`` built-in module
   actually and therefore must be included. Fixed in 1.8.1 already.

-  Standalone: Added data file for ``unstructured`` package. Fixed in
   1.8.1 already.

-  Standalone: Added data file for ``grpc`` package. Fixed in 1.8.1
   already.

-  Standalone: Added missing dependency for ``skimage``. Fixed in 1.8.1
   already.

-  Python3.11: The dictionary copy code could crash on special kinds of
   dictionaries. Fixed in 1.8.2 already.

-  Standalone: Added data file required by ``ens`` of ``web3`` package.
   Fixed in 1.8.2 already.

-  Fix, ``multiprocessing`` could not access attributes living in
   ``__main__`` module, but only things elsewhere, breaking minimal
   examples. Fixed in 1.8.2 already.

-  Reports: Fix, the license of some packages in case it is ``UNKNOWN``
   was not handling all the cases that wheels expose. Fixed in 1.8.2
   already.

-  Fix, using ``--include-module`` and ``--include-package`` was
   behaving identical for packages. Made the former not include all of
   the package, but only the top level and what that uses.

-  Standalone: Added support for the ``lightning`` package. Fixed in
   1.8.3 already.

-  Distutils: Fix, the platform tag was sometimes incorrect for wheels
   built. Fixed in 1.8.3 already.

-  Compatibility: Make the PySide2/PySide6 signal connection workaround
   more robust. It was not handling reuse of the same method properly
   and insisted on changing ``__name__`` which some objects apparently
   dislike a lot. Fixed in 1.8.4 already.

-  Windows: Fix, need to use short path for the Python installation
   prefix, as it might be unicode path as well. Fixed in 1.8.4 already.

-  Fix, output spec ``%NONE%`` was not compiling anymore. Fixed in 1.8.4
   already.

-  Reports: Avoid having short paths for DLL sources on Windows. Fixed
   in 1.8.4 already.

-  Fix, catch provided metadata from command line
   ``--include-distribution-metadata`` without including the package at
   runtime. Fixed in 1.8.4 already.

-  Python3.10+: Fix, was not properly initializing indicator variable
   used in the ``match`` re-formulation. The generated code still work,
   but this was an error on the logical level to use a variable
   un-initialized. Fixed in 1.8.4 already.

-  Standalone: Added missing DLLs for ``rlottie-python``. Fixed in 1.8.4
   already.

-  Standalone: Added missing implicit dependencies and also avoid
   duplication of DLLs for the ``av`` package. Fixed in 1.8.4 already.

-  Fix, was not handling errors when creating distribution objects.
   Fixed in 1.8.4 already.

-  macOS: Remove extended attributes from DLLs, e.g. ``finder`` can add
   them and it prevents code signing. Fixed in 1.8.4 already.

-  macOS: Workaround for signing tkinter data files properly, we just
   exclude the problematic ones, as they are going to be unused. Fixed
   in 1.8.4 already.

-  Standalone: Added hidden dependency of ``curl_cffi`` package. Fixed
   in 1.8.5 already.

-  Standalone: Added hidden dependency of ``tensorflow`` package. Fixed
   in 1.8.5 already.

-  Standalone: Added more ``kivymd`` data files. Fixed in 1.8.5 already.

-  Standalone: Added implicit dependency for ``winloop`` package. Fixed
   in 1.8.6 already.

-  Windows: Fix, do not resolve main program executable filename to long
   filename. Fixed in 1.8.5 already.

-  Windows: Fix, ignore ``ucrtbase`` runtime DLLs found from ``%PATH%``
   as well. Fixed in 1.8.6 already.

-  Compatibility: Fix, the ``dill-compat`` plugin was regressed and
   support for ``dill`` version 0.3 was added.

-  Fix, need to include package name for ``joblib`` usage with
   ``--python-flag=-m`` to work properly.

-  Windows: Added support for newest ``joblib`` too, we no longer need
   to error for using the latest one.

-  Fix, attribute lookups becoming hard through node factories didn't
   annotate possible exceptions.

-  Standalone: Added support for ``huggingface_hub`` vendored lazy
   loader variant.

-  Standalone: Added support for ``datasets`` module.

-  Plugins: Handle default plugin of ``matplotlib`` a lot better. Be
   more graceful when the query of the default one fails, and point to
   ``MPLBACKEND`` usage. Otherwise inform the user of the backend used
   for ``matplotlib`` so it can be checked.

-  Fix, ``--include-module`` on a package was including all of it rather
   than just top level, which was what it should do. For including the
   full package, there is ``--include-package`` instead.

-  macOS: Fix, need to check dependencies for the selected target arch
   precisely, otherwise DLLs and extension modules for the other arch
   can cause errors for our dependency analysis in standalone mode.

      -  Also added support for getting DLL exported symbols on macOS
         which then allows to properly distinguish extension modules
         from mere DLLs on macOS, and not just Linux.

-  MSYS2: Fix, the GTK DLL name changed again.

-  Compatibility: Added support for ``.zip`` files being in python path
   as well.

-  Fix, when a sub-package module import is rejected for whatever
   reason, the programs attempt to import it, still implies an attempt
   to import the parent module. For extension modules in accelerated
   mode, this is of course common, but the containing package if any, is
   of course still to be included.

-  Fix, PySide6 in accelerated mode needs workarounds too, previously
   only standalone mode was avoiding the corruptions it was causing.

-  Fix, make the PySide2/PySide6 signal connection workaround also fix
   disconnection only. For signals that only ever got disconnected, but
   never connected, the workaround was not applied.

-  MSYS2: For standalone add more GI dlls.

-  Fix, inline copies of e.g. ``tqdm`` could be detected during
   compilation and even in place of the real package.

-  Standalone: Added proper support for ``timm`` without disabling JIT
   generally.

-  Python3.11: Fix, frozen stdlib modules must be turned off

   Otherwise the value of ``os.__file__`` becomes wrong, and maybe more
   issues, as Nuitka is more compatible to full modules than the frozen
   modules are for standalone mode at least.

-  Python2: Avoid RuntimeWarning when using inline copy of ``tqdm``.

-  Standalone: Added support for newer ``pydantic`` and its lazy loader.

-  Standalone: Add config for font data files of ``qtawesome`` package.

-  Plugins: Added workaround for PySide6 enums checking bytecode when
   some older enum values are used. The PySide6 means to detect method
   calls vs. type lookups to decide if to inject the default value for a
   flag value. With our workaround, enums behave as expected without
   that check being possible.

-  Standalone: Added support for ``gradio`` package.

-  Python3.6+: Added support for non-latin (for example Chinese) module
   names, these were not working correctly yet.

-  Python3: Fix, star importing from modules with non-UTF8 encodable
   names in the module dictionary crashed.

-  Python2: Fix, couldn't list directories with unicode filenames in
   them, so that e.g. a Python3 created build directory with unicode
   module names was not possible to fully delete.

-  Compatibility: Added missing ``as_posix`` method to our resource
   reader objects.

-  Standalone: Added missing DLLs for ``PyAutoIt`` package.

-  Standalone: Added data files for the ``flask_restx`` package, for
   which ``--include-package-data`` also wouldn't work, due to its
   strange handling when running in frozen mode.

-  Standalone: Added more metadata requirements for ``transformers``
   package.

-  Standalone: Added support for newer ``transformers`` package.

-  Standalone: Added data files for ``yapf`` vendored ``lib2to3``
   package.

-  Plugins: Fix, was crashing on module patterns of submodules not
   existing in the yaml config implicit dependencies.

New Features
============

-  Plugins: Introduce an explicit hard import registry, that now can be
   expanded at compile time by plugins.

-  Plugins: Added support for ``lazy`` delayed loading, which removes
   the need for ``include-pyi-file`` as we inline its effect at compile
   time. Also, the dependencies of these kinds of packages no longer
   need to be overreaching and can analyze the code again. This is using
   the hard import registry plugin interface.

-  Linux: Standalone builds with PyPI packages no longer include system
   DLLs unless a new Yaml configuration for DLLs called
   ``package-system-dlls`` is configured, which will be necessary for
   GTK bindings probably. With this the included DLLs will more often be
   only ones suitable for use on other OSes. This should make Linux
   standalone somewhat easier, but still need to compile on old OS.

-  Reports: For distributions include the ``installer`` name, so we can
   tell pip, conda or system packages apart better.

-  Reports: For included modules, we now also attribute the
   distributions it directly uses modules from and the distribution the
   module itself belongs to was added as an attribute as well.

-  Reports: Added excluded module reasons to reporting, so that it can
   be told directly, which imports were found, but not followed to. Also
   added report reader capable of providing information from a
   compilation report.

-  Added support for FIPS compliance, a US security standard by NIST,
   that caused parts of Python used by Nuitka to be flagged.

-  Watch: Added option to control the update mode, handles now rc
   versions, so it can be used before and after Nuitka releases easily.

-  Watch: Added timeout for how long programs are allow to run.

-  Watch: Added ability to recognize fork loops happening, so test cases
   of e.g. ``joblib`` do not suddenly go wild on a break change in that
   or other packages.

-  macOS: The ``--list-package-dlls`` now needs to check target arch
   options, so we now delay the non-compiling options execution until
   it's set, which also makes it cleaner code. Also, we can now
   distinguish real Python extension modules from mere DLLs on macOS
   too.

-  Standalone: Also ignore ``av`` and ``cv2`` DLL collisions, making it
   more generic.

-  Standalone: Make ``tk-inter`` plugin more robust. Detect the tkinter
   version used and scan for its paths. Use path used when compiling
   ``tcl`` from source and check data directory paths for ``tcl`` and
   ``tk`` for expected files, and error out if they are not found. With
   these changes self-compiled Python as e.g. used in our commercial
   Linux container is supported too now.

-  Enhanced support for self compiled Python by using link libraries
   needed for static linked extension modules. This allows a better
   commercial Linux container build mainly.

Optimization
============

-  Optimization: Enhanced handling of aliased variables.

   Was not converting variable assignments from variables created during
   re-formulations to the dedicated nodes, potentially missing out on
   optimizations specific to that case, because it was then not
   recognized to be non-generic anymore later.

   Was not optimizing comparisons and truth checks for temporary
   variable references, missing out a lot of opportunities for
   optimization of code coming from re-formulations.

   When a variable is aliased, but the source variable is one that
   cannot escape or is even very hard value, we were not annotating that
   as well as possible, but now e.g. comparisons with constant values
   that are immutable are done even if aliased.

   Remove knowledge of variables assigned to other variables only if
   that value can actually escape, otherwise that has no real point.

-  Use variable length encoding for data blob size values. This removes
   size constraints in some cases, but also makes the representation of
   ``list``, ``tuple``, ``dict`` more compact, since they commonly have
   only a few elements, but we used 4 bytes for length, where the
   average should be close to one 1 byte per length item now.

-  Faster CRC32 with zlib, leading to much faster program startup, and
   faster checksums for cached mode of onefile, improving that a lot as
   well.

-  Windows: Updated MinGW64 to latest winlibs package, should produce
   even faster code and show stopping bugs in its ``binutils`` have
   apparently been fixed. This should now link a lot faster with LTO,
   due to using multiple processes.

-  Added support for ``builtins.open`` as hard import to ``open``.

-  Scalability: Make sure we actually use ``__slots__`` for our classes.
   Variables, code generation context, iteration handles, and type
   shapes didn't really use those and that should speed their use up and
   therefore reduce Python compile time and memory usage.

-  Standalone: Removed one more automatic stdlib module ``textwrap`` as
   it otherwise uses a runner code with test code that is bloating with
   hello world code.

-  Fedora: Enabled LTO linking by default as well, it's working, but
   Fedora Python is still not really good to use, since it doesn't allow
   static linking of libpython.

-  Anti-Bloat: Avoid ``pytest`` usage in ``pooch`` package. Added in
   1.8.1 already.

-  Anti-Bloat: Remove ``pdb`` usage from ``pyparsing`` package. Added in
   1.8.2 already.

-  Anti-Bloat: Remove ``unittest`` usage in ``bitarray``. module. Added
   in 1.8.2 already.

-  Anti-Bloat: Avoid ``lightning`` to cause use of its
   ``lightning.testing`` framework.

-  Anti-Bloat: Added override that that ``torch`` but only it can use
   ``unittest``, it will not work otherwise.

-  Anti-Bloat: Avoid using ``IPython`` in ``gradio`` package.

-  Anti-Bloat: Avoid using ``IPython`` in ``altair`` package.

-  Anti-Bloat: Avoid using ``numba`` in ``pyqtgraph`` package.

-  Anti-Bloat: Avoid using ``triton`` in ``torch`` package.

-  Anti-Bloat: Avoid using ``unittest`` in ``multiprocess`` package.

-  Anti-Bloat: Avoid using ``setuptools`` with new ``mmcv`` package as
   well.

-  Anti-Bloat: Avoid URLs in numpy messages.

-  Code Generation: Dedicated helper function for fixed imports, that
   uses less C code for standard imports.

-  Standalone: Avoid including ``libz`` on Linux.

-  Quality: Use latest ``isort`` and ``rstchk`` versions.

Organisational
==============

-  Python3.12: Mark as unsupported for now, it does not yet compile on
   the C level again.

-  User Manual: Added description of deployment mode, this was not
   documented so far, but for some programs, dealing with them is now
   required.

-  User Manual: Improved ``--include-plugin-directory`` documentation to
   make it more clear what it is usable for and what not.

-  UI: Reject standard library paths for plugin directories given to
   ``--include-plugin-directory`` which is a frequent user error.

-  UI: When interrupting during Scons build with CTRL-C do not give a
   Nuitka call stack, there is no point in that one, rather just exit
   with a message saying the user interrupted the scons build.

-  UI: Make package data output from ``--list-package-data`` more
   understandable.

   We already had a count for DLLs too, and should not list directory
   name in case it's empty and has no data files, otherwise this can
   confuse people.

-  UI: Make the progress bar react to terminal resizes. This avoids many
   of the distortions seen in Visual Code that seems to do it a lot.

-  UI: Added a mnemonic warning for macOS architecture cross
   compilation, that it will only work as well as Python does when
   limited to that arch. Read more on `the info page
   <https://nuitka.net/info/macos-cross-compile.html>`__ for detailed
   information. Added in 1.8.4 already.

-  UI: Error exit for wrong/non-existent input files first. Otherwise
   e.g. complaints about not including anything can be given where
   project options were intended to solve that.

-  UI: Enhanced error message in case of not included ``imageio``
   plugins. Added in 1.8.4 already.

-  UI: Enhanced messages from options nanny, showing the condition that
   was not passed.

-  UI: Improved download experience. When hitting CTRL-C during a
   download, delete the incomplete file immediately, otherwise it's
   causing an error next run. Also added progress for downloads as well,
   so they do not sit there silent without a way to know how much is
   remaining.

-  UI: Also report errors happening during plugin init nicely.

-  Visual Code: Added ignore paths code spell checking. This only adds
   the most obvious things, more to come later.

-  Visual Code: Use environment for C include path configurations, and
   add one for use on macOS, this cleaned up a lot of inconsistencies in
   paths for the various existing platforms.

-  Debugging: Added experimental switch to disable free lists, so memory
   corruption issues can become easier to debug.

-  UI: Output clang and gcc versions in ``--version`` output as well.

-  UI: Add hint how to disable the warning message that asks to disable
   the console during debugging by explicit ``--enable-console`` usage.

-  UI: Do not consider aliases of options for ambiguous option error.
   Without this ``--no-progressbar`` and ``--no-progress-bar`` being
   both accepted, forced long version of options for no good reason.

-  Debugging: With ``--debug`` output failed query command that a plugin
   made. In this way it is easier to check what is wrong about it for
   the user already.

-  UI: Check if metadata included has the actual distribution package
   included. Otherwise we error out, as this would result in a
   ``RuntimeError`` when the program is attempting to use it.

-  UI: Harmonized help text quoting. We will also need that in order to
   generate the help texts for Nuitka-Action in the future. Currently
   this is not perfect yet.

-  Debugging: Added trace that allows us to see how long ``Py_Exit``
   call takes, which might be a while in some cases.

-  User Manual: Made the Nuitka requirements top level chapter.

-  User Manual: Added promise to support newer Python versions as soon
   as possible.

-  User Manual: Added section about how Linux standalone is hard and
   needs special care.

-  Python3.11: Disallow to switch to g++ for too old gcc, with this
   Python version we have to use C11.

-  Quality: Remove inconsistencies with C python hex version literals in
   auto-format, which will also make searching code easier.

-  UI: More clear error message for asking package data of a module name
   that is not a package.

Cleanups
========

-  Dedicated node for fixed and built-in imports were added, which allow
   the general import node to be cleaner code.

-  Scons: Removed remaining ``win_target`` mode, this is long obsolete.

-  Spelling improvements by newer codespell, and generally, partially
   ported to 1.8.4 already so the Actions pass again.

-  Plugins: Move python code of ``dill-compat`` run time hook to
   separate file.

Tests
=====

-  Run the distutils tests on macOS as well, so it's made sure wheel
   creation is working there too, which it was though.

-  Avoid relative URLs in use during ``pyproject.toml`` tests, these
   fail to work on macOS at least.

-  Add GI GTK/GDK/Cairo standalone test for use with MSYS2. Eventually
   this should be run inside Nuitka-Watch against MSYS2 on a regular
   basis, but it doesn't support this Python flavor yet.

-  Added test case with Chinese module names and identifiers that
   exposed issues.

-  Completed the PGO test case and actually verify it does what we want.

-  Added standalone test for setuptools. Since our anti-bloat works
   makes it not compiled with most packages, when it is, make sure it
   doesn't expose Nuitka to some sort of issue by explicitly covering
   it.

-  Show tracebacks made in report creations on GitHub Actions and during
   RPM builds.

Summary
=======

This is again massive in terms of new features supported. The lazy
loader support is very important as it allows to handle more packages in
better ways than just including everything.

The new added optimization are nice, esp. startup time will make a huge
difference for many people, but mainly the focus was on supporting
packages properly, and getting Nuitka-Watch to be able to detect
breaking of packages from PyPI closer to when it happens.

And then of course, there is a tremendous amount of improvements for the
UI, with lots features become even more rounded.

For Python 3.12 work has begun, but there is more to do for it. At this
time it's not clear how long it takes to add it. Stay tuned.

********************
 Nuitka Release 1.8
********************

Bug Fixes
=========

-  Standalone: Added support for ``opentelemetry`` package. Added in
   1.7.1 already.

-  Reports: Fix, do not report plugin influence when there are not
   ``no-auto-follow`` in an anti-bloat section. Fixed in 1.7.2 already.

-  Anti-Bloat: Add missing usage tag ``use_pytest`` for anti-bloat
   changes that remove ``pytest`` related codes. Fixed in 1.7.2 already.

-  Standalone: Added support for newer ``jsonschema`` package. Fixed in
   1.7.2 already.

-  Standalone: Fix, our ``iterdir`` implementation was crashing in
   ``files`` for packages that don't actually have a directory for data
   files to live in. Fixed in 1.7.2 already.

-  Fix, parent package imports could pick the wrong name internally and
   then collide with sub-packages of that package during collision.
   Fixed in 1.7.3 already.

-  Standalone: Added support for ``pymssql`` package. Fixed in 1.7.3
   already.

-  Standalone: Added support for ``cvxpy`` package. Fixed in 1.7.4
   already.

-  Standalone: Added missing dependencies of ``lib2to3.refactor``. Fixed
   in 1.7.4 already.

-  Standalone: Fix, data files for ``lib2to3.pgen`` were regressed.
   Fixed in 1.7.4 already.

-  Standalone: Added missing dependency of ``cairo`` package. Fixed in
   1.7.4 already.

-  Standalone: Added support for new ``trio`` package. Fixed in 1.7.4
   already.

-  Standalone: Added support for ``markdown`` package. Fixed in 1.7.4
   already.

-  Standalone: Added support to ``eventlet`` package. Fixed in 1.7.4
   already.

-  Standalone: Added support for more newer ``sklearn`` package. Fixed
   in 1.7.5 already.

-  Standalone: Added support for more newer ``skimage`` package. Fixed
   in 1.7.5 already.

-  Standalone: Added support for more newer ``transformers`` package.
   Fixed in 1.7.5 already.

-  Standalone: Added support for ``torch_scatter`` package. Fixed in
   1.7.6 already.

-  Standalone: Added missing DLL for ``wx.html2`` to work well on
   Windows. Fixed in 1.7.6 already.

-  Fix, the ``@pyqtSlot`` decoration could crash the compilation and was
   effective even if no pyqt plugin was active. Fixed in 1.7.6 already.

-  Python3.11: Fix, need to support ``BaseExceptionGroup`` for code
   generation too, otherwise the ``exceptiongroup`` backport was not
   working. Fixed in 1.7.7 already.

-  MSYS2: Fix usage of deprecated ``sysconfig`` variable with mingw.
   After their switch to Python 3.11, it is no longer available. Fixed
   in 1.7.7 already.

-  Distutils: Do not compile empty directories found in package scan as
   namespaces. Fixed in 1.7.7 already.

-  Python3.7+: Fix, need to follow dict internal structure more
   correctly, otherwise we over-allocate and copy more data than
   necessary. Fixed in 1.7.7 already.

-  Python3.8: Fix, the new pyqt plugin workaround requires 3.9 or higher
   and could causes compile time crashes with the ``@pyqtSlot``
   decorator. Fixed in 1.7.7 already.

-  Modules: Fix, the ``.pyi`` file created was using default encoding
   which can vary and potentially even crash on other systems. Enforcing
   ``utf-8`` now. Fixed in 1.7.8 already.

-  Fix, only failed relative imports should become package relative.
   This was giving wrong names for attempts imports in these cases.
   Mostly only affected dependency caching correctness and reporting at
   this time. Fixed in 1.7.8 already.

-  Standalone: Added missing metadata dependencies for ``transformers``
   package. Fixed in 1.7.9 already, but more added for release.

-  Fix, need to ignore folders that cannot be module names in stdlib.
   Could e.g. crash when encountering folders like ``.idea`` which
   cannot be module names. Fixed in 1.7.9 already.

-  Standalone: Added data files for ``langchain`` package. Fixed in
   1.7.10 already.

-  Fix, forced output paths didn't work without C11 mode. This mainly
   affected older MSVC users, with newer MSVC and good enough Windows
   SDK, it's not using C++ anymore. Fixed in 1.7.10 already.

-  Fix, was using int values for boolean returns, something that was
   giving warnings with at least older MSVC not in C11 mode. Fixed in
   1.7.10 already.

-  Fix, failed hard name imports could crash with segfault trying to
   release their value. Fixed in 1.7.10 already.

-  Standalone: Added missing implicit dependency for ``xml.sax`` in
   stdlib. Fixed in 1.7.10 already.

-  Windows: Fix, ``--mingw64`` mode was not working if MSVC was
   installed, but not acceptable for use. Fixed in 1.7.10 already.

-  Standalone: Fix, ``onnxruntime`` had too few DLLs included. Fixed in
   1.7.10 already.

-  Standalone: Added support for ``moviepy``. Fixed in 1.7.10 already.

-  Python3.10+: Fix, matching empty sequences was not considering
   length, leading to incorrect code execution for that case.

   .. code:: python

      match x:
         case []:
               ... # non-empty sequences matched here

-  UI: Fix, some error outputs didn't work nicely with progress bars,
   need to use our own print function that temporarily disables them or
   else outputs get corrupted.

-  Linux: Sync output for data composer. This is to avoid race
   conditions that we might have been seeing occasionally.

-  Compatibility: Fix, the ``sys.flags.optimize`` value for
   ``--python-flag=-OO`` didn't match what Python does.

-  Standalone: Fix, packages have no ``__file__`` if imported from
   frozen, these was causing issues for some packages that scan all
   modules and expect those to be there.

-  Fix, the ``dict`` built-in could crash if its argument self-destructs
   during usage.

-  Fix, the ``PySide2/PySide6`` workaround for connecting compiled class
   methods without crashing were not handling its optional ``type``
   argument.

-  Enhanced non-commercial PySide2 support by adding yet another class
   to be hooked. This was ironically contributed by a commercial user.

-  Standalone: Added support for newer ``delvewheel`` version as used in
   newest ``scipy`` and probably more packages in the future.

-  Compatibility: The ``pkgutil.iter_modules`` function now works
   without importing the module first. The makes ``Faker`` work on
   Windows as well.

-  Reports: Detect top level packages even with broken packaging. Some
   packages will not reveal through installed files or top level what
   package they are for, and as a result, they cannot be uninstalled,
   but we need to still be able guess what package they are responsible
   for, so we go by their PyPI name, which works for ``tensorflow``.

-  Compatibility: More robust way of allowing iteration of compiled
   packages via file path.

   Rather than pre-populating the cache, we should provide the hook
   function to check if we are responsible for a given path. With this,
   the ``Faker`` package works on Windows as well now, and probably
   other packages benefit too. This then works on paths rather than
   strings, which due to short paths, etc. can be non-unique on Windows
   easily.

-  Standalone: Added support for the ``opencc`` package.

-  Compatibility: Fix, import name resolving done for things like
   ``six`` and others should be done as soon as possible, and not just
   during optimization, or else some imports can become just wrong as a
   result.

-  Python3.11: Added support for the new ``closure`` keyword only
   argument in ``exec`` built-in.

-  Standalone: Added support for ``pythonnet`` on Linux as well.

-  Debian: Fix, do not give false alarms for root pip installed
   packages, they get a similar path component, but are not actually
   Debian packages of course, this was mostly affecting builds inside
   containers of course.

-  Compatibility: Added support for comparing results from our resource
   reader file interfaces. This is needed for when people want to e.g.
   sort the the file list.

-  Python3.6+: Fix, didn't catch ``await`` on module level as a syntax
   error.

-  Compatibility: Added support for ``joblib`` with ``loky`` backend as
   well.

-  Standalone: Added support for newer ``chromadb`` adding missing
   dependencies and data files.

-  Python3.9+: Fix, ``importlib.resources.files()`` was not fully
   compatible

   Need to provide basename for ``.name`` attribute rather than an
   absolute path. And in some cases, a leading trailing slashes was
   produced for the full path, which caused trouble for file iteration
   of filenames.

-  Standalone: Added support for newer ``importlib_resources`` as well.
   We now need to expose the ``files`` functionality even before Python
   3.9 for this to be possible.

-  Standalone: Added support for newer ``rapidfuzz`` package.

-  Added support for newer ``PyOpenGL`` package.

New Features
============

-  Plugins: Added support to specify embedding of metadata for given
   packages via the package configuration. With this, entry points,
   version, etc. can even be resolved if not currently possible at
   compile time to so through the code with static optimization. Added
   in 1.7.1 already.

   .. code:: yaml

      - module-name: 'opentelemetry.propagate'
        data-files:
          include-metadata:
            - 'opentelemetry-api'

-  Distutils: Add PEP 660 editable install support. With this ``pdm``
   can be used for building wheels with Nuitka compilation. Added in
   1.7.8 already.

-  Haiku: Added support for accelerated mode, standalone will need more
   work, also recognize its form of the ``site-packages`` folder, named
   ``vendor-packages``.

-  Disable misleading initial import exception handling in ``numpy``,
   all what it says detracts only.

-  Added python flags given for ``no_asserts``, ``no_docstrings`` and
   ``no_annotations`` to the ``__compiled__`` attribute values of
   modules and functions to fully expose the information.

-  Watch: Added capability to specify what ``nuitka`` binary to use in
   ``nuitka-watch`` so we can use enhanced ``nuitka-watch`` from develop
   branch with older versions of Nuitka with no issues.

-  Watch: Now evaluates the minimum version needed for Nuitka, and skips
   test cases, allowing ``nuitka-watch`` to be run with versions that do
   not yet handle cases that e.g. develop already can, i.e. next Nuitka
   version.

-  Watch: Now evaluates if a compilation with Nuitka needs to be done at
   all, as it's only necessary if the PyPI config changed, or if Nuitka
   version changed.

-  Reports: Added source path for modules, so it's easier to tell where
   something came from, and esp. in case of bugs in the import location
   of Nuitka.

-  Reports: In case of a crash, always write report file for use in bug
   reporting. This is now done even if no report was asked for.

-  Reports: Include error exit message from Nuitka in case of explicit
   exits.

-  UI: Added new ``--deployment`` and ``--no-deployment-flag`` that
   disables certain debugging helpers.

   Right now, we use this to control a hook that prevents execution of
   itself with ``-c`` which is used by e.g. ``joblib`` and that
   potentially can turns Nuitka created programs into a fork bombs, when
   they use ``sys.executable -c ...``. This can be disabled with
   ``--no-deployment-flag=self-execution`` or ``--deployment``.

   The plan is to expand this to cover ``FileNotFoundError`` and similar
   exception exits pointing to compilation issues with helpful more
   annotations.

-  Catch attempts to exec compiled function bytecodes.

   This segfaults otherwise with at least Python3.11 and is probably a
   good idea to catch for all versions, as it doesn't do anything.

-  Windows: Remove unnecessary ``.\`` in CMD files generated, these will
   otherwise show up in ``sys.argv[0]`` too, making them more ugly than
   necessary.

-  Scons: Also respect ``CFLAGS`` setting. It's rarely used, but for
   completeness sake we should have that too. The effects are the same
   as ``CCFLAGS`` it seems.

Optimization
============

-  Added type shape for built-in hash operation, these must indeed be of
   ``int`` type either way.

-  Anti-Bloat: Avoid using ``unittest`` in ``future`` and
   ``multiprocessing`` package. Added in 1.7.3 already.

-  Anti-Bloat: Avoid using ``unittest`` in ``git`` package. Added in
   1.7.3 already.

-  Anti-Bloat: Avoid ``IPython`` in ``streamlit`` package.

-  Standalone: Make ``transformers`` work with ``no_docstrings`` mode.
   Added in 1.7.7 already.

-  Anti-Bloat: Avoid more ``IPython`` usage in ``transformers`` package.

-  Anti-Bloat: Avoid using ``pytest`` in ``polyfactory`` package.

-  Anti-Bloat: Expand the list of modules that are in the ``unittest``
   group by the ones Python provides itself, ``test.support``,
   ``test.test_support`` and ``future.moves.test.support``, so the
   culprits are more easily recognizable.

-  Anti-Bloat: Treat ``ipykernel`` and ``jupyter_client`` as equal to
   IPython for usage, so the bloat warning about IPython becomes more
   meaningful in that case too.

-  Anti-Bloat: Avoid using ``IPython`` in ``plumbum`` package.

-  Statically optimize the value of ``sys.byteorder`` as well.

-  Anti-Bloat: Added ``no-auto-follow`` for ``tornado`` in ``joblib``
   package. The user is informed of that happening if nothing else
   imports tornado in case he wants to enable it.

-  Standalone: Avoid including standard library ``zipapp`` or
   ``calendar`` automatically and remove their runners through
   ``anti-bloat`` configuration. This got rid of ``argparse`` for hello
   world compilation.

-  Standalone: Do not auto include standard library ``json.tool`` which
   is a binary only.

-  Standalone: Avoid automatic inclusion a ``_json`` extension module
   for the ``json`` module and do not automatically include it as part
   of stdlib anymore, this can reduce the size of standalone
   distributions.

-  Standalone: Avoid the standard library ``audioop`` extension module
   by making all audio related modules non-automatically included.

-  Standalone: Avoid the ``_contextvars`` standard library extension
   module. Explicit and implicit imports of ``contextvar`` module will
   continue to work and hopefully give proper errors until we do
   ourselves raise such errors.

-  Standalone: Avoid also the "_crypt" standard library extension
   module, and make the ``crypt`` module raise an error where we modify
   the message to not be as misleading.

-  Standalone: On macOS we also saw ``_bisect``, ``_opcode`` and more
   modules that are optional extension modules, that we no longer do
   automatically use if they are that way.

-  Standalone: Added more modules like ``mailbox``, ``grp``, etc. to
   exclusion from standard library when they trigger dependencies on
   other things, or are an extension themselves.

-  Anti-Bloat: Avoid using ``sqlalchmy.testing`` and therefore
   ``pytest`` in ``sqlalchemy`` package. Also added that testing package
   to be treated as using ``pytest``. Added in 1.7.10 already.

-  Anti-Bloat: Avoid IPython in ``distributed`` package. Added in 1.7.10
   already.

-  Anti-Bloat: Avoid ``dask`` usage in ``skimage``. Added in 1.7.10
   already.

-  Anti-Bloat: More changes needed for newer ``sympy`` to avoid
   ``IPython``. Added in 1.7.10 already.

-  Anti-Bloat: Enhanced handling of ``PIL.ImageQt`` even without the Qt
   binding plugins being active.

-  Anti-Bloat: Do not automatically follow ``matplotlib`` from ``scipy``
   as that is code that will only be used if other code using it exists
   too.

-  Anti-Bloat: Avoid ``pandas`` and ``matplotlib`` for ``sklearn``
   package. Availability checks of third party packages should be
   counted as real usage.

-  Anti-Bloat: Avoid ``IPython`` in newer ``keras`` module too.

-  Anti-Bloat: Updated for newer ``tensorflow`` package, also using more
   robust new form of ``no-auto-follow`` to achieve that.

-  Anti-Bloat: Avoid using Qt bindings for ``pandas.io.clipboard`` as
   it's only useful if one of our Qt plugins is active.

Organisational
==============

-  User Manual: Make it clear in the example that renaming created
   extension modules to change their name does not work, such that the
   user has to first rename the Python module properly.

-  macOS: Pronounce Homebrew as somewhat support but not recommended due
   to its limited results for portability.

-  UI: Added mnemonic for unsupported Windows store Python, so we have a
   place to give more information. Read more on `the info page
   <https://nuitka.net/info/unsupported-windows-app-store-python.html>`__
   for detailed information.

-  UI: Disable warning for ``numpy``/``scipy`` DLL non-identity
   conflicts. These are very common unfortunately and known to be
   harmless.

-  Stop creating PDFs for release. They are not really needed, but cause
   extra effort that makes no sense.

-  Quality: Updated to latest black which removes some leading new lines
   in blocks, changing a bunch of files. Bumped development requirements
   file Python version to 3.8, since black won't do 3.7 anymore.

-  Quality: Updated to latest PyLint, no changes from that.

-  Quality: Auto-format the markdown files used for GitHub templates as
   well.

-  Debugging: Catch errors during data composer phase cleaner. Added in
   1.7.1 already.

-  Plugins: More clear error messages for Yaml files checker. Added in
   1.7.5 already.

-  Release: Avoid DNS lookup by container, these sometimes failed.

-  UI: Catch user error of compiling in module mode with unknown file
   kinds, it needs to be Python code of course.

-  UI: In case of ``SyntaxError`` in main file, always suggest latest
   supported version. Previous it was toggling between Python2 and
   Python3, but that's no longer the main reason this happens.

-  UI: Fix typo in help output for ``--trademarks`` option. Added in
   1.7.8 already.

-  UI: Fix, need to enforce version information completeness only on
   Windows, other platforms can be more forgiving. Added in 1.7.8
   already.

-  Visual Code: Enable black formatter as default for Python.

-  UI: Disallow ``--follow-stdlib`` with ``--standalone`` mode. This is
   now the default, and just generally makes no sense anymore.

-  Plugins: Warn if Qt qml plugins are not included, but qml files are.
   This has been a trap for first time users for a while now, that now
   have a way of knowing that they need to enable that Qt plugin
   feature.

-  Plugins: Enhanced Qt binding plugins selection by the various qt
   plugins

   Now can also ask to not include specified plugins with
   ``--noinclude-qt-plugins`` and by now include ``sensible`` by
   default, with the ``--include-qt-plugins=qml`` line not replacing it,
   but rather extending it. That makes it easier to handle and catches a
   common trap, where users would only specify the missing plugin, but
   remove required plugins like ``platform`` making it stop to work.

-  Plugins: Allow plugins provide ``None`` for flags not just by return
   value length, but also an explicit value, so plugin code can make a
   difference in a consistent way.

-  UI: Lets have the ``options-nanny`` output the failed condition, so
   it's more clear what the issue is.

-  Quality: Unified spell checker markers to same form in all files
   through auto-format for more consistency.

-  Quality: Always avoid attempting to format executables, much like we
   already do for bytecode, otherwise some attempts on them can crash.

-  Windows: Only change directory to short path during execution of
   Scons, we are otherwise leaking it to ``--run`` execution in tests,
   giving their output comparison a harder time than necessary.

-  Scons: Use report paths for outputs of filenames in slow compilation
   messages as well.

-  WinPython: Adapted detection of this flavor to changes made in that
   project.

Cleanups
========

-  Major Cleanup, do not treat technical modules special anymore

   Previously the immediate demotion of standard library to bytecode is
   not really needed and prevented dependency analysis. We have had
   plenty issues with that ever since not all stdlib modules were
   automatic anymore, there was a risk of missing some of them, just
   because this analysis was not done.

   Moved the import detection code to a dedicated module cleaning up the
   size of the standalone mechanics, as it also is not exclusive to it.

   Adding "reasons" to modules, different from "decision reasons" why
   something was allowed to be included, these give the technical reason
   why something is added. This is needed for anti-bloat to be able to
   ignore stdlib being added only for being frozen.

   Now we are correctly annotating why an extension module was included,
   e.g. is it technical or not, that solves a TODO we had.

   Removes a lot of code duplication for reading source and bytecode of
   modules and the separate handling of uncompiled modules as a category
   in the module registry is no more necessary.

   The detection logic for technical modules itself was apparently not
   robust and had bugs to be fixed that became visible now, and that
   make it unclear how it ever worked as well.

-  Refactor towards unification of statement and expression.

   Make sure Make existing statement operations, i.e. use the function
   intended for them so they are immediately closer to what expressions
   do, and don't visit their own children themselves anymore.

   Remove checks for expression or statement, we won't use that anymore,
   and it's only costing performance until we merge them.

-  The caching (currently only used when demoting to bytecode), was not
   keeping track of distributions attempted to be used, but then being
   not found. That could have led to errors when using the cached
   result.

-  Again some more spelling fixes in code were identified and fixed.

-  Removed now unused user provided flag from uncompiled module nodes.

-  Removed 3.3 support from test runner as well.

-  Avoid potential slur word from one of the tests.

Tests
=====

-  Sometimes the pickle from cached CPython executions cannot be read
   due to protocol version differences, then of course it's also not
   usable.

-  Added CPython311 test suite, but it is not yet completely integrated.

-  Tests: Salvage one test for ``dateutil`` from a GSoC 2019 PR, we can
   use that.

Summary
=======

This is massive in terms of new features supported. The deployment mode
being added, provides us with a framework to make new user experience
with e.g. the missing data files, much more generous and help them by
pointing to the right solution.

The technical debt of immediate bytecode demotion being removed, is huge
for reliability of Nuitka. We now really only have to deal with actual
hidden dependencies in stdlib, and not just ones caused by us trying to
exclude parts of it and missing internal dependencies.

********************
 Nuitka Release 1.7
********************

There release is focused on adding plenty of new features in Nuitka,
with the new isolated mode for standalone being headliners, but there
are beginnings for including functions as not compiled, and really a lot
of new anti-bloat new features for improved handling, and improving user
interaction.

Also many packages were improved specifically to use less unnecessary
stuff, some of which are commonly used. For some things, e.g. avoiding
tkinter, this got also down to polishing modules that have GUI plugins
to avoid those if another GUI toolkit is used.

In terms of bug fixes, it's also a lot, and macOS got again a lot of
improvements that solve issues in our dependency detection. But also a
long standing corruption for code generation of cell variables of
contractions in loops has finally been solved.

Bug Fixes
=========

-  Python3.11: The MSVC compiler for Windows will not work before 14.3
   (Visual Studio 2022) if used in conjunction with Python 3.11, point
   it out to the user an ignore older versions. Fixed in 1.6.1 already.

-  Standalone: Added support for the ``pint`` package. Fixed in 1.6.1
   already.

-  Standalone: Added missing standard library dependency for
   ``statistics``. Fixed in 1.6.1 already.

-  Compatibility: Fix, the ``transformers`` auto models were copying
   invalid bytecode from compiled functions. Added workaround to use
   compiled function ``.clone()`` method. Fixed in 1.6.1 already.

-  Compatibility: Added workaround for ``scipy.optimize.cobyla``
   package. Fixed in 1.6.1 already.

-  Anaconda: Detect Anaconda package from ``conda install`` vs. PyPI
   package from ``pip install``, the specifics should only be applied to
   those. Adapted our configurations to make the difference. Fixed in
   1.6.1 already.

-  Anaconda: Do not search DLLs for newer ``shapely`` versions. Fixed in
   1.6.1 already.

-  Standalone: Add new implicit dependencies for ``pycrytodome.ECC``
   module. Fixed in 1.6.1 already.

-  Standalone: Fix ``tls_client`` for Linux by not non-Linux DLLs. Fixed
   in 1.6.1 already.

-  MacOS: When using ``--macos-app-name``, the executable name of a
   bundle could become wrong and prevent the launch of the program. Now
   uses the actual executable name. Fixed in 1.6.1 already.

-  Multidist: The docs didn't properly state the option name to use
   which is ``--main`` and also it didn't show up in help output. Fixed
   in 1.6.2 already.

-  Standalone: Added support for ``polars`` package. Fixed in 1.6.3
   already.

-  Standalone: Added implicit imports for ``apscheduler`` triggers.
   Fixed in 1.6.3 already.

-  Standalone: Add data files to AXML parser packages. Added in 1.6.4
   already.

-  Fix, ``exec`` nodes didn't annotate their exception exit. Fixed in
   1.6.4 already.

-  Standalone: Added data files for ``open_clip`` package. Fixed in
   1.6.4 already.

-  Standalone: Avoid data files warning with old ``pendulum`` package.
   Fixed in 1.6.4 already.

-  Standalone: Added implicit dependencies for ``faker`` module. Fixed
   in 1.6.4 already.

-  Added workaround for ``opentele`` exception raising trying to look at
   the exception frame before its raised. Fixed in 1.6.4 already.

-  Nuitka-Python: Do not check for unknown built-in modules. Fixed in
   1.6.4 already.

-  Scons: Fix, the total ``ccache`` file number given could be wrong.
   Ignored messages were counted still as compiled, leading to larger
   sum of files than actually there was. Fixed in 1.6.5 already.

-  Fix, multiprocessing resource tracker was not properly initialized.
   On at least macOS this was causing it to work relatively badly,
   because it could fail to actually use it. Fixed in 1.6.5 already.

-  Standalone: Added support for ``cassandra-driver`` package. Fixed in
   1.6.5 already.

-  Onefile: Have Python process suicide when bootstrap surprisingly
   died, respecting the provided grace time for shutdown. Fixed in 1.6.5
   already.

-  Plugins: Fix, package versions for at least Ubuntu packages can be
   broken, such that at least ``pkg_resources`` rejects them. Handle
   that and use fallback to next version detection method. Fixed in
   1.6.5 already.

-  Onefile: Handle ``SIGTERM`` and ``SIGQUIT`` just like ``SIGINT`` on
   non-Windows. The Python code with see ``KeyboardInterrupt`` for all 3
   signals, so it's easier to implement. Previously onefile would exit
   without cleanup being performed. Fixed in 1.6.5 already.

-  Standalone: Fix, need to add more implicit dependencies for
   ``pydantic`` because we do no longer include e.g. ``decimal`` and
   ``uuid`` automatically.

-  Standalone: Added missing implicit dependencies for ``fiona``
   package. Added in 1.6.6 already.

-  Standalone: Added missing implicit dependencies for ``rasterio``
   package. Added in 1.6.6 already.

-  Standalone: Fix, need to add more implicit dependencies for
   ``pydantic``. Added in 1.6.6 already.

-  Fix, the data composer used a signed value for encoding constant blob
   sizes, limiting it needlessly to half the size possible.

-  Windows: Avoid dependency on API not available on all versions,
   specifically Windows 7 didn't work anymore. With this, symlinks are
   only resolved where they actually exist, and MinGW64 does it too now.

-  Standalone: Added support for ``.location`` attribute for
   ``pkg_resources`` distribution objects.

-  Anti-Bloat: Avoid using ``dask`` and ``numba`` in the ``tsfresh``
   package.

-  Fix, outline cell variables must be re-initialized on entry. The code
   would be crashing for for outlines used in a loop, since the cleanup
   code for these cell variables would release the cell that was created
   during containing scope setup.

-  Standalone: Added missing dependency of ``pygeos`` package.

-  Standalone: Added ``sqlalchemy`` implicit dependency.

-  Standalone: Added data files for ``mnemonic`` package.

-  Fix, attribute checks could cause corruption when used on objects
   that raise exceptions during ``__getattr__``.

-  Python2: Fix, wasn't making sure instance attribute lookups were
   actually only done with ``str`` attributes.

-  macOS: Fix, need to allow versioned DLL dependency from un-versioned
   DLLs packaged.

-  Standalone: Added DLLs for ``rtree`` package.

-  Standalone: Added support for newer ``skimage`` package.

-  Standalone: Added support for newer ``matplotlib`` package.

-  Standalone: Fix, our ``numpy.testing`` replacement, was lacking a
   function ``assert_array_almost_equal`` used in at least the
   ``pytransform3d`` package.

New Features
============

-  Added support for ``--python-flag=isolated`` mode. In this mode,
   packages are not expandable via environment variable provided paths
   and ``sys.path`` is emptied which makes imports from the file system
   not work.

-  The options for forcing outputs were renamed to
   ``--force-stdout-spec`` and ``force-stderr-spec`` to force output to
   files and now work on non-Windows as well. They kind of were before,
   but e.g. ``%PROGRAM%`` was not implemented for all OSes yet.

-  Capturing of all outputs now extends beyond the Python level outputs
   is now attempting to capture C level outputs as well. These can be
   traces of Nuitka itself, but also messages from C libraries. On
   Windows, with MinGW64 this does not work, and it still only captures
   MinGW64, due to limitations of using different C run-times. With MSVC
   it works for the compiled program and C, but DLLs can have their own
   C runtime outputs that are still not caught.

-  Added new spec value ``%PROGRAM_BASE%`` which will avoid the suffix
   ``.exe`` or ``.bin`` of binaries that ``%PROGRAM%`` will still give.

-  Plugins: Added ability to query if a package in an Anaconda package
   or not, with the new ``is_conda_package()`` function in Nuitka
   package configuration. Added in 1.6.1 already.

-  Plugins: Provide control tags during plugin startup with new
   interface, such that these become globally visible.

-  Plugins: Allow to give ``--include-qt-plugins`` options of Qt binding
   plugins to be given multiple times. This is for consistency with
   other options. These now expand the list of plugins rather than
   replacing it.

-  Added experimental code to include functions decorated in certain
   ways to be included as bytecode. Prepare the inclusion as source code
   in a similar fashion. This was used to make example PyQt5 code work
   properly with timers where it doesn't normally work, but is still in
   development before it will be generally useful. For that it reacts to
   ``@pyqtSlot`` decorators.

-  Plugins: Make anti-bloat not warn when bloating modules include their
   group. This helps when e.g. ``distributed`` is going to use ``dask``,
   then we warn about ``distributed``, but not anymore, when that then
   uses ``dask``. And that intention to avoid ``dask`` is now in the
   warning given for ``distributed``.

-  Plugins: Added ability to decide module inclusion based on using
   module name and not only the used name. This will be super useful to
   make some imports not count per se for inclusion.

-  Plugins: Added new ``no-auto-follow`` Yaml configuration for
   ``anti-bloat``, that makes imports from one module not automatically
   included. That can make optional import removal much easier.

-  Plugins: Added new function for when clauses, such that it now can be
   tested if this Python version has a certain built-in name, e.g.
   ``when: 'not has_builtin_module("_socket")'`` will not apply
   configuration ``_socket`` is an extension module rather than
   built-in. This can be used to avoid unnecessary changes.

Optimization
============

-  Optimization: Better ``hasattr`` handling. Added ability for
   generated expression base class to monitor the attribute name for
   becoming constant and then calling a new abstract method due to
   ``auto_compute_handling`` saying ``wait_constant:name``.

-  Optimization: Added type shapes for ``setattr`` and ``hasattr``
   built-ins as well as the attribute check node for better code
   generation.

-  Optimization: Added dedicated nodes for ``importlib.resources.files``
   to allow including the used package automatically.

-  Standalone: Include only platform DLLs for ``tls_client`` rather than
   all DLLs for all platforms. Added in 1.6.1 already.

-  Anti-Bloat: Avoid including ``sympy.testing`` for ``sympy`` package.
   Added in 1.6.3 already.

-  Anti-Bloat: Avoid ``IPython`` in ``transformers`` package. Added in
   1.6.3 already.

-  Anti-Bloat: Avoid ``transformers.testing_util`` inclusion for
   ``transformers`` package as it will trigger ``pytest`` inclusion.

-  Anti-Bloat: Added missing method to our ``numpy.testing`` stub, so it
   can be used with more packages. Added in 1.6.4 already.

-  Anti-Bloat: Avoid ``numba`` usage from parts of ``pandas``. Added in
   1.6.4 already.

-  Anti-Bloat: Avoid ``pytest`` usage in ``patsy`` more completely.
   Added in 1.6.4 already.

-  Standalone: Added data files needed for ``pycountry`` package. Added
   in 1.6.4 already.

-  Anti-Bloat: Avoid ``unittest`` usage in ``numpy`` package. Added in
   1.6.4 already.

-  Anti-Bloat: Avoid using ``pytest`` in ``statsmodels`` package. Added
   in 1.6.4 already.

-  Anti-Bloat: Avoid including ``PIL.ImageQt`` when ``no-qt`` plugin is
   used. Added in 1.6.4 already.

-  Anti-Bloat: Avoid ``IPython`` usage in ``dask``. We do not cover
   bloat with ``dask`` allowed well yet, more like this should be added.
   Added in 1.6.5 already.

-  Anti-Bloat: Avoid ``dask`` via ``distributed`` in ``fsspec`` package.
   Added in 1.6.5 already.

-  Anti-Bloat: Avoid ``IPython`` in ``patsy`` package. Added in 1.6.5
   already.

-  Anti-Bloat: Avoid ``setuptools`` in newer ``torch`` as well. Added in
   1.6.5 already.

-  Anti-Bloat: Avoid ``tkinter`` inclusion in ``PIL`` and ``matplotlib``
   if another GUI plugin is active. This is using the control tags made
   available by GUI plugins.

-  Anti-Bloat: Avoid warning for ``from unittest import mock`` imports.
   These are common, and not considered actual usage of ``unittest``
   anymore.

-  Anti-Bloat: Avoid ``pandas`` usage in ``tqdm``. This uses the new
   ``no-auto-follow`` feature that will enable the optional integration
   of ``tqdm`` if pandas is included by other means only.

-  Anti-Bloat: Better method of avoiding ``socket`` in ``email.utils``.
   With changing the source code to delay the import of ``socket`` to
   the only function using it. Socket is now included only if used
   elsewhere. These changes however, are only done if ``_socket`` if is
   not a built-in module, because only then they really matters. And
   using a simple ``--include-module=socket`` will restore this. This
   approach is more robust and less invasive.

Organisational
==============

-  Added ``run-inside-nuitka-container`` for use in CI scripts. With
   this, dependencies of package building and testing from correct
   system installation should go away.

-  Release: Add CI container for use with
   ``run-inside-nuitka-container`` to make Debian package releases. This
   provides a more stable and flexible environment rather than building
   through ansible maintained environments, since different branches can
   more easily use different versions, or new features for the container
   handling.

-  Release: Use upload tokens rather than PyPI password in uploads, and
   secure the account with 2FA.

-  UI: Avoid duplicate warnings for ``anti-bloat`` detected imports. In
   case of ``from unittest import mock`` there were 2 warnings given,
   for ``unittest`` and ``unittest.mock`` but that is superfluous.

-  macOS: More beginner friendly version of Apple Python standalone
   error. They won't know why it is, and where to get a working Python
   version, so we explain more and added a download link.

-  Scons: Consider only 5 minutes slow for a module compilation in
   backend. Many machines are busy or slow by nature, so don't warn that
   much.

-  GitHub: Actions no longer work (easily) with Python2, so we removed
   those and need to test it elsewhere.

-  UI: Output the filename of the XML node dump from ``--xml`` as well.

-  UI: Make ``--edit-module-code`` work with onefile outputs as well.

-  Debugging: Allow yaml condition traceback to go through in
   ``--debug`` mode, so exception causes are visible.

-  Plugins: Make more clear what is the forbidden module user, such that
   it is possible to debug it.

-  UI: Inform user about slow linking, and ``--lto=no`` choice in case
   ``auto`` was used. This should make this option more obvious for new
   users that somehow victim of not defaulting to ``no``, but still
   having a slow link.

-  Debugging: Include PDBs for DLLs in unstripped mode already.
   Previously this was only done for debug mode, but that's a bit high
   of a requirement, and we sometimes need to debug where things do not
   happen in debug mode.

-  User Manual: Added typical problem with ``python -m compiled_module``
   execution not working and why that is so.

-  Debian: Do not include PDF files in packages. These are probably not
   used that much, but they cause issues at times, that are likely not
   worth the effort.

Cleanups
========

-  Moved OS error reporting as done in onefile binary to common code for
   easier reuse in plugins.

-  Moved helper codes for expanding paths and for getting the path to
   the running executable to file path common code for clearer code
   structure.

-  Removed ``x-bits`` from files that do not need them. For ``__main__``
   files, they are not needed, and for some files they were outright
   wrong.

-  Python3.12: Avoid usage of ``distutils.utils`` which were using to
   disable bytecode compilation for things we expect to not work.

-  Solve TODO and use more modern git command ``git branch
   --show-current`` to detect branch, our CI will have this for sure.

-  In our Yaml configuration prefer the GUI toolkit control tags, e.g.
   ``use_pyside6`` over the ``plugin("pyside6")`` method.

Tests
=====

-  Release: Use CI container for linter checks, so different branches
   can use different versions with less pain involved.

-  macOS: Allow all system library frameworks to be used, not just a few
   selected ones, there is many of them and they should all exist on
   every system. Added in 1.6.1 already.

-  Made the ``pendulum`` test actually useful to cover new and old
   pendulum actually working properly.

Summary
=======

This release really polished ``anti-bloat`` to the point where we now
have all the tools needed. Also ``torch`` in newest version is now
working nicely again with it, and a few rough edges of what we did with
1.6 for not including extension modules were removed. This polishing
will go on, but has reached really high levels. More and more people are
capable of helping with PRs here.

The optimization work outside of ``anti-bloat`` was really minor, with
only the two attribute built-in nodes being worked on, and only
``hasattr`` seeing real improvements. However, this was more of a
structural thing. The ``wait_constant`` technique will not get applied
more often, but it also will need a ``wait_all_constant`` companion,
before we can expect scalability improvements.

Restoring Windows 7 is important to many people deploying to old
systems, and the like.

However, in the coming release, we need to attack loop tracing. The only
bugs currently remaining are related to wrong tracing of items, and it
also is a limitation for hard imports to work. So scalability from doing
more of the ``wait_constant`` work, and from more clever loop tracing
shall be the focus of the 1.8 release.

********************
 Nuitka Release 1.6
********************

This release bumps the much awaited 3.11 support to full level. This
means Nuitka is now expected to behave identical to CPython3.11 for the
largest part.

There is plenty of new features in Nuitka, e.g. a new testing approach
with reproducible compilation reports, support for including the
metadata if an distribution, and more.

In terms of bug fixes, it's also huge, and esp. macOS got a lot of
improvements that solve issues with prominent packages in our dependency
detection. And then for PySide we found a corruption issue, that got
workarounds.

Bug Fixes
=========

-  The new dict ``in`` optimization was compile time crashing on code
   where the dictionary shaped value checked for a key was actually an
   conditional expression

   .. code:: python

      # Was crashing
      "value" in some_dict if condition else other_dict

   Fixed in 1.5.1 already.

-  Standalone: Added support for ``openvino``. This also required to
   make sure to keep used DLLs and their dependencies in the same
   folder. Before they were put on the top level. Fixed in 1.5.1
   already.

-  Android: Convert ``RPATH`` to ``RUNPATH`` such that standalone
   binaries need no ``LD_LIBRARY_PATH`` guidance anymore. Fixed in 1.5.1
   already.

-  Standalone: Added support for newer ``skimage``. Fixed in 1.5.1
   already.

-  Standalone: Fix, new data file type ``.json`` needed to be added to
   the list of extensions used for the Qt plugin bindings. Fixed in
   1.5.2 already.

-  Standalone: Fix, the ``nuitka_types_patch`` module using during
   startup was released, which can have bad effects. Fixed in 1.5.2
   already.

-  Android: More reliable detection of the Android based Python Flavor.
   Fixed in 1.5.2 already.

-  Standalone: Added data files for ``pytorch_lightning`` and
   ``lightning_fabric`` packages. Added in 1.5.2 already.

-  Windows: Fix, the preservation of ``PATH`` didn't work on systems
   where this could lead to encoding issues due to reading a MBCS value
   and writing it as a unicode string. We now read and write the
   environment value as ``unicode`` both. Fixed in 1.5.3 already.

-  Plugins: Fix, the scons report values were not available in case of
   removed ``--remove-output`` deleting it before use. It is now read in
   case if will be used. Fixed in 1.5.3 already.

-  Python3.11: Added support for ``ExceptionGroup`` built-in type. Fixed
   in 1.5.4 already.

-  Anaconda: Fix, using ``numpy`` in a virtualenv and not from conda
   package was crashing. Fixed in 1.5.4 already.

-  Standalone: Added support for ``setuptools``. Due to the anti-bloat
   work, we didn't notice that if that was not sufficiently usable, the
   compiled result was not usable. Fixed in 1.5.4 already.

-  Distutils: Added support for pyproject with ``src`` folders. This
   supports now ``tool.setuptools.packages.find`` with a ``where`` value
   with pyproject files, where it typically is used like this:

   .. code:: toml

      [tool.setuptools.packages.find]
      where = ["src"]

-  Windows: Fix, the ``nuitka-run`` batch file was not working. Fixed in
   1.5.4 already.

-  Standalone: Add ``pymoo`` implicit dependencies. Fixed in 1.5.5
   already.

-  macOS: Avoid deprecated API, this should fix newer Xcode being used.
   Fixed in 1.5.5 already.

-  Fix, the ``multiprocessing`` in spawn mode didn't handle relative
   paths that become invalid after process start. Fixed in 1.5.5
   already.

-  Fix, spec ``%CACHE_DIR%`` was not given the correct folder on
   non-Windows. Fixed in 1.5.5 already.

-  Fix, special float values like ``nan`` and ``inf`` didn't properly
   generate code for C values. Fixed in 1.5.5 already.

-  Standalone: Add missing DLL for ``onnxruntime`` on Linux too. Fixed
   in 1.5.5 already.

-  UI: Fix, illegal python flags value could enable ``site`` mode. by
   mistake and were not caught. Fixed in 1.5.6 already.

-  Windows: Fix, user names with spaces failed with MinGW64 during
   linking. Fixed in 1.5.6 already.

-  Linux: Fix, was not excluding all libraries from glibc, which could
   cause crashes on newer systems. Fixed in 1.5.6 already.

-  Windows: Fix, could still pickup SxS libraries distributed by other
   software when found in PATH. Fixed in 1.5.6 already.

-  Windows: Fix, do not use cache DLL dependencies if one the files
   listed there went missing. Fixed in 1.5.6 already.

-  Onefile: Reject path spec that points to a system folder. We do not
   want to delete those when cleaning up clearly. Added in 1.5.6
   already.

-  Plugins: Fix, the ``dill-compat`` was broken by code object changes.
   Fixed in 1.5.6 already.

-  Standalone: Added workaround for ``networkx`` decorator issues. Fixed
   in 1.5.7 already.

-  Standalone: Added workaround for PySide6 problem with disconnecting
   signals from methods. Fixed in 1.5.7 already.

-  Standalone: Added workaround for PySide2 problem with disconnecting
   signals.

-  Fix, need to make sure the yaml package is located absolutely or else
   case insensitive file systems can confuse things. Fixed in 1.5.7
   already.

-  Standalone: Fix, extra scan paths were not considered in caching of
   module imports, breaking the feature in many cases. Fixed in 1.5.7
   already.

-  Windows: Fix, avoid system installed ``appdirs`` package as it is
   frequently broken. Fixed in 1.5.7 already.

-  Standalone: The bytecode cache check needs to handle re-checking
   relative imports found in the cache better. Otherwise some standard
   library modules were always recompiled due to apparent import
   changes. Fixed in 1.5.7 already.

-  Nuitka-Python: Fix, do not insist on ``PYTHONHOME`` making it to
   ``os.environ`` in order to delete it again. Fixed in 1.5.7 already.

-  Nuitka-Python: Allow builtin modules of all names. This is of course
   what it does. Fixed in 1.5.7 already.

-  Nuitka-Python: Ignore empty extension module suffix. Was confusing
   Nuitka to consider every file an extension module potentially. Fixed
   in 1.5.7 already.

-  Plugins: Properly merge code coming from distinct plugins. The
   ``__future__`` imports need to be moved to the start. Added in 1.5.7
   already.

-  Standalone: Added support for ``opentele`` package. Fixed in 1.5.7
   already.

-  Standalone: Added support for newer ``pandas`` and ``pyarrow`` usage.
   Fixed in 1.5.7 already.

-  Standalone: Added missing implicit dependency for PySide6. Fixed in
   1.5.7 already.

-  Fix, the pyi-file parser didn't handle doc strings, and could be
   crash for comment contents not conforming to be import statement
   code. Fixed in 1.5.8 already.

-  Standalone: Added support for ``pyqtlet2`` data files.

-  Python2: Fix, ``PermissionError`` doesn't exist on that version,
   which could lead to issues with retries for locked files e.g. but was
   also observed with symlinks.

-  Plugins: Recognize the error given by with ``upx`` if a file is
   already compressed.

-  Fix, so called "fixed" imports were not properly tracking their use,
   such that they then didn't show up in reports, and didn't cause
   dependencies on the module, which could e.g. impact ``importlib`` to
   not be included even if still being used.

-  Windows: Fix, retries for payload attachment were crashing when
   maximum number of retries were reached. Using the common code for
   retries solves that, since that code handles it just fine.

-  Standalone: Added support for the ``av`` module.

-  Distutils: Fix, should build from files in ``build`` folder rather
   than ``source`` files. This allows tools like ``versioneer`` that
   integrate with setuptools to do their thing, and get the result of
   that to compilation rather than the original source files.

-  Standalone: Added support for the ``Equation`` module.

-  Windows/macOS: Avoid problems with case insensitive file systems. The
   ``nuitka.Constants`` module and ``nuitka.constants`` package could
   collide, so we now avoid that package, there was only what is now
   ``nuitka.Serialization`` in there anyway. Also similar problem with
   ``nuitka.utils.Json`` and ``json`` standard library module.

-  Standalone: Added support ``transformers`` package.

-  Standalone: Fix for ``PyQt5`` which needs a directory to exist.

-  macOS: Fix, was crashing with PyQt6 in standalone mode when trying to
   register plugins to non-default path. We now try to skip the need,
   which also makes it work.

-  Fix, recursion error for complex code that doesn't happen in ``ast``
   module, but during conversion of the node tree it gives to our own
   tree, were not handled, and crashed with ``RecursionError``. This is
   now also handled, just like the error from ``ast``.

-  Standalone: Added support for ``sqlfluff``.

-  Standalone: Added support for PySide 6.5 on macOS solving DLL
   dependency issues.

-  Scons: Recognize more ``ccache`` outputs properly, their logging
   changed and provided irrelevant states, and ones not associated so
   far.

-  Onefile: Fix, could do random exit codes when failing to fork for
   whatever reason.

-  Standalone: Added support for ``pysnmp`` package.

-  Standalone: Added support for ``torchaudio`` and ``tensorflow`` on
   macOS. These contain broken DLL dependencies as relative paths, that
   are apparently ignored by macOS, so we do that too now.

-  Onefile: Use actual rather than guessed standalone binary name for
   ``multiprocessing`` spawns. Without this, a renamed onefile binary,
   didn't work.

-  Fix, side effect nodes, that are typically created when an expression
   raises, were use in optimization contexts, where they do not work.

-  Standalone: Added missing implicit dependency for
   ``sentence_transformers`` package.

-  macOS: Fix, added missing dependency for ``platform`` module.

New Features
============

-  Support for Python 3.11 is finally there. This took very long,
   because there were way more core changes than with previous releases.
   Nuitka integrates close to that core, and is as such very affected by
   this. Also a lot of missed opportunities to improve 3.7 or higher,
   3.9 or higher, and 3.10 or higher were implemented right away, as
   they were discovered on the way. Those had core changes not yet taken
   advantage of and as a result got faster with Nuitka too.

-  Reports: Added option ``--report-diffable`` to make the XML report
   created with ``--report`` become usable for comparison across
   different machine installations, users compiling, etc. so it can be
   used to compare versions of Nuitka and versions of packages being
   compiled for changes. Also avoid short names in reports, and resolve
   them back to long names, so they become more portable too.

-  Reports: Added option to provide custom data from the user. We use it
   in out testing to record the pipenv state used with things like
   ``--report-user-provided=pipenv-lock-hash=64a5e4`` with this data
   ending up inside of reports, where tools like the new testing tool
   ``nuitka-watch`` can use it to decide if upstream packages changed or
   not. These are free form, just needs to fit XML rules.

-  Plugins: Added ``include-pyi-file`` flag to data-files section. If
   provided, the ``.pyi`` file belonging to a specific module is
   included. Some packages, e.g. ``skimage`` depend at runtime on them.
   For data file options and configuration, these files are excluded,
   but this is now the way to force their inclusion. Added in 1.5.1
   already.

-  Compatibility: Added support for including distribution metadata with
   new option ``--include-distribution-metadata``.

   This allows generic walks over distributions and their entry points
   to succeed, as well as version checks with the metadata packages that
   are not compile time optimized.

-  Distutils: Handle extension modules in build tasks. Also recognize if
   we built it ourselves, in which case we remove it for rebuild. Added
   in 1.5.7 already.

-  Linux: Detect DLL like filenames that are Python extension modules,
   and ignore them when listing DLLs of a package with
   ``--list-package-dlls`` option. So far, this was a manual task to
   figure out actual DLLs. This will of course improve the Yaml package
   configuration tooling .

-  Onefile: Allow forcing to use no compression for the onefile payload,
   useful for debugging, to avoid long compression times and for test
   coverage of the rare case of not compressing if the bootstrap handles
   that correctly too.

-  Need to resolve symlinks that were used to call the application
   binary in some places on macOS at least. We therefore implemented the
   previously experimental and Windows only feature for all platforms.

-  Standalone: Added support including symlinks on non-Windows in
   standalone distribution, if they still point to a path that is inside
   the distribution. This can save a bunch of disk space used for some
   packages that e.g. distribute DLL links on Linux.

-  Onefile: Added support for including symlinks from the standalone
   distribution as such on non-Windows. Previously they were resolved to
   complete copies.

-  UI: Respect code suffixes in package data patterns. With this e.g.
   ``--include-package-data=package_name:*.py`` is doing what you say,
   even if of course, that might not be working.

-  UI: Added option ``--edit-module-code`` option.

   To avoid manually locating code to open it in Visual Code replaced
   old ``find-module`` helper to be a main Nuitka option, where it is
   more accessible. This also goes beyond it it, such that it resolves
   standalone file paths to module names to make debugging easier, and
   that it opens the file right away.

-  Standalone: Added support for handling missing DLLs. Needed for macOS
   PySide6.5.0 from PyPI, which contains DLL references that are broken.
   With this feature, we can exclude DLLs that wouldn't work anyway.

Optimization
============

-  Anti-Bloat: Remove ``IPython`` usage in ``huggingface_hub`` package
   versions. Added in 1.5.2 already.

-  Anti-Bloat: Avoid ``IPython`` usage in ``tokenizers`` module. Added
   in 1.5.4 already.

-  Added support for module type as a constant value. We want to add all
   types we have shapes for to allow better ``type(x)`` optimization.
   This is only the start.

-  Onefile: During payload unpacking the memory mapped data was copied
   to an input buffer. Removing that avoids memory copying and reduces
   usage.

-  Onefile: Avoid repeated directory creations. Without it, the
   bootstrap was creating already existing directories up to the root
   over and over, making many unnecessary file system checks. Added in
   1.5.5 already.

-  Anti-Bloat: Remove usage of ``IPython`` in ``trio`` package. Added in
   1.5.6 already.

-  Onefile: Use resource for payload on Win32 rather than overlay. This
   integrates better with signatures, removing the need to check for
   original file size. Changed in 1.5.6 already.

-  Onefile: Avoid using zstd input buffer, but using the memory mapped
   contents directly avoiding to copy uncompressed payload data. Changed
   in 1.5.6 already.

-  Onefile: Avoid double slashes in expanded onefile temp spec paths,
   they are just ugly.

-  Anti-Bloat: Remove usage of ``pytest`` and ``IPython`` for some
   packages used by newer ``torch``. Added in 1.5.7 already.

-  Anti-Bloat: Avoid ``triton`` to use setuptools. Added in 1.5.7
   already.

-  Anti-Bloat: Avoid ``pytest`` in newer ``networkx`` package. Added in
   1.5.7 already.

-  Prepare optimization for more built-in types with experimental code,
   but we need to disable it for now as it requires more completeness in
   code generation to cover them all. We did some, e.g. module type, but
   many more will be missing still.

-  Prepare optimization of class selection at compile time, by having a
   helper function rather than a dedicated node. This work is not
   complete though, and cannot be activated yet.

-  Windows: Cache short path name resolutions. Esp. for reporting, we
   now do a lot more of these than before, and this avoids they can
   become too time consuming.

-  Faster constant value handling for float value checks by avoiding
   module lookups per value.

-  Minimize size for hello world distribution such that no unused
   extension modules are included, by excluding even more modules and
   using modules from automatic inclusion of standard library.

-  Anti-Bloat: Catch ``pytest`` namespaces ``py`` and ``_pytest``
   sooner, to point to the actual uses more directly.

-  Anti-Bloat: Usage of ``doctest`` equals usage of "unittest" so cover
   it too, to point to the actual uses more directly.

-  Ever more spelling fixes in code and tests were identified and fixed.

-  Make sure side effect nodes indicate properly that they are raising,
   allowing exceptions to fully bubble up. This should lead to more dead
   code being recognized as such.

Organisational
==============

-  GitHub: Added marketplace action designed to cross platform build
   with Nuitka on GitHub directly. Usable with both standard and
   commercial Nuitka versions, and pronouncing it as officially
   supported.

   Check out out at `Nuitka-Action
   <https://github.com/Nuitka/Nuitka-Action>`__ repository.

-  Windows: When MSVC doesn't have WindowsSDK, just don't use it, and
   proceed, to e.g. allow fallback to winlibs gcc.

-  User Manual: The code to update benchmark numbers as giving was
   actually wrong. Fixed in 1.5.1 already.

-  UI: Make it clear that partially supported versions are considered
   experimental, not unsupported. Fixed in 1.5.2 already.

-  Plugins: Do not list deprecated plugins with ``plugin-list``, they do
   not have any effect, but listing them, makes people use them still.
   Fixed in 1.5.4 already.

-  Plugins: Make sure all plugins have descriptions. Some didn't have
   any yet, and sometimes the wording was improved. Fixed in 1.5.4
   already.

-  UI: Accept ``y`` as a shortcut for ``yes`` in prompts. Added in 1.5.5
   already.

-  Reports: Make sure the DLL dependencies for Linux are in a stable
   order. Added in 1.5.6 already.

-  Plugins: Check for latest fixes in PySide6. Added in 1.5.6 already.

-  Windows XP: For Python3.4 make using Python2 scons work again, we
   cannot have 3.5 or higher there. Added in 1.5.6 already.

-  Quality: Updated to latest PyLint. With Python 3.11 the older one,
   was not really working, and it was about time. Due to its many
   changes, we included it in the hotfix, so those can still be done.
   Changed in 1.5.7 already.

-  Release: Avoid broken ``requires.txt`` in source distribution. This
   apparently breaks poetry. Changed in 1.5.7 already.

-  GitHub: Enhanced issue template for more clarity, esp. to avoid
   unnecessary options, e.g. using ``--onefile`` for issues that show up
   with ``--standalone`` already, to report factory branch issues rather
   on Discord, and give a quick tip for a likely reproducer if a package
   fails to import.

-  User Manual: Added instructions on how to add a DLL or executable to
   a standalone distribution.

-  User Manual: Example paths in the table for path specs, meant for
   Windows were not properly escaping the backslashes and therefore
   rendered incorrectly.

-  Visual Code: Python3.11 is now the default configuration for C code
   editing.

-  Developer Manual: Updated descriptions for adding test suite. While
   added the Python 3.11 test suite, these instructions were further
   improved.

-  Debugging: Make it easier to fully deactivate free lists. Now only
   need to set max size to 0 and the free list will not be used.

-  Debugging: Added more assertions, added corrections to feature
   disables, check args after function calls for validity, check more
   types to be as expected.

-  Plugins: Enhanced plugin error messages generally, with ``--debug``
   exceptions become warning messages with the original exception being
   raised instead, making debugging during development much easier.

-  UI: Make it clear what not using ``ccache`` actually means. Not
   everybody is familiar with the design of Nuitka there or what the
   tool can actually do.

-  UI: Do not warn about not found distributions but merely inform of
   them.

   Since Nuitka is fully compatible with these, no need to consider
   those a warning, for some packages they also are given really a lot.

-  UI: Catch user error of wrong cases plugin names

   This now points out the proper name rather than denying the existence
   outright. We do not want to accept wrong case names silently.

Cleanups
========

-  Use proper API for setting ``PyConfig`` values during interpreter
   initialization. There is otherwise always the risk of crashes, should
   these values change during runtime. Fixed in 1.5.2 already.

-  For our reformulations have a helper function that build release
   statements for multiple variables at once. This removed a bunch of
   repetitve code from re-formulations.

-  Move the pyi-file parser code out of the module nodes and to source
   handling, where it is more closely related.

Tests
=====

-  Adding a ``nuitka-watch`` tool, which is still experimental and for
   use with the `Nuitka-Watch
   <https://github.com/Nuitka/Nuitka-Watch>`__ repository.

-  Refined macOS standalone exceptions further to cover more normal
   usages of files on that OS and for frameworks that applications
   typically use from the system.

-  Detect and consider onefile mode if given in project options as well.

-  Was not really applying import check in programs tests. Added in
   1.5.6 already.

-  Added coverage of testing the signing of Windows binaries with the
   commercial plugin.

-  Added coverage of version information to hello world onefile test, so
   we can use it for Virus tools checks.

-  Added tests to cover PyQt6 and PySide6 plugin availability, we so far
   only had that for PyQt5, which is of course not relevant, and totally
   different code anyway.

-  Cleanup distutils tests case to use common test case scanning. We now
   decide version skips based on names, and had to get away from number
   suffixes, so they are now in the middle.

Summary
=======

The class bodies optimization has made some progress in this release,
going to a re-formulation of the metaclass selection, so as to allow its
future optimization. We are not yet at "compiled objects", but this is a
promising road. We need to make some optimization improvements for
inlining constant value calls, then this can become really important,
but by itself these changes do not yield a lot of improvement.

For macOS again a bunch of time was spent to improve and complete the
detection of DLL dependencies. More corner cases are covered now and
more packages just work fine as a result.

The most important is to become Python3.11 compatible, even if attribute
lookups, and other things, and not yet optimized. We will get to that in
future releases. For now, compatibility is the first step to take.

For GitHub users, the Nuitka-Action will be interesting. But it's still
in develop. We keep adding missing options of Nuitka for a while it
seems, but for most people it should be usable already.

The new ``nuitka-watch`` ability, should allow us to detect breaking
PyPI releases, that need a new tweak in Nuitka sooner. But it will
probably grow in the coming releases to full value only. For now the
tool itself is not yet finished.

From here, a few open ends in the CPython 3.11 test suite will have to
be addressed, and maybe some of the performance tricks that it now will
enable, e.g. with repeated attribute lookups.

********************
 Nuitka Release 1.5
********************

This release contains the long awaited 3.11 support, even if only on an
experimental level. This means where 3.10 code is used, it is expected
to work equally well, but the Python 3.11 specific new features have yet
been done.

There is plenty of new features in Nuitka, e.g. much enhanced reports,
Windows ARM native compilation support, and the usual slew of anti-bloat
updates, and newly supported packages.

Bug Fixes
=========

-  Standalone: Added implicit dependencies for ``charset_normalizer``
   package. Fixed in 1.4.1 already.

-  Standalone: Added platform DLLs for ``sounddevice`` package. Fixed in
   1.4.1 already.

-  Plugins: The info from Qt bindings about other Qt bindings being
   suppressed for import, was spawning multiple lines, breaking tests.
   Merged to a single line until we do text wrap for info messages as
   well. Fixed in 1.4.1 already.

-  Plugins: Fix ``removeDllDependencies`` was broken and could not
   longer be used to remove DLLs from inclusion. Fixed in 1.4.1 already.

-  Fix, assigning methods of lists and calling them that way could crash
   at runtime. The same was true of dict methods, but had never been
   observed. Fixed in 1.4.2 already.

-  Standalone: Added DLL dependencies for ``onnxruntime``. Fixed in
   1.4.2 already.

-  Standalone: Added implicit dependencies for ``textual`` package.
   Fixed in 1.4.2 already.

-  Fix, boolean tests of lists could be optimized to wrong result when
   list methods got recognized, due to not annotating the escape during
   that pass properly. Fixed in 1.4.3 already.

-  Standalone: Added missing implicit dependency of ``apsw``. Fixed in
   1.4.3 already.

   .. note::

      Currently ``apsw`` only works with manual workarounds and only in
      limited ways, there is an import level incompatible with
      ``__init__`` being an extension module, that Nuitka does not yet
      handle.

-  Python3: Fix, for range arguments that fail to divide there
   difference, the code would have crashed. Fixed in 1.4.3 already.

-  Standalone: Fix, added support for newer ``pkg_resources`` with
   another vendored package. Fixed in 1.4.4 already.

-  Standalone: Fix, added support for newer ``shapely`` 2.0 versions.
   Fixed in 1.4.4 already.

-  Plugins: Fix, some yaml package configurations with DLLs by code
   didn't work anymore, notably old ``shapely`` 1.7.x versions were
   affected. Fixed in 1.4.4 already.

-  Fix, for onefile final result the "--output-dir" option was ignored.
   Fixed in 1.4.4 already.

-  Standalone: Added ``mozilla-ca`` package data file. Fixed in 1.4.4
   already.

-  Standalone: Fix, added missing implicit dependency for newer
   ``gevent``. Fixed in 1.4.4 already.

-  Scons: Accept an installed Python 3.11 for Scons execution as well.
   Fixed in 1.4.4 already.

-  Python3.7: Some ``importlib.resource`` nodes asserted against use in
   3.7, expecting it to be 3.8 or higher, but this interface is present
   in 3.7 already. Fixed in 1.4.5 already.

-  Standalone: Fix, Python DLLs installed to the Windows system folder
   were not included, causing the result to be not portable. Fixed in
   1.4.5 already.

-  Python3.9+: Fix, ``metadata.resources`` files method ``joinpath`` is
   some contexts is expected to accept variable number of arguments.
   Fixed in 1.4.5 already.

-  Standalone: Workaround for ``customtkinter`` data files on
   non-Windows. Fixed in 1.4.5 already.

-  Standalone: Added support for ``overrides`` package. Fixed in 1.4.6
   already.

-  Standalone: Added data files for ``strawberry`` package. Fixed in
   1.4.7 already.

-  Fix, anti-bloat plugin caused crashes when attempting to warn about
   packages coming from ``--include-package`` by the user. Fixed in
   1.4.7 already.

-  Windows: Fix, main program filenames with an extra dot apart from the
   ``.py`` suffix, had the part beyond that wrongly trimmed. Fixed in
   1.4.7 already.

-  Fix, list methods didn't properly annotated value escape during their
   optimization, which could lead to wrong optimization for boolean
   tests. Fixed in 1.4.7 already.

-  Standalone: Added support for ``imagej``, ``scyjava``, ``jpype``
   packages. Fixed in 1.4.8 already.

-  Fix, using ``--include-package`` on extension module names was not
   working. Fixed in 1.4.8 already.

-  Standalone: Added support for ``tensorflow.keras`` namespace as well.

-  Distutils: Fix namespace packages were not including their contained
   modules properly with regards to ``__file__`` properties, making
   relative file access impossible.

-  Onefile: On Windows the onefile binary did lock itself, which could
   fail with certain types of AV software. This is now avoided.

-  Accessing files using the top level ``metadata.resources`` files
   object was not working properly, this is now supported too.

-  MSYS2: Make sure mixing POSIX and Windows slashes causes no issues by
   hard-coding the onefile archive to use the subsystem slash rather
   than what MSYS prefers to use internally.

-  Standalone: Added missing dependencies of newer ``imageio``.

-  Fix, side effect nodes didn't annotate their non-exception raising
   nature properly, if that was the case.

New Features
============

-  Added experimental support for Python 3.11, for 3.10 language level
   code it should be fully usable, but the ``CPython311`` test suite has
   not even been started to check newly added or changed features.

-  Windows: Support for native Python on Windows ARM64, which needs 3.11
   or higher, but standalone and therefore onefile do not yet work, due
   to lack of any form of binary dependency analysis tool.

   This platform is relatively new in Python and generally. For the time
   being standalone and onefile should be done with Intel based Python,
   they would also be ARM64 only, whereas 32/64 Bit binaries can be run
   on all Windows ARM platforms.

-  Reports: Write compilation report even in case of Nuitka being
   interrupted or crashing. This then includes the exception, and a
   status like ``completed`` or ``interrupted``. At this time this
   happens only when ``--report=`` was specified, but in the future we
   will likely write one in case of Nuitka crashes.

-  Reports: Now the details of the used Python version, its flavor, the
   OS and the architecture are included. This is crucial information for
   analysis and can make ``--version`` output unnecessary.

-  Reports: License reports now handle ``UNKNOWN`` license by falling
   back to checking the classifiers, and therefore include the correct
   license e.g. with ``setuptools``. Also in case no license text is
   found, do not create an empty block. Added in 1.4.4 already.

-  Reports: In case the distribution name and the contained package
   names differ, output the list of packages included from a
   distribution. Added in 1.4.4 already.

-  Reports: Include data file sizes in report. Added in 1.4.7 already.

-  Reports: Include memory usage into the compilation report as well.

-  macOS: Add support for downloading ``ccache`` on arm64 (M1/M2) too.
   Added in 1.4.4 already.

-  UI: Allow ``--output-filename`` for standalone mode again. Added in
   1.4.3 already.

-  Standalone: Improved isolation with Python 3.8 or higher. Using new
   init mechanisms of Python, we now achieve that the scan for
   ``pyvenv.cfg`` on in current directory and above is not done, using
   it will be unwanted.

-  Python2: Expose ``__loader__`` for modules and register with
   ``pkg_resources`` too which expects these to be present for custom
   resource handling.

-  Python3.9+: The ``metadata.resources`` files objects method
   ``iterdir`` was not implemented yet. Fixed in 1.4.5 already.

-  Python3.9+: The ``metadata.resources`` files objects method
   ``absolute`` was not implemented yet.

-  Added experimental ability to create virtualenv from an existing
   compilation report with new ``--create-environment-from-report``
   option. It attempts to create a requirements file with the used
   packages and their versions. However, sometimes it seems not to be
   possible to due to conflicts.

Optimization
============

-  Onefile: Use memory mapping for calculating the checksum of files on
   all platforms. This is faster and simpler code. So far it had only be
   done this way on Windows, but other platforms also benefit a lot from
   it.

-  Onefile: Use memory mapping for accessing the payload rather than
   file operations. This avoids differences to macOS payload handling
   and is much faster too.

-  Anti-Bloat: Avoid using ``dask`` in ``joblib``.

   .. note::

      Newer versions of ``joblib`` do not currently work yet due to
      their own form of multiprocessing spawn not being supported yet.

-  Anti-Bloat: Adapt for newer ``pandas`` package.

-  Anti-Bloat: Remove more ``IPython`` usages in newer tensorflow.

-  Use dedicated class bodies for Python2 and Python3, with the former
   has a static dict type shape, and with Python3 this needs to be
   traced in order to tell what the meta class put in there.

-  Compile time optimize dict ``in``/``not in`` and ``dict.has_key``
   operations statically where the keys of a dict are known. As a
   result, the class declarations of Python3 no longer created code for
   both branches, the one with ``metaclass =`` in the class declaration
   and without. That means also a big scalability improvement.

-  For the Python3 class bodies, the usage of ``locals()`` was not
   recognized as not locally escaping all the variables, leading to
   variable traces where each class variable was marked as escaped for
   no good reason.

-  Added support for ``dict.fromkeys`` method, making the code
   generation understand and handle static methods as well.

-  Added support for ``os.listdir`` and ``os.path.basename``. Added in
   1.4.5 already for use in implementing the ``iterdir`` method, but
   they are also now optimized by themselves.

-  Added support for trusted constant values of the ``os`` module. These
   are ``curdir``, ``pardir``, ``sep``, ``extsep``, ``altsep``,
   ``pathsep``, ``linesep`` which may enable some minor compile time
   optimization to happen and completes this aspect of the ``os``
   module.

-  Faster ``digit`` size checks during ``float`` code generation for
   better compile time performance.

-  Faster ``list`` operations due to using ``PyList_CheckExact``
   everywhere this is applicable, this mostly makes debug operations
   faster, but also deep copying list values, or extending lists with
   iterables, etc.

-  Optimization: Collect module usages of the given module during its
   abstract execution. This avoids a full tree visit afterwards only to
   find them. It is much cheaper to collect them while we go over the
   tree. This enhances the scalability of large compilations by ca. 5%.

-  Optimization: Faster determination of loop variables. Rather than
   using a generic visitor, we use the children having generator codes
   to add traversal code that emits relevant variables to the user
   directly.

-  Cache extra search paths in order to avoid repeated directory
   operations as these are known to be slow at times.

-  Standalone: Do not include ``py.typed`` data files, these indicator
   files are for IDEs, but not needed at run time ever.

-  Make sure that the generic attribute code optimization is also
   effective in cases where a Python DLL is used. Previously this was
   only guaranteed to be used with static libpython.

-  Faster list constant usage

   Small immutable constants get their own code that is much faster for
   small sizes.

   Medium sized lists get code that just is hinted the size, but takes
   items from a source list, still a lot faster.

   For repeated lists where all elements are the same, we use a
   dedicated helper for all sizes, that is even faster except for small
   ones with LTO enabled, where the C compiler may already do that
   effectively.

-  Added optimization for ``os.path.abspath`` and ``os.path.isabs``
   which of course have not as much potential for compile time
   optimization, but we needed them for providing ``.absolute()`` for
   the meta path loader files implementation.

-  Faster class dictionary propagation decision. Instead of checking for
   trace types, let the trace object decide. Also abort immediately on
   first inhibit, rather than checking all variables. This improves
   Python2 compile time, and Python3 where this code is now starting to
   get used when the class dictionary is shown to have ``dict`` type.

-  Specialize type method ``__prepare__`` which is used in the Python3
   re-formation of class bodies to initialize the class dictionary.
   Where the metaclass is resolved, we can use this to decide that the
   standard empty dictionary is used statically, enabling class
   dictionary propagation for best scalability.

   At this time this only happens with classes without bases, but we
   expect to soon do this with all compile time known base classes. At
   this time, these optimization to become effective, we need to
   optimize meta class selection from bases classes, as well as
   modification of base classes with ``__mro_entries__`` methods.

-  The ``bool`` built-in on boolean values is now optimized away.

   Since it's used also for conditions being extracted, this is actually
   somewhat relevant, since it could keep code alive in side effects at
   least for no good reason and this allows a proper reduction.

Organisational
==============

-  Project: Require the useful stuff for installation of Nuitka already.
   These are things we cannot inline really, but otherwise will
   frequently be warned about, e.g. ``zstandard`` for onefile and
   ``ordered-set`` for fast operation, but we do not require packages
   that might fail to install.

-  User Manual: Added section about virus scanners and how to avoid
   false reports.

-  User Manual: Enhanced description for plugin module loading, the old
   code was too complicated and actually working only for a mode of
   including plugin code that is discouraged.

-  User Manual: Fix section for standalone finding files on wrong level.

-  Windows: Using the console on Python 3.4 to 3.7 is not working very
   well with e.g. many Asian systems. Nuitka fails to setup the encoding
   for stdin and stdout or this platform. It can then produce exceptions
   on input or output of unicode data, that doesn't overlap with UTF-8.

   We now inform the user of these older Python with a warning and
   mnemonic, to either disable the console or to upgrade to Python 3.8
   or higher, which normally won't be much of an issue for most users.

   Read more on `the info page
   <https://nuitka.net/info/old-python-windows-console.html>`__ for
   detailed information. Added in 1.4.1 already.

-  Debugging: Fixup debugging reference count output with Python3.4. For
   Python 3.11 compatibility tests, actually it was useful to compare
   with a version that doesn't have coroutines yet. Never tell me,
   supporting old versions is not good.

-  Deprecating support for Python 3.3, there is no apparent use of this
   version, and it has gained specific bugs, that are indeed not worth
   our time. Python 2.6 and Python 2.7 will continue to be supported
   probably indefinitely.

-  Recommend ``ordered-set`` for Python 3.7 to 3.9 as well, as not only
   for 3.10+ because on Windows, to install ``orderset`` MSVC needs to
   be installed, whereas ``ordered-set`` has a wheel for ready use.

-  Actually zstandard requirement is for a minimal version, added that
   to the requirement files.

-  Debugging: Lets not reexecute Nuitka in case if we are debugging it
   from Visual Code.

-  Debugging: Include the ``.pdb`` files in Windows standalone mode for
   proper C tracebacks should that be necessary.

-  UI: Detect the GitHub flavor of Python as well.

-  Quality: Check the ``clang-format`` version to avoid older ones with
   bugs that made it switch whitespace for one file. Using the one from
   Visual Code C extension is a good idea, since it will often be
   available. Running the checks on newer Ubuntu GitHub Actions runner
   to have the correct version available.

-  Quality: Updated the version of ``rstfmt`` and ``isort`` to the
   latest versions.

-  GitHub: Added commented out section for enabling ``ssh`` login, which
   we occasionally need to git bisect problems specific to GitHub Python
   flavor.

-  Plugins: Report problematic plugin name with module name or DLL name
   when these raise exceptions.

-  Use ``ordered-set`` package for Python3.7+ rather than only
   Python3.10+ because it doesn't need any build dependency on Windows.

-  UI: When showing source changes, also display the module name with
   the changed code.

-  UI: Use function intended for user query when asking about downloads
   too.

-  UI: Do not report usage of ``ccache`` for linking from newer version,
   that is not relevant.

-  Onefile: Make sure we have proper error codes when reporting IO
   errors.

-  MSVC: Detect a version for developer prompts too. This version is
   needed for use in enabling version specific features.

-  Started UML diagrams with ``plantuml`` that will need to be completed
   before using them in then new and more visual parts of Nuitka
   documentation.

-  UI: Check icon conversion capability at start of compilation rather
   than error exiting at the very end informing the user about required
   ``imageio`` packages to convert to native icons.

-  Quality: Enhanced autoformat on Windows, which was susceptible to
   tools introducing Windows new lines before other steps were
   performed, that then could be confused, also enforcing use of UTF-8
   encoding when working with Nuitka source code for formatting.

Cleanups
========

-  The ``delvewheel`` plugin was still using a ``zmq`` class name from
   its original implementation, adapted that.

-  Use common template for generator frames as well. This made them also
   work with 3.11, by avoiding duplication.

-  Applied code formatting to many more files in ``tests``, etc.

-  Removed a few micro benchmarks that are instead to be covered by
   construct based tests now.

-  Enhanced code generation for specialized in-place operations to avoid
   unused code for operations that do not have any shortcuts where the
   operation would be actual in-place of a reference count 1 object.

-  Better code generation for module variable in-place operations with
   proper indentation and no repeated calls.

-  Plugins: Use the ``namedtuple`` factory that we created for
   informational tuples from plugins as well.

-  Make details of download utils module more accessible for better
   reuse.

-  Remove last remaining Python 3.2 version check in C code, for us this
   is just Python3 with 3.2 being unsupported.

-  Cleanup, name generated call helper file properly, indicating that it
   is a generated file.

Tests
=====

-  Made the CPython3.10 test suite largely executable with Python 3.11
   and running that with CI now.

-  Allow measuring constructs without writing the code diff again. Was
   crashing when no filename was given.

-  Make Python3.11 test execution recognized by generally accepting
   partially supported versions to execute the tests with.

-  Handle also ``newfstat`` directory checks in file usage scan. This
   are used on newer Linux systems.

-  GitHub: In actions use ``--report`` for coverage and upload the
   reports as artifacts.

-  Use ``no-qt`` plugin to avoid warnings in ``matplotlib`` test rather
   than disabling the warnings about Qt bindings.

-  macOS: Detect if the machine can take runtime traces, which on Apple
   Silicon by default it cannot.

-  macOS: Cover all APIs for file tracing, rather than just one for
   extended coverage.

-  Fix, distutils test was not installing the built wheels, but source
   archive and therefore compiling that second time.

-  For the ``pyproject.toml`` using tests, Nuitka was always downloaded
   from PyPI rather than using the version under test.

-  Ignore ``ld`` info output about mismatching architecture libraries
   being ignored. Fixed in 1.4.1 already.

Summary
=======

With this release an important new avenue for scalability has been
started. While for Python2 class bodies were very often reduced to just
that dictionary creation, with Python3 that was not the case, due to the
many new complexities, and while this release makes a start, we will be
able to continue this path towards much more scalable class creation
codes. And while the performance does not really matter all that much
for these, knowing these, will ultimately lead us to "compiled classes"
as our own type, and "compiled objects" that may well perform much
faster.

Already now, the enhancements to class creation codes will result in
smaller binaries, but much more is expected the more this is completed.

The majority of the work was of course to become Python3.11 compatible,
and unfortunately the attribute lookups are not as optimized as for 3.10
yet, which may cause disappointing results for performance initially. We
will need to complete that before benchmarks will make much sense.

For the next release, full Python 3.11 support is planned. I believe it
should be usable. Problems with 3.11 may get hotfixes, but ultimately
the develop version is probably the one to recommend when using 3.11
with Nuitka, as there will be the whole set of fixes, since not
everything will be ported back.

The new reports should be used in bug reporting soon. We foresee that
for issue reports, these may well become mandatory. Together with the
ability to create a virtualenv from the reports, this may make
reproducing issues a breeze, but first tries on complex projects were
also highlighting that it may not be as simple.

********************
 Nuitka Release 1.4
********************

This release contains a large amount of performance work, where
specifically Python versions 3.7 or higher see regressions in relative
performance to CPython fixed. Many cases of macros turned to functions
have been found and resolved. For 3.10 specifically we take advantage of
new opportunities for optimization. And generally avoiding DLL calls
will benefit execution times on platform where the Python DLL is used,
most prominently Windows.

Then this also adds new features, specifically custom reports. Also
tools to aid with adding Nuitka package configuration input data, to
list DLLs and data files.

With multidist we see a brand new ability to combine several programs
into one, that will become very useful for packaging multiple binaries
without the overhead of multiple distributions.

Bug Fixes
=========

-  Standalone: Added implicit dependencies for ``dependency_injector``
   package. Fixed in 1.3.1 already.

-  Fix, the generated metadata nodes for distribution queries had an
   error in their generated children handling that could cause crashes
   at compile time. Fixed in 1.3.2 already.

-  Standalone: Added implicit dependencies for ``passlib.apache``
   package. Fixed in 1.3.2 already.

-  Windows: Fix, our shortcut to find DLLs by analyzing loaded DLLs
   stumbled in a case of a DLL loaded into the compiling Python that had
   no filename associated, while strange, we need to handle this as
   well. Fixed in 1.3.3 already.

-  Standalone: Also need to workaround more decorator tricks for
   ``networkx``. Fixed in 1.3.3 already.

-  Scons: Fix, was not updating ``PATH`` environment variable anymore,
   which could lead to externally provided compilers and internal
   winlibs gcc clashing on Windows, but should be a general problem.
   Fixed in 1.3.4 already.

-  Standalone: Added support for ``cefpython3`` package. Fixed in 1.3.4
   already.

-  Standalone: Added support for newer ``webview`` package versions.
   Fixed in 1.3.4 already.

-  Standalone: Fix, some extension modules set their ``__file__`` to
   ``None`` during multi phase imports, which we then didn't update
   anymore, however that is necessary. Fixed in 1.3.4 already.

-  Python3.10+: Fix, was not supporting ``match`` cases where an
   alternative had no condition associated. Fixed in 1.3.5 already.

-  Windows: Identify Windows ARM architecture Python properly. We do not
   yet support it, but we should report it properly and some package
   configurations are already taking it already into account. Fixed in
   1.3.5 already.

-  Fix, the Nuitka meta path based loader, needs to expose a
   ``__module__`` attribute because there is code out there, that
   identifies standard loaders through looking at this value, but
   crashes without it. Fixed in 1.3.5 already.

-  Fix, very old versions of the ``importlib_metadata`` backport were
   using themselves to load their ``__version__`` attribute. Added a
   workaround for it, since in Nuitka it doesn't work until after
   loading the module.

-  Fix, value escapes for attribute and subscript assignments sources
   were not properly annotated. This could cause incorrect code
   execution. Fixed in 1.3.6 already.

-  Fix, "pure" functions, which are currently only our complex call
   helper functions, were not visited in all cases. This lead to a crash
   in code generation after modules using them got demoted to bytecode.
   After use from cache, this didn't happen again. Fixed in 1.3.6
   already.

-  Standalone: Added more implicit dependencies of crypto packages.
   Fixed in 1.3.6 already.

-  Standalone: Added implicit dependencies of ``pygments.styles``
   module. Fixed in 1.3.6 already.

-  Fix, was falsely encoding ``Ellipsis`` too soon during tree building.
   It is not quite like ``True`` and ``False``. Fixed in 1.3.6 already.

-  Standalone: Fix, ``numpy`` on macOS didn't work inside an application
   bundle anymore. Fixed in 1.3.7 already.

-  Python3.8+: Fix, need to follow change for extension module handling,
   otherwise some uses of ``os.add_dll_directory`` fail to work. Fixed
   in 1.3.8 already.

-  Standalone: Added missing implicit dependencies of ``sqlalchemy``.
   Fixed in 1.3.8 already.

-  Python3.9+: Fix, resource reader files was not fully compatible and
   needed to register with ``importlib.resources.as_file`` to work well
   with it. Fixed in 1.3.8 already.

-  Fix, the version check for ``cv2`` was not working with the
   ``opencv-python-headless`` variant. Package name and distribution
   name is not a 1:1 mapping for all things. Fixed in 1.3.8 already.

-  Standalone: Added DLLs needed for ``tls_client`` package.

-  Fix, imports of resolved names should be modified for runtime too.
   Where Nuitka recognizes aliases, as e.g. the ``requests`` module
   does, it only adding a dependency on the resolved name, but not
   ``requests`` itself. The import however was still done at runtime on
   ``requests`` which then didn't work. This was only visible if only
   these aliases to other modules were used.

-  Onefile: Fix, do not send duplicate CTRL-C to child process. Our test
   only send it to the bootstrap process, rather than the process group,
   as it normally is working, therefore misleading us into sending it to
   the child even if not needed.

-  Onefile: When not using cached mode, on Windows the temporary folder
   used sometimes failed to delete after the executable stopped with
   CTRL-C. This is due to races in releasing of locks and process
   termination and AV tools, so we now retry for some time, to make sure
   it is always deleted.

-  Standalone: Fix, was not ignoring ``.dylib`` when scanning for data
   files unlike all other DLL suffixes.

-  Standalone: Added missing implicit dependency of ``mplcairo``.

-  Standalone: The main binary name on non-Windows didn't have a suffix
   ``.bin`` unlike in accelerated mode. However, this didn't work well
   for packages which have binaries colliding with the package name.
   Therefore now the suffix is added in this case too.

-  macOS: Workaround bug in ``platform_utils.paths``. It is guessing the
   wrong path for included data files with Nuitka.

-  Standalone: Added DLLs of ``sound_lib``, selecting by OS and
   architecture.

-  Fix, for package metadata as from ``importlib.metadata.metadata`` for
   use at runtime we need to use both package name and distribution name
   to create it, or else it failed to work. Packages like
   ``opencv-python-headless`` can now with this too.

-  Standalone: Added support for ``tkinterweb`` on Windows. Other
   platforms will need work to be done later.

New Features
============

-  UI: Added new option to listing package data files. This is for use
   with analyzing standalone issues. And will output all files that are
   data files for a given package name.

   .. code:: shell

      python -m nuitka --list-package-data=tkinterweb

-  UI: Added new option to listing package DLL files. This is also for
   use with analyzing standalone issues.

   .. code:: shell

      python -m nuitka --list-package-dlls=tkinterweb

-  Reports: The usages of modules, successful or not, are now included
   in the compilation report. Checking out which ones are ``not-found``
   might help recognition of issues.

-  Multidist: You can now experimentally create binaries with multiple
   entry points. At runtime one of multiple ``__main__`` will be
   executed. The option to use is multiple ``--main=some_main.py``
   arguments. If then the binary name is changed, on execution you get a
   different variant being executed.

   .. note::

      Using it with only one replaces the previous use of the positional
      argument given and is not using multidist at all.

   .. note::

      Multidist is compatible with onefile, standalone, and mere
      acceleration. It cannot be used for module mode obviously.

   For deployment this can solve duplication.

   .. note::

      For wheels, we will probably change those with multiple entry
      points to compiling multidist executables, so we do avoid Python
      script entry points there. But this has not yet been done.

-  Onefile: Kill non-cooperating child processes on CTRL-C after a grace
   period, that can be controlled at compile time with
   ``--onefile-child-grace-time`` the hard way. This avoids hangs of
   processes that fail to properly shutdown.

-  Plugins: Add support for extra global search paths to mimic
   ``sys.path`` manipulations in the Yaml configuration with new
   ``global-sys-path`` import hack.

-  Reports: Include used distributions of compiled packages and their
   versions.

-  Reports: Added ability to generate custom reports with
   ``--report-template`` where the user can provide a Jinja2 template to
   make his own reports.

-  Anti-Bloat: Added support for checking python flags. There are
   ``no_asserts``, ``no_docstrings`` and ``no_annotations`` now. These
   can be used to limit rules to be only applied when these optional
   modes are active.

   Not all packages will work in these modes, but often can be enhanced
   to work with relatively little patching. This allows to limit these
   patches to only where they are necessary.

Optimization
============

-  Anti-Bloat: Avoid using ``sparse`` and through that Numba in the
   ``scipy`` package, reducing its distribution footprint. Part of 1.3.3
   already.

-  Anti-Bloat: Avoid IPython and Numba in ``trimesh`` package. Part of
   1.3.3 already.

-  Anti-Bloat: Avoid Numba in ``shap`` package. Part of 1.3.8 already.

-  Anti-bloat: Removed ``xgboost`` docstring dependencies, such that
   ``--python-flag=no_docstrings`` can be used with this package.

-  For guided deep copy ``frozenset`` and empty ``tuple`` need no copies

   This also speeds up copies of non-empty tuples by avoiding that size
   checking branch in construction with Python 3.10 or higher.

-  For node construction, avoid keyword argument style calls of the base
   class, where there is only a single argument. They don't really help
   readability, but cost compile time.

-  Determine guard mode of frames dynamically and avoid frame
   preservation checks where they are not needed.

   For Python2 this is necessary, but not for Python3, so make the
   function avoid finding the parent frame for that version entirely,
   which should speed up compilation as well.

   By not hard coding frame guard mode at creation time, and instead
   determine it at compile time, after optimization, so this now allows
   to use the "once" mode more often. This affects contractions and also
   classes on the module level right now. They do not need a cached
   frame, since their code is only executed once.

   By avoiding that useless code, the C compiler also has a slightly
   better scalability, since the classes are all created in one function
   that then has less code.

-  The bytecode cache is now checking if the used modules or attempted
   to be used modules are available or not in just the same way.
   Previously it was very dependent on the file system to contain the
   same things, which was not giving cache hits even after only creating
   a new folder near a binary, since that affected importable modules.
   With the new check it should be much more directly hitting even
   across different virtual environments, but with same code.

-  Generate base classes or mixins for all kinds of expression,
   statements and statement sequences. The previous code had a dedicated
   variant for single child, to allow faster operation in a common case,
   but still a lot of ``hasattr/getattr/setattr`` on dynamic attribute
   names were done. This was making the tree traversal during
   optimization slower than necessary.

   Another shortcoming was that for some nodes, some values are
   optional, where for others, they are not. Some values are a ``tuple``
   actually, while most are nodes only. However, dealing with this
   generically was also slower than necessary.

   The new code now enforces children types during creation and updated,
   it rejects unexpected ``None`` values for non-optional children, and
   it provides generated code to do this in the fastest way possible,
   although surely some more improvements will come here.

   Also when abstract executing the tree, rather than generically
   visiting all children, this now just unrolls this, and there are even
   some modes added, where a node can indicate properties, e.g.
   ``auto_compute_handling = "final,no_raise"`` will tell the code
   generator that this expression never raises in the computation, and
   is final, i.e. doesn't have any code to evaluate, because it cannot
   be optimized any further.

   Also the way ``checkers`` previously worked, for every node creation,
   for every child update, a dictionary lookup had to be done. This is
   now hard coded for the few nodes that actually want to convert values
   on the fly and we might make a difference in the future for optional
   checkers, such that these are only run in debug mode.

   These changes brought about much faster compilation, however the big
   elephant in the room will still be merging value traces, and
   scalability problems remain there.

-  Attribute node generation for method specs like ``dict.update``, etc.
   now provide type shapes. From these type shapes, mixins for the
   result value type are picked automatically. Previously these shapes
   were added manually. In some cases, they were even missing. In a few
   cases, where the type is dependent on the Python version, we do not
   currently do this though, so this needs more work, but expanding the
   coverage got easier in this way.

-  Determining the used modules of a module requires a tree visit
   operations, that then asked for node types and used different APIs.
   This has been unified to be able to call a virtual method instead,
   which saves some compile time.

-  After scanning for a module, we then determined the module kind even
   after we previously knew it during the scan. Also, this was checking
   ``os.path.isdir`` which was making it relatively slow and wasting 5%
   compile time on the IO being done. The check got enhanced and most
   often replaced with using the knowledge from the original import scan
   eliminating this time.

-  Already most helper code of Nuitka was included from ``.c`` files,
   but compiled generators and compiled cells codes were not yet done
   like this, making life unnecessarily harder for the compiler and
   linker. This should also allow more optimization for some codes.

-  Cache the plugin decisions about recursion for a module name. When a
   module is imported multiple times plugins were each asked again and
   again, which is not a good thing to do.

-  Avoid usage of ``PyObject_RichCompareBool`` API, as we have our own
   comparison functions that are faster and faster to call without
   crossing of DLL barrier.

-  Python3.8+: Avoid usage of ``PyIndex_Check`` which has become an API
   in 3.8, and was as a result not inlined anymore with a DLL barrier
   was to be crossed, making all kinds of multiplication and
   subscript/index operations slower.

-  Replace ``PyNumber_Index`` API with our own code. As of 3.10 it
   enforces a conversion to ``long`` that for Nuitka is not a good thing
   to do in all places. But also due to DLL barrier it was potentially
   slow to call, and is used a lot, and we can drop the checks that are
   useless for Nuitka.

-  Python3.7+: Avoid the use of ``PyImport_GetModule`` for looking up
   imported modules from ``sys.modules``, rather look it up from
   interpreter internals, also this was using subscript functions, when
   this is always a dictionary.

-  Avoid using ``PyImport_GetModuleDict`` and instead have our own API
   to get this quicker.

-  Faster exception match checks and sub type checks.

   This solves a ``TODO`` about inlining the API function used, so we
   can be faster in a relatively common operation. For every exception
   handler, we had to do one API call there.

-  Faster subtype checks.

   These are common in binary operations on non-identical types, but
   also needed for the exception checks, and object creation through
   class type calls. With our own ``PyType_IsSubType`` replacement these
   faster to use and avoid the API call.

-  Faster Python3 ``int`` value startup initialization.

   On Python 3.9 or higher we can get small int values directly from the
   interpreter, and with 3.11 they are accessible as global values.

   Also we no longer de-duplicate small int values through our cache,
   since there is no use in this, saving a bunch of startup time. And we
   can create the values with our own API replacement, that will work
   during startup already and save API calls as these can be relatively
   slow. And esp. for the small values, this benefits from not having to
   create them.

-  Faster Python3 ``bytes`` value startup initialization.

   On Python 3.10 or higher, we can create these values ourselves
   without an API call, avoiding its overhead.

   Also we no longer de-duplicate small bytes values through our cache,
   because that is already done by the API and our replacement, so this
   was just wasting time.

-  Faster ``slice`` object values with Python 3.10 or higher

   On Python 3.10 or higher, we can create these values ourselves
   without an API call, avoiding its overhead.

   These are important for Python3, because ``a[x:y]`` in the general
   case has to use ``a[slice(x,y)]`` on that version, making this
   somewhat relevant to performance in some cases.

-  Faster ``str`` built-in with API calls

   For common cases, this avoids API calls. We mostly have this such
   that ``print`` style tests do not have this as API calls where we
   strive to remove all API calls for given programs.

-  Faster exception normalization.

   For the common case, we have our own variant of
   ``PyErr_NormalizeException`` that will avoid the API call. It may
   still call the ``PyObject_IsSubclass`` API, for which we only have
   started replacement work, but this is already a step ahead in the
   right direction.

-  Faster object releases

   For Python3.8 or higher when our code released objects, it was doing
   that with an API call, due to a macro change in Python headers. We
   revert that and do it still on our own which avoids the performance
   penalty.

-  Enable Python threading during extension module DLL loading

   We now release the GIL for Python3.8 or higher when loading the DLL,
   following a change in that version.

-  Faster variable handling in trace collection. The code was doing
   checks for variable types, to decide what to do e.g. when control
   flow escapes for a variable. However, this is faster if solved with a
   virtual method in those variable classes, shifting the responsibility
   to inside there.

-  For call codes the need to check the return value was not perfectly
   annotated in all cases. This is now driven by the expression rather
   than passed, and will result in better code generated in some corner
   cases.

Organisational
==============

-  Release: Make clear we require ``wheel`` and ``setuptools`` to
   install by adding a ``pyproject.toml`` that addresses a warning of
   ``pip``. Part of 1.3.6 release already.

-  Debugging: When plugins evaluate ``when`` conditions that raise,
   output which it was exactly. Part of 1.3.3 already.

-  Anti-Bloat: Added a mnemonic and more clear message for the case of
   unwanted imports being encountered. Also do not warn about IPython
   itself using IPython packages, that must of course be considered
   normal. Now it also lists the module that does the unwanted usage
   immediately. Previously this was not as clear.

-  UI: More clear output for not yet supported Python version. Make it
   more clear in the message, what is the highest supported version, and
   what version is Nuitka and what is Python in this.

-  UI: Make sure data files have normalized paths. Specifically on
   Windows, otherwise a mix of slashes could appear. Part of 1.3.6
   release already.

-  UI: Make it clear that disabling the console harms your debugging
   when we suggest the ``--disable-console`` for GUI packages. Otherwise
   using that, they just deprive themselves of ways to get error
   information.

-  UI: The ordering of scons ``ccache`` report was not enforced. Part of
   1.3.7 release already.

-  Quality: Use proper temporary filename during autoformat, so as to
   avoid flicker in Visual Code, e.g. search results.

-  User Manual: Was still using old option name for
   ``--onefile-tempdir-spec`` that has since been made not OS specific,
   with even the OS specific name being removed.

-  Standalone: Do not include data files scanned with ``site-packages``
   or ``__pycache__`` folders. This should make it easier to use
   ``--include-data-file=./**.qml:.`` when you have a virtualenv living
   in the same folder.

-  Onefile: Added check for compression ability before starting the
   compilation to inform the user immediately.

-  Release: Mark macOS as supported in PyPI categories. This is of
   course true for a long time already.

-  Release: Mark Android as supported in PyPI categories as well. With
   some extra work, it can be used.

-  User Manual: Added section pointing to and explaining compilation
   reports. This has become extremely useful even if still somewhat work
   in progress.

-  User Manual: Added table with included custom reports, at this time
   only the license reports, which is very rough shape and needs
   contributors for good looks and content.

Cleanups
========

-  Plugins: Moved parts of the ``pywebview`` plugin that pertain to the
   DLLs and data files to package configuration.

-  Made the user query code a dedicated function, so it can be reused
   and more consistent across its uses in Nuitka. With a default that is
   proposed to a user, and a default that applies if used
   non-interactively. We will switch all prompts to using this.

-  Code generation for module, class and function frames is now unified,
   removing duplication while also becoming more flexible. For
   generators this work has been started, but is not yet completed.

-  Nodes exposing used modules now implement the same virtual method
   providing a list of them.

-  Make sure to pass ``tuple`` values rather than ``list`` values from
   the tree building stage and node optimization creating new nodes.
   This allows us to drop conversions previously done inside of nodes.

Tests
=====

-  Do not enable deprecated plugins, the warnings about them break
   tests.

-  Ignore Qt binding warnings in tests, some are less supported than
   ``PySide6`` or commercial ``PySide2``.

Summary
=======

The focus of this release was first a major restructuring of how
children are handled in the node tree. The generated code opens up the
possibility of many more scalability improvements in the coming
releases. The pure iteration speed for the node tree will make compile
times for the Python part even shorter in coming releases. Scalability
will be a continuous focus for some releases.

Then the avoiding of API calls is a huge benefit for many platforms that
are otherwise at a disadvantage. This is also only started. We will aim
at getting more complex programs to do next to none of these, so far
only some tests are working after program start without them, which is
of course big progress. We will progress there with future releases as
well.

Catching up on problems that previous migrations have not discovered is
also a huge step forward to restoring the performance supremacy, that
was not there anymore in extreme cases.

The Yaml package configuration work is showing its fruits. More people
have been able to contribute changes for ``anti-bloat`` or missing
dependencies than ever before.

Some part of the Python 3.11 work have positively influenced things,
e.g. with the frame cleanup. THe focus of the next release cycle shall
be to add support for it. Right now, generator frames need a cleanup to
be finished, to also become better and working with 3.11 at the same
time. Where possible, work to support 3.11 was also conducted as a
cleanup action, or reduction of the technical debts.

All in all, it is fair to say that this release is a big leap forward in
all kinds of ways.

********************
 Nuitka Release 1.3
********************

This release contains a large amount of performance work, that should
specifically be useful on Windows, but also generally. A bit of
scalability work has been applied, and as usual many bug fixes and small
improvements, many of which have been in hotfixes.

Bug Fixes
=========

-  macOS: Framework build of PySide6 were not properly supporting the
   use of WebEngine. This requires including frameworks and resources in
   new ways, and actually some duplication of files, making the bundle
   big, but this seems to be unavoidable to keep the signature intact.

-  Standalone: Added workaround for ``dotenv``. Do not insist on
   compiled package directories that may not be there in case of no data
   files. Fixed in 1.2.1 already.

-  Python3.8+: Fix, the ``ctypes.CDLL`` node attributes the ``winmode``
   argument to Python2, which is wrong, it was actually added with 3.8.
   Fixed in 1.2.1 already.

-  Windows: Attempt to detect corrupt object file in MSVC linking. These
   might be produced by ``cl.exe`` crashes or ``clcache`` bugs. When
   these are reported by the linker, it now suggests to use the
   ``--clean-cache=ccache`` which will remove it, otherwise there would
   be no way to cure it. Added in 1.2.1 already.

-  Standalone: Added data files for ``folium`` package. Added in 1.2.1
   already.

-  Standalone: Added data files for ``branca`` package. Added in 1.2.1
   already.

-  Fix, some forms ``try`` that had exiting ``finally`` branches were
   tracing values only assigned in the ``try`` block incorrectly. Fixed
   in 1.2.2 already.

-  Alpine: Fix, Also include ``libstdc++`` for Alpine to not use the
   system one which is required by its other binaries, much like we
   already do for Anaconda. Fixed in 1.2.2 already.

-  Standalone: Added support for latest ``pytorch``. One of our
   workarounds no longer applies. Fixed in 1.2.2 already.

-  Standalone: Added support for webcam on Windows with
   ``opencv-python``. Fixed in 1.2.3 already.

-  Standalone: Added support for ``pytorch_lightning``, it was not
   finding metadata for ``rich`` package. Fixed in 1.2.4 already.

   For the release we found that ``pytorch_lightning`` may not find
   ``rich`` installed. Need to guard ``version()`` checks in our package
   configuration.

-  Standalone: Added data files for ``dash`` package. Fixed in 1.2.4
   already.

-  Windows: Retry replace ``clcache`` entry after a delay, this works
   around Virus scanners giving access denied while they are checking
   the file. Naturally you ought to disable those for your build space,
   but new users often don't have this. Fixed in 1.2.4 already.

-  Standalone: Added support for ``scipy`` 1.9.2 changes. Fixed in 1.2.4
   already.

-  Catch corrupt object file outputs from ``gcc`` as well and suggest to
   clean cache as well. This has been observed to happen at least on
   Windows and should help resolve the ``ccache`` situation there.

-  Windows: In case ``clcache`` fails to acquire the global lock, simply
   ignore that. This happens sporadically and barely is a real locking
   issue, since that would require two compilations at the same time and
   for that it largely works.

-  Compatibility: Classes should have the ``f_locals`` set to the actual
   mapping used in their frame. This makes Nuitka usable with the
   ``multidispatch`` package which tries to find methods there while the
   class is building.

-  Anaconda: Fix, newer Anaconda versions have TCL and Tk in new places,
   breaking the ``tk-inter`` automatic detection. This was fixed in
   1.2.6 already.

-  Windows 7: Fix, onefile was not working anymore, a new API usage was
   not done in a compatible fashion. Fixed in 1.2.6 already.

-  Standalone: Added data files for ``lark`` package. Fixed in 1.2.6
   already.

-  Fix, ``pkgutil.iter_modules`` without arguments was given wrong
   compiled package names. Fixed in 1.2.6 already.

-  Standalone: Added support for newer ``clr`` DLLs changes. Fixed in
   1.2.7 already.

-  Standalone: Added workarounds for ``tensorflow.compat`` namespace not
   being available. Fixed in 1.2.7 already.

-  Standalone: Added support for ``tkextrafont``. Fixed in 1.2.7
   already.

-  Python3: Fix, locals dict test code testing if a variable was present
   in a mapping could leak references. Fixed in 1.2.7 already.

-  Standalone: Added support for ``timm`` package. Fixed in 1.2.7
   already.

-  Plugins: Add ``tls`` to list of sensible plugins. This enables at
   least ``pyqt6`` plugin to do networking with SSL encryption.

-  Standalone: Added implicit dependencies of ``sklearn.cluster``.

-  FreeBSD: Fix, ``fcopyfile`` is no longer available on newest OS
   version, and include files for ``sendfile`` have changed.

-  MSYS2: Add back support for MSYS Posix variant. Now onefile works
   there too.

-  Fix, when picking up data files from command line and plugins,
   different exclusions were applied. This has been unified to get
   better coverage for avoiding to include DLLs and the like as data
   files. DLLs are not data files and must be dealt with differently
   after all.

New Features
============

-  UI: Added new option for cache disabling ``--disable-cache`` that
   accepts ``all`` and cache names like ``ccache``, ``bytecode`` and on
   Windows, ``dll-dependencies`` with selective values.

   .. note::

      The ``clcache`` is implied in ``ccache`` for simplicity.

-  UI: With the same values as ``--disable-cache`` Nuitka may now also
   be called with ``--clean-cache`` in a compilation or without a
   filename argument, and then it will erase those caches current data
   before making a compilation.

-  macOS: Added ``--macos-app-mode`` option for application bundles that
   should run in the background (``background``) or are only a UI
   element (``ui-element``).

-  Plugins: In the Nuitka package configuration files, the ``when``
   allows now to check if a plugin is active. This allowed us to limit
   console warnings to only packages whose plugin was activated.

-  Plugins: Can now mark a plugin as a GUI toolkit responsible with the
   consequence that other toolkit detector plugins are all disabled, so
   when using ``tk-inter`` no longer will you be asked about ``PySide6``
   plugin, as that is not what you are using apparently.

-  Plugins: Generalized the GUI toolkit detection to include
   ``tk-inter`` as well, so it will now point out that ``wx`` and the Qt
   bindings should be removed for best results, if they are included in
   the compilation.

-  Plugins: Added ability to provide data files for macOS ``Resources``
   folder of application bundles.

-  macOS: Fix, Qt WebEngine was not working for framework using Python
   builds, like the ones from PyPI. This adds support for both PySide2
   and PySide6 to distribute those as well.

-  MSYS2: When asking a CPython installation to compress from the POSIX
   Python, it crashed on the main filename being not the same.

-  Scons: Fix, need to preserve environment attached modes when
   switching to winlibs gcc on Windows. This was observed with MSYS2,
   but might have effects in other cases too.

Optimization
============

-  Python3.10+: When creating dictionaries, lists, and tuples, we use
   the newly exposed dictionary free list. This can speedup code that
   repeatedly allocates and releases dictionaries by a lot.

-  Python3.6+: Added fast path to dictionary copy. Compact dictionaries
   have their keys and values copied directly. This is inspired by a
   Python3.10 change, but it is applicable to older Python as well, and
   so we did.

-  Python3.9+: Faster compiled object creation, esp. on Python platforms
   that use a DLLs for libpython, which is a given on Windows. This
   makes up for core changes that went unnoticed so far and should
   regain relative speedups to standard Python.

-  Python3.10+: Faster float operations, we use the newly exposed float
   free list. This can speed up all kinds of float operations that are
   not doable in-place by a lot.

-  Python3.8+: On Windows, faster object tracking is now available, this
   previously had to go through a DLL call, that is now removed in this
   way as it was for non-Windows only so far.

-  Python3.7+: On non-Windows, faster object tracking is now used, this
   was regressed when adding support for this version, becoming equally
   bad as all of Windows at the time. However, we now managed to restore
   it.

-  Optimization: Faster deep copy of mutable tuples and list constants,
   these were already faster, but e.g. went up from 137% gain factor to
   201% on Python3.10 as a result. We now use guided a deep copy, which
   then has the information, what types it is going to copy, removing
   the need to check through a dictionary.

-  Optimization: Also have own allocator function for fixed size
   objects. This accelerates allocation of compiled cells, dictionaries,
   some iterators, and lists objects.

-  More efficient code for object initialization, avoiding one DLL calls
   to set up our compiled objects.

-  Have our own ``PyObject_Size`` variant, that will be slightly faster
   and avoids DLL usage for ``len`` and size hints, e.g. in container
   creations.

-  Avoid using non-optimal ``malloc`` related macros and functions of
   Python, and instead of the fasted form generally. This avoids Python
   DLL calls that on Windows can be particularly slow.

-  Scalability: Generated child mixins are now used for the generated
   package metadata hard import nodes calls, and for all instances of
   single child tuple containers. These are more efficient for creation
   and traversal of the tree, directly improving the Python compile
   time.

-  Scalability: Slightly more efficient compile time constant property
   detections. For ``frozenset`` there was not need to check for
   hashable values, and some branches could be replaced with e.g.
   defining our own ``EllipsisType`` for use in short paths.

-  Windows: When using MSVC and LTO, the linking stage was done with
   only one thread, we now use the proper options to use all cores. This
   is controlled by ``--jobs`` much like C compilation already is. For
   large programs this will give big savings in overall execution time.
   Added in 1.2.7 already.

-  Anti-Bloat: Remove the use of ``pytest`` for ``dash`` package
   compilation.

-  Anti-Bloat: Remove the use of IPython for ``dotenv``, ``pyvista``,
   ``python_utils``, and ``trimesh`` package compilation.

-  Anti-Bloat: Remove IPython usage in ``rdkit`` improving compile time
   for standalone by a lot. Fixed in 1.2.7 already.

-  Anti-Bloat: Avoid ``keras`` testing framework when using that
   package.

Organisational
==============

-  Plugins: The ``numpy`` plugin functionality was moved to Nuitka
   package configuration, and as a result, the plugin is now deprecated
   and devoid of functionality. On non-Windows, this removes unused
   duplications of the ``numpy.core`` DLLs.

-  User Manual: Added information about macOS entitlements and Windows
   console. These features are supported very well by Nuitka, but needed
   documentation.

-  UI: Remove alternative options from ``--help`` output. These are
   there often only for historic reasons, e.g. when an option was
   renamed. They should not bother users reading them.

-  Plugins: Expose the mnemonics option to plugin warnings function, and
   use it for ``pyside2`` and ``pyqt5`` plugins.

-  Quality: Detect trailing/leading spaces in Nuitka package
   configuration ``description`` values during their automatic check.

-  UI: Detect the CPython official flavor on Windows by comparing to
   registry paths and consider real prefixes, when being used in
   virtualenv more often, e.g. when checking for CPython on Apple.

-  UI: Enhanced ``--version`` output to include the C compiler
   selection. It is doing that respecting your other options, e.g.
   ``--clang``, etc. so it will be helpful in debugging setup issues.

   UI: Some error messages were using ``%r`` rather than ``'%s'`` to
   output file paths, but that escaped backslashes on Windows, making
   them look worse, so we changed away from this.

-  UI: Document more clearly what ``--output-dir`` actually controls.

-  macOS: Added options hint that the ``Foundation`` module requires
   bundle mode to be usable.

-  UI: Allow using both ``--follow-imports`` and ``--nofollow-imports``
   on command line rather than erroring out. Simply use what was given
   last, this allows overriding what was given in project options tests
   should the need arise.

-  Reports: Include plugin reasons for pre and post load modules
   provided. This solves a TODO and makes it easier to debug plugins.

-  UI: Handle ``--include-package-data`` before compilation, removing
   the ability to use pattern. This makes it easier to recognize
   mistakes without a long compilation and plugins can know them this
   way too.

-  GitHub: Migration workflows to using newer actions for Python and
   checkout. Also use newer Ubuntu LTS for Linux test runner.

-  UI: Catch user error of running Nuitka with the ``pythonw`` binary on
   Windows.

-  UI: Make it clear that MSYS2 defaults to ``--mingw64`` mode. It had
   been like this, but the ``--help`` output didn't say so.

-  GitHub: Updated contribution guidelines for better readability.

-  GitHub: Use organisation URLs everywhere, some were still pointing to
   the personal rather than the organisation one. While these are
   redirected, it is not good to have them like this.

-  Mastodon: Added link to https://fosstodon.org/@kayhayen to the PyPI
   package and User Manual.

Cleanups
========

-  Nodes for hard import calls of package meta data now have their base
   classes fully automatically created, replacing what was previously
   manual code. This aims at making them more consistent and easier to
   add.

-  When adding the new Scons file for C compiler version output, more
   values that are needed for both onefile and backend compilation were
   moved to centralized code, simplifying these somewhat again.

-  Remove unused ``main_module`` tag. It cannot happen that a module
   name matches, and still thinks of itself as ``__main__`` during
   compilation, so that idea was unnecessary.

-  Generate the dictionary copy variants from template code rather than
   having manual duplications. For ``dict.copy()``, for deep copy
   (needed e.g. when there are escaping mutable keyword argument
   constant values in say a function call), and for ``**kw`` value
   preparation in the called function (checking argument types), we have
   had diverged copies, that are now unified in a single Jinja2 template
   for optimization.

-  Plugins: Also allow providing generators for providing extra DLLs
   much like we already do for data files.

-  Naming of basic tests now makes sure to use a ``Test`` suffix, so in
   Visual Code selector they are more distinct from Nuitka code modules.

-  Rather than populating empty dictionaries, helper code now uses
   factory functions to create them, passing keys and values, and
   allowing values to be optional, removing noisy ``if`` branches at
   call side.

-  Removed remaining ``PyDev`` annotations, we don't need those anymore
   for a long time already.

-  Cleanup, avoid lists objects for ctypes defined functions and their
   ``arglist``, actually tuples are sufficient and naturally better to
   use.

-  Spelling cleanups were resumed, as an ongoing action.

Tests
=====

-  Added construct test that demonstrates the mutable constant argument
   passing for lists to see the performance gains in this area too.

-  Made construct runner ``--diff`` output usable for interactive usage.

-  Repaired Nuitka Speedcenter, but it's not yet too usable for general
   consumption. More work will be needed there, esp. to make comparisons
   more accessible for the general public.

Summary
=======

The major achievement of this release was the removal of the long lived
``numpy`` plug-in, replacing it with package based configuration, that
is even more optimal and works perfectly across all platforms on both
important package installation flavors.

This release has a lot of consolidation efforts, but also as a result of
3.11 investigations, addresses a lot of issues, that have crept in over
time with Python3 releases since 3.7, each time, something had not been
noticed. There will more need for investigation of relative performance
losses, but this should address the most crucial ones, and also takes
advantage of optimization that had become with 3.10 already.

There is also some initial results from cleanups with the composite node
tree structure, and how it is managed. Generated "child(ren) having"
mixins, allow for faster traversal of the node tree.

Some technical things also improved in Scons. Using multiple cores in
LTO with MSVC with help this a lot, although for big compilations
``--lto=no`` probably has to be recommended still.

More ``anti-bloat`` work on more packages rounds up the work.

For macOS specifically, the WebEngine support is crucial to some users,
and the new ``--macos-app-mode`` with more GUI friendly default resolves
long standing problems in this area.

And for MSYS2 and FreeBSD, support has been re-activated, so now 4 OSes
work extremely well (others too likely), and on those, most Python
flavors work well.

The performance and scalability improvements are going to be crucial.
It's a pity that 3.11 is not yet supported, but we will be getting
there.

********************
 Nuitka Release 1.2
********************

This release contains a large amount of new compatibility features and a
few new optimization, while again consolidating what we have.
Scalability should be better in many cases.

Bug Fixes
=========

-  Standalone: Added implicit dependency of ``thinc`` backend. Fixed in
   1.1.1 already.

-  Python3.10: Fix, ``match`` statements with unnamed star matches could
   give incorrect results. Fixed in 1.1.1 already.

      .. code:: python

         match x:
            case [*_, y]:
                  ... # y had wrong value here.

-  Python3.9+: Fix, file reader objects must convert to ``str`` objects.
   Fixed in 1.1.1 already.

      .. code:: python

         # This was the `repr` rather than a path value, but it must be usable
         # like that too.
         str(importlib.resources.files("package_name").joinpath("lala"))

-  Standalone: Added data file of ``echopype`` package. Fixed in 1.1.1
   already.

-  Anti-Bloat: Remove non-sense warning of compiled ``pyscf``. Fixed in
   1.1.1 already.

-  macOS: Fix, in LTO mode using ``incbin`` can fail, switch to source
   mode for constants resources. Fixed in 1.1.2 already.

-  Standalone: Add support for ``sv_ttk`` module. Fixed in 1.1.2
   already.

-  macOS: Fix, was no longer correcting ``libpython`` path, this was a
   regression preventing CPython for creating properly portable binary.
   Fixed in 1.1.2 already.

-  macOS: Fix, main binary was not included in signing command. Fixed in
   1.1.3 already.

-  Standalone: Added implicit dependency of ``orjson``. Due to
   ``zoneinfo`` not being automatically included anymore, this was
   having a segfault. Fixed in 1.1.3 already.

-  Standalone: Added support for new ``shapely``. Fixed in 1.1.4
   already.

-  macOS: Ignore extension module of non-matching architecture. Some
   wheels contain extension modules for only ``x86_64`` arch, and others
   contain them only for ``arm64``, preventing the standalone build.
   Fixed in 1.1.4 already.

-  Standalone: Added missing ``sklearn`` dependencies. Fixed in 1.1.4
   already.

-  Fix, packages available through relative import paths could be
   confused with the same ones imported by absolute paths. This should
   be very hard to trigger, by normal users, but was seen during
   development. Fixed in 1.1.4 already.

-  Standalone: Apply import hacks for ``pywin32`` modules only on
   Windows, otherwise it can break e.g. macOS compilation. Fixed in
   1.1.4 already.

-  Windows: More robust DLL dependency caching, otherwise e.g. a Windows
   update can break things. Also consider plugin contribution, and
   Nuitka version, to be absolutely sure, much like we already do for
   bytecode caching. Fixed in 1.1.4 already.

-  Standalone: Fix, ``seaborn`` needs the same workaround as ``scipy``
   for corruption with MSVC. Fixed in 1.1.4 already.

-  UI: Fix, the ``options-nanny`` was no longer functional and therefore
   failed to warn about non working options and package usages. Fixed in
   1.1.5 already.

-  macOS: Do not use extension modules of non-matching architecture.
   Fixed in 1.1.5 already.

-  Windows: Fix, resolving symlinks could fail for spaces in paths.
   Fixed in 1.1.6 already.

-  Standalone: Added missing DLL for ``lightgbm`` module. Fixed in 1.1.6
   already.

-  Compatibility: Respect ``super`` module variable. It is now possible
   to have a module level change of ``super`` but still get compatible
   behavior with Nuitka. Fixed in 1.1.6 already.

-  Compatibility: Make sure we respect ``super`` overloads in the
   builtin module. Fixed in 1.1.6 already.

-  Fix, the anti-bloat replacement code for ``numpy.testing`` was
   missing a required function. Fixed in 1.1.6 already.

-  Fix, ``importlib.import_module`` static optimization was mishandling
   a module name of ``.`` with a package name given. Fixed in 1.1.6
   already.

-  macOS: Fix, some extension modules use wrong suffixes in self
   references, we need to not complain about this kind of error. Fixed
   in 1.1.6 already.

-  Fix, do not make ``ctypes.wintypes`` a hard import on non-Windows.
   Nuitka asserted against it failing, where some code handles it
   failing on non-Windows platforms. Fixed in 1.1.6 already.

-  Standalone: Added data files for ``vedo`` package. Fixed in 1.1.7
   already.

-  Plugins: Fix, the ``gi`` plugin did always set ``GI_TYPELIB_PATH``
   even if already present from user code. Also it did not handle errors
   to detect its value during compile time. Fixed in 1.1.7 already.

-  Standalone: Added missing dependencies for ``sqlalchemy`` to have all
   SQL backends working. Fixed in 1.1.7 already.

-  Added support Nixpkgs's default non-writable ``HOME`` directory.
   Fixed in 1.1.8 already.

-  Fix, distribution metadata name and package name need not align, need
   to preserve the original looked up name from
   ``importlib.metadata.distribution`` call. Fixed in 1.1.8 already.

-  Windows: Fix, catch usage of unsupported ``CLCACHE_MEMCACHED`` mode
   with MSVC compilation. It is just unsupported.

-  Windows: Fix, file version was spoiled from product version if it was
   the only version given.

-  Windows: The default for file description in version information was
   not as intended.

-  Plugins: Workaround for PyQt5 as contained in Anaconda providing
   wrong paths from the build machine.

-  macOS: After signing a binary with a certificate, compiling the next
   one was crashing on a warning about initially creating an ad-hoc
   binary.

-  Fix, detect case of non-writable cache path, make explaining error
   exit rather than crashing attempting to write to the cache.

-  macOS: Added support for ``pyobjc`` in version 9.0 or higher.

New Features
============

-  Python3.11: For now prevent the execution with 3.11 and give a
   warning to the user for a not yet supported version. This can be
   overridden with ``--experimental=python311`` but at this times will
   not compile anything yet due to required and at this time missing
   core changes.

-  macOS: Added option ``--macos-sign-notarization`` that signs with
   runtime signature, but requires a developer certificate from Apple.
   As its name implies, this is for use with notarization for their App
   store.

-  DLLs used via ``delvewheel`` were so far only handled in the ``zmq``
   plugin, but this has been generalized to cover any package using it.
   With that, e.g. ``shapely`` just works. This probably helps many
   other packages as well.

-  Added ``__compiled__`` and ``__compiled_constant__`` attributes to
   compiled functions.

   With this, it can be decided per function what it is and bridges like
   ``pyobjc`` can use it to create better code on their side for
   constant value returning functions.

-  Added ``support_info`` check to Nuitka package format. Make it clear
   that ``pyobjc`` is only supported after ``9.0`` by erroring out if it
   has a too low version. It will not work at all before that version
   added support in upstream. Also using this to make it clear that
   ``opencv-python`` is best supported in version 4.6 or higher. It
   seems e.g. that video capture is not working with 4.5 at this time.

-  Added ``--report-template`` which can be used to provide Jinja2
   templates to create custom reports, and refer to built-in reports, at
   this time e.g. a license reports.

Optimization
============

-  Trust the absence of a few selected hard modules and convert those to
   static raises of import errors.

-  For conditional nodes where only one branch exits, and the other does
   not, no merging of the trace collection should happen. This should
   enhance the scalability and leads to more static optimization being
   done after these kinds of branches on variables assigned in such
   branches.

   .. code:: python

      if condition1:
         a = 1
      else:
         raise KeyError

      if condition2:
         b = 1

      # Here, "a" is known to be assigned, but before it was only "maybe"
      # assigned, like "b" would have to be since, the branch may or may
      # not have been taken.

-  Do not merge tried blocks that are aborting with an exception handler
   that is not aborting. This is very similar to the change for
   conditional statements, again there is a control flow branch, that
   may have to be merged with an optional part, but sometimes that part
   is not optional from the perspective of the code following.

   .. code:: python

      try:
         ... # potentially raising, but not aborting code
         return something() # this aborts
      except Exception:
         a = 1

      try:
         ... # potentially raising, but not aborting code
      except Exception:
         b = 1

      # Here, "a" is known to be assigned, but before it was only "maybe"
      # assigned, like "b" would have to be since, the branch may or may
      # not have been taken.

-  Exception matches were annotating a control flow escape and an
   exception exit, even when it is known that no error is possible to be
   happening that comparison.

   .. code:: python

      try:
         ...
      except ImportError: # an exception match is done here, that cannot raise
         ...

-  Trust ``importlib.metadata.PackageNotFoundError`` to exist, with this
   some more metadata usages are statically optimized. Added in 1.1.4
   already.

-  Handle constant values from trusted imports as trusted values. So
   far, trusted import values were on equal footing to regular
   variables, which on the module level could mean that no optimization
   was done, due to control flow escapes happening.

   .. code:: python

      # Known to be False at compile time.
      from typing import TYPE_CHECKING
      ...

      if TYPE_CHECKING:
         from something import normally_unused_unless_type_checking

   In this code example above, the static optimization was not done
   because the value may be changed on the outside. However, for trusted
   constants, this is no longer assumed to be happening. So far only
   ``if typing.TYPE_CHECKING:`` using code had been optimized.

-  macOS: Use sections for main binary constants binary blob rather than
   C source code (which we started in a recent hotfix due to LTO issues
   with incbin) and onefile payload. The latter enables notarization of
   the onefile binary as well and makes it faster to unpack as well.

-  Windows: Do not include DLLs from SxS. For PyPI packages these are
   generally unused, and self compiled modules won't be SxS
   installations either. We can add it back where it turns out needed.
   This avoids including ``comctl32`` and similar DLLs, which ought to
   come from the OS, and might impede backward compatibility only.

-  Disabled C compilation of very large ``azure`` modules.

-  The per module usage information of other modules was only updated in
   first pass was used in later passes. But since they can get optimized
   away, we have to update every time, avoiding to still include unused
   modules.

-  Anti-Bloat: Fight the use of ``dask`` in ``xarray`` and ``pint``,
   adding a mode controlling its use. This is however still incomplete
   and needs more work.

-  Fix, the anti-bloat configuration for ``rich.pretty`` introduced a
   ``SyntaxError`` that went unnoticed. In the future compilation will
   abort when this happens.

-  Standalone: Added support for including DLLs of ``llvmlite.binding``
   package.

-  Anti-Bloat: Avoid using ``pywin32`` through ``pkg_resources`` import.
   This seems rather pointless and follows an optimization done for the
   inline copy of Nuitka already, the ``ctypes`` code path works just
   fine, and this may well be the only reason why ``pywin32`` is
   included, which is by itself relatively large.

-  Cache directory contents when scanning for modules. The ``sys.path``
   and package directories were listed over and over, wasting time
   during the import analysis.

-  Optimization: Was not caching not found modules, but retrying every
   time for each usage, potentially wasting time during import analysis.

-  Anti-Bloat: Initial work to avoid ``pytest`` in patsy, it is however
   incomplete.

Organisational
==============

-  User Manual: Explain how to create 64/32 bits binaries on Windows,
   with there being no option to control it, this can otherwise be a bit
   unobvious that you have to just use the matching Python binary.

-  UI: Added an example for a cached onefile temporary location spec to
   the help output of ``--onefile-tempdir-spec`` to make cached more
   easy to achieve in the proper way.

-  UI: Quote command line options with space in value better, no need to
   quote an affected command line option in its entirety, and it looks
   strange.

-  macOS: Catch user error of disabling the console without using the
   bundle mode, as it otherwise it has no effect.

-  macOS: Warn about not providing an icon with disabled console,
   otherwise the dock icon is empty, which just looks bad.

-  Debian: Also need to depend on ``glob2`` packages which the yaml
   engine expects to use when searching for DLLs.

-  Debian: Pertain inline copies of modules in very old builds, there is
   e.g. no ``glob2`` for older releases, but only recent Debian releases
   need very pure packages, our backport doesn't have to do it right.

-  macOS: More reliable detection of Homebrew based Python. Rather than
   checking file system via its ``sitecustomize`` contents. The
   environment variables are only present to some usages.

-  Installations with pip did not include all license, README files,
   etc. which however was intended. Also the attempt to disable bytecode
   compilation for some inline copies was not effective yet.

-  Renamed ``pyzmq`` plugin to ``delvewheel`` as it is now absolutely
   generic and covers all uses of said packaging technique.

-  Caching: Use cache directory for cached downloads, rather than
   application directory, which is just wrong. This will cause all
   previously cached downloads to become unused and repeated.

-  Quality: Updated development requirements to latest ``black``,
   ``isort``, ``yamllint``, and ``tqdm``.

-  Visual Code: Added recommendation for extension for Debian packaging
   files.

-  Added warning for ``PyQt5`` usage, since its support is very
   incomplete. Made the ``PyQt6`` warning more concrete. It seems only
   Qt threading does not work, which is of course still significant.
   Instead PySide2 and PySide6 are recommended.

-  UI: Have dedicated options group for onefile, the spec for the
   temporary files is not a Windows option at all anymore. Also move the
   warnings group to the end, people need to see the inclusion related
   group first.

-  User Manual: Explain how to create 64/32 bits binaries on Windows,
   which is not too obvious.

Cleanups
========

-  Moved PySide plugins DLL search extra paths to the Yaml
   configuration. In this way it is not dependent on the plugin being
   active, avoiding cryptic errors on macOS when they are not found.

-  Plugins: Avoid duplicate link libraries due to casing. We are now
   normalizing the link library names, which avoids e.g. ``Shell32`` and
   ``shell32`` to be in the result.

-  Cleanups to prepare a PyLint update that so otherwise failed due to
   encountered issues.

-  Plugins: Pass so called build definitions for generically. Rather
   than having dedicated code for each, and plugins can now provide them
   and pass their index to the scons builds.

-  Onefile: Moved file handling code to common code reducing code
   duplication and heavily cleaning up the bootstrap code generally.

-  Onefile: The CRC32 checksum code was duplicated between constants
   blob and onefile, and has moved to shared code, with an actual
   interface to take the checksum.

-  Spelling cleanups resumed, e.g. this time more clearly distinguishing
   between ``run time`` and ``runtime``, the first is when the program
   executes, but the latter can be an environment provided by a C
   compiler.

Tests
=====

-  Tests: Added test that applies anti-bloat configuration to all found
   modules.

-  Tests: Tests: Avoid including unused ``nuitka.tools`` code in
   reflected test, which should make it faster. The compiler itself
   doesn't use that code.

Summary
=======

This release is again mainly a consolidation of previous release, as
well as finishing off existing features. Optimization added in previous
releases should have all regressions fixed now, again with a strong
series of hotfixes.

New optimization was focused around findings with static optimization
not being done, but still resulting in general improvements. Letting
static optimization drive the effort is still paying off.

Scalability has seen improvements through some of the optimization, this
time a lot less anti-bloat work has been done, and some things are only
started. The focus will clearly now shift to making this a community
effort. Expect postings that document the Yaml format we use.

For macOS specifically, with the sections work, onefile should launch
faster, should be more compatible with signing, and can now be used in
notarization, so for that platform, things are more round.

For Windows, a few issues with version information and onefile have been
addressed. We should be able to use memory mapped view on this platform
too, for faster unpacking of the payload, since it doesn't have to go
through the file anymore.

********************
 Nuitka Release 1.1
********************

This release contains a large amount of new compatibility features,
while consolidating what we have. Scalability should be better in some
cases.

Bug Fixes
=========

-  Standalone: Enhanced dependency scan of dependent DLLs to forward the
   containing package, so it can be searched in as well. This fixed at
   least PySide on macOS. Fixed in 1.0.1 already.

-  macOS: Enhanced dependency detection to use normalized paths and
   therefore to be more stable. Fixed in 1.0.1 already.

-  Standalone: Added support for the ``networkx`` package which uses new
   support for a function decorator trying to copy function default
   values. Fixed in 1.0.1 already.

-  Standalone: Include data files for ``pandas.io.format`` package. This
   one has Jinja2 template files that will be needed when using this
   package.

-  Python3.10: Fix, could crash in case a class was not giving ``match``
   arguments, but the user did attempt to match them. This happened e.g.
   with ``range`` objects. Fixed in 1.0.2 already.

-  Standalone: Added data files needed for ``pyenchant`` package. Fixed
   in 1.0.2 already.

-  Python3.10: Fix, matching sequence with ``as`` assignments in them
   didn't check for sub-pattern given. Fixed in 1.0.2 already.

-  Standalone: Fix, do not attempt to list non-existent ``PATH`` entries
   on Windows, these can crash the dependency detection otherwise. Fixed
   in 1.0.2 already.

-  Standalone: Fix, on newer Linux, ``linux-vdso.so.1`` appears in
   output of ``ldd`` in a way that suggests it may exist, which of
   course it does not, this is a kernel virtual DLL. Fixed in 1.0.3
   already.

-  Fix, comparison expressions could give wrong results as a regression
   of the new release. Fixed in 1.0.3 already.

-  Fix, on older Python (before 3.6), it could crash on data files
   defined in the Yaml config. Fixed in 1.0.4 already.

-  Fix, binary operations could give wrong results as a regression of
   the new release. Fixed in 1.0.4 already.

-  Standalone: Added support for ``pyzbar`` package. Fixed in 1.0.5
   already.

-  Standalone: Fix, empty directory structures were not working anymore
   due to a regression in the last release. Fixed in 1.0.5 already.

-  Windows: Fix, detected Pythons from Windows registry may of course
   fail to execute, because they were e.g. manually deleted. This would
   show e.g. in onefile compression. Fixed in 1.0.5 already.

-  Onefile: Fix, using a too old ``zstandard`` without finding another
   Python with a suitable one, lead to run time unpacking errors. Fixed
   in 1.0.6 already.

-  Fix, the inline copy of Jinja2 imported ``logging`` for no good
   reason, which lead to errors for users who have a module of the same
   name, that it was then using instead. Fixed in 1.0.6 already.

-  Fix, disable LTO mode for Anaconda Python, it is known to not work.
   Fixed in 1.0.6 already.

-  Linux: Fix, no need to insist on icon path for onefile anymore. Fixed
   in 1.0.6 already.

-  Standalone: Fix, the new version ``certifi`` was not working on
   Windows and 3.10 anymore. Fixed in 1.0.7 already.

-  Standalone: Added support for more ``rapidfuzz`` implicit
   dependencies. Fixed in 1.0.8 already.

-  Standalone: Added support for ``vibora``. Fixed in 1.0.8 already.

-  Fix, must not expose module name objects to Python import hooks.
   Fixed in 1.0.8 already.

-  Fix, calls to bound methods of string values generated incorrect
   calls. Fixed in 1.0.8 already.

-  Fix, do not crash in version detection on ``gcc`` error exit querying
   of its version.

-  Standalone: Added back support for older versions of the ``pyzmq``
   package.

-  Standalone: Ignore ``PATH`` elements that fail to be listed as a
   directory. It appears e.g. on Windows, folders can exist, despite
   being unusable in fact. These can then cause errors in DLL dependency
   scan. Also avoid having ``PATH`` set when executing dependency
   walker, it appears to use it even if not asked to.

-  Standalone: Added support for ``tzlocal`` package.

-  Python3.10: Fix, ``complex`` literals were not working for mappings
   in ``match`` statements.

-  Fix, ``bool`` built-in expressions were not properly annotating
   exception raises, where the value cannot raise on truth check.

-  Standalone: Added support for the ``agscheduler`` package. Plugins
   must be done manually still with explicit ``--include-module`` calls.

-  Standalone: Added support for using ``shapely`` in Anaconda as well.

-  Debian: Fix, versioned dependency for ``libzstd`` should also be in
   package, this should restore Nuitka package builds for Debian Jessie.

-  Standalone: Added support for ``vtk`` package.

-  Windows: Fix, avoid using ``pywin32`` in our appdirs usage, it might
   be a broken installation and is optional to ``appdirs`` anyway, which
   then will fallback to using ``ctypes`` to make the lookups.

-  Standalone: Added support for more ``pandas`` versions.

-  Standalone: Adding support for ``mkl`` implicit DLL usage in
   Anaconda.

-  Standalone: Added support for ``jsonschema`` with Python 3.10.

-  Standalone: Added support for ``pyfiglet`` fonts data files.

-  Scons: Avoid gcc linker command line length limits for module mode
   too.

-  Standalone: Added data file of ``distributed.config``.

-  Standalone: Add support for ``cv2`` GUI on Linux, the Qt platform
   plugin is now included.

-  Fix, the anti-bloat configuration for ``numpy.testing`` tools exposed
   an incomplete ``suppress_warnings`` replacement that could lead to
   errors in some functions of ``numpy``.

-  Standalone: Fix DLL dependency caching on Windows, need to consider
   DLL content of course too.

-  Standalone: Added missing dependency for ``torchvision``.

-  Standalone: Added support for ``torchvision`` on Anaconda as well.

-  Standalone: Added support for ``panda3d``.

-  Windows: Fix, need to make sure to use UTF-8 encoding for define
   values like company name. Otherwise the local system encoding is
   used, but the C compiler expects UTF-8 in wide literals. This may
   crash of give wrong results.

-  Standalone: Added ``facenet_torch`` data files.

-  Anaconda: Include ``libstdc++.so`` on Linux or else e.g. ``cv2`` will
   not work with system library.

-  Windows: Fix, can have file version without a company name.

New Features
============

-  Python3.10: Added support for assignments in ``match`` alternatives
   ``|`` syntax.

-  Compatibility: Register Nuitka meta path based loader with
   ``pkg_resources`` such that checking resource presence with
   ``has_resource`` works too. This should also add support for using
   ``jinja2.PackageLoader``, previously only ``jinja2.FileSystemLoader``
   worked. Fixed in 1.0.1 already.

-  Compatibility: Make function ``__defaults__`` attribute size
   changeable. For a long time, this was a relatively big issue for some
   packages, but now this is supported as well.

-  Compatibility: Added support for ``importlib.metadata.distribution``
   and ``importlib_metadata.distribution`` functions as well
   ``importlib.metadata.metadata`` and ``importlib_metadata.metadata``
   functions.

-  Onefile: Added support for including other binaries than the main
   executable in the payload. So far on non-Windows, we only made the
   main binary executable, hard coded, and nothing else. But Some
   things, e.g. Qt web engine, do require binaries to be used, and these
   no longer have the issue of missing x-bit on macOS and Linux now.

-  Standalone: Resolve executable path when called through symbolic
   link, which makes file resolutions work properly for it, for this
   type of installing it in ``%PATH%``.

-  Python3.9+: Added support for ``importlib.resources.files`` with
   compiled modules.

   It returns traversable objects, which can be used to opens files,
   checks them, etc. and this e.g. allows ``jsonschema`` to work with
   Python 3.10, despite bugs in CPython's compatibility layer.

-  UI: Added interface method to specify filename patterns with package
   data inclusion option, making ``--include-package-data`` usable in
   many more cases, picking the only files or file types you want. You
   can now use ``--include-package-data=package_name=*.txt`` and select
   only a subset of package data files in this way. Before this, it
   included everything and ``--noinclude-data-files`` would have to be
   used.

-  macOS: Make ``runtime`` signing an experimental option.

-  Consistently allow ``when`` conditions for all package configuration
   elements, e.g. also DLLs.

-  Plugins: Added method to overload to work on standalone binary
   specifically. This makes it easier to only modify that specific
   binary.

-  Plugins: Added support for regular expressions in anti-bloat
   replacements, with new ``replacements_re`` code.

Optimization
============

-  Add support for ``os.path`` hard module imports along with
   specialized nodes for file tests ``os.path.exists``,
   ``os.path.isfile``, and ``os.path.isdir`` aiming at tracking used
   files, producing warnings about missing files in the future.

-  Standalone: Do not include ``concurrent`` standard library package
   automatically. This avoids the inclusion of ``multiprocessing`` which
   we essentially had reverted during last release cycle.

-  Standalone: Do not include ``zoneinfo`` standard library package
   automatically. It has many data files and is often not used (yet).

-  Standalone: Do not include ``asyncio`` standard library package
   automatically anymore.

-  Avoid compilation of large generated codes in the ``asyncua``
   package.

-  Compile time optimize ``pkg_resources.iter_entry_points`` too, such
   that these can be used to resolve plugin modules, which helps with
   adding support for ``agscheduler`` package plugins. Note that these
   still need to be manually included with ``--include-module`` but now
   that works.

-  For known truth values of the right hand side of ``and`` or ``or``
   conditions, reduce the expression as far as possible.

-  Added dedicated assignment node for hard imports, which then are
   propagated in classes as well, allowing for more static optimization
   for code on the class level.

-  Added linker options to make static ``--static-libpython`` work with
   clang on Linux as well.

-  macOS: Make sure ``libpython`` is loaded relative to the executable.
   This is needed for at least Anaconda Python.

-  macOS: Fix, need to search environment specific DLL paths and only
   then global paths, otherwise mixed Python versions will not work
   correctly.

-  Anti-Bloat: Remove IPython usage in ``rich`` package.

-  Anti-Bloat: Avoid ``doctest`` dependency when using ``pyrect``.

-  Anti-Bloat: Some ``unittest`` removals from ``pytorch`` using
   libraries.

-  Keep the Scons report items sorted, or else it varies for the hashing
   of dependencies with Python versions before 3.6, causing cache misses
   without need.

Organisational
==============

-  UI: Output the ``.cmd`` file created (if any) on Windows, e.g. when
   run in a virtualenv or for uninstalled Python versions, it will
   otherwise not run in accelerated mode, but previously the output
   suggested to run the executable directly.

-  UI: Enhanced command line option description of
   ``--include-plugin-directory`` which is frequently misunderstood.
   That option barely does what people want it to do. Point them to
   using the other options that are easy to use and will work.

-  UI: Specified needed Python version for use in ``--python-for-scons``
   so users can know ahead of time what versions are suitable.

-  Reports: Added information about data files including, optimization
   times per module, active plugins.

-  Debugging: Repaired offline DLL dependency listing tool, such that it
   can be used during Windows DLL analysis.

-  Make ``--xml`` accept a filename for the node tree dump, and change
   it so it can be executed in addition to actual compilation. This way
   we need not be super-robust about keeping stdout clean, to not break
   XML parsing.

-  Plugins: Avoid useless warning about PySide2 plugin usage if another
   Qt plugin is actually selected.

-  UI: Catch error of directories being used as data files where plain
   files are expected and point out that other options must be used.

-  User Manual: Added section about accessing files in standalone mode
   too, so people can make sure it works properly.

-  Onefile: Using ``%TEMP%`` folder should not by itself prevent cached
   onefile mode, only really variable paths should. People may want to
   have this as some kind of temporary cache still.

-  UI: Catch user error of using elements, that resolve to absolute
   values in the middle of path specs, so using e.g.
   ``something/%PROGRAM%`` is now a mistake caught at compile time.
   These values can only be at the start of spec values naturally.

-  Quality: Updated to newer version of ``rstfmt``.

-  UI: Nicer error message when a forbidden import is requested as an
   implicit import by a plugin.

-  Python3.11: Adapted to allocator and exception state changes, but
   more will be needed to compile at all.

-  Visual Code: Find ``clang-format`` from the recommended C++ extension
   of Visual Code, which makes it finally available on macOS easily too.

-  UI: Quote command line argument values as necessary when stating them
   in the logging. Otherwise they are not directly usable on the shell
   and also less readable.

-  Debian: Do not list fake modules as used debian packages codes, which
   could e.g. happen with the pre-load code of ``pkg_resources`` if that
   is from a Debian package. Fake packages should not be mentioned for
   these lists though.

-  Nuitka-Python: Added support to set link time flags coming from
   statically included packages.

-  For our ``isort`` trick of splitting files in two parts (mostly to
   setup import paths for ``nuitka`` package), make sure the second
   parts starts with a new line.

-  Added more usable form ``--output-filename`` to specify the output
   filename, the short form has become barely usable after we switched
   to enforcing no space separation for command line arguments.

-  UI: Check if output filename's directory exists ahead of time, and
   error exit if not, otherwise compilation crashed only in the very
   end, trying to create the final result.

-  UI: When exiting with no error code, do not use red color or
   ``FATAL`` error annotation, that is not justified.

-  Quality: Make sure the Yaml auto-format does not change effective
   contents.

-  Quality: Added ability to limit autoformat by file type, which can be
   handy when e.g. only the yaml files should be scanned.

-  UI: Removed ``--windows-onefile-tempdir-spec`` alias of
   ``--onefile-tempdir-spec`` option, it is no longer Windows specific.

Cleanups
========

-  Prefer single quotes rather than double quotes in our package
   configuration Yaml files, otherwise esp. regular expressions with
   escapes become very confusing.

-  Move import hacks to general mechanism in Yaml package configuration
   files. This is for extra paths from package names or from directory
   paths relative to the package. This removes special purpose code from
   core code paths and allows their reuse.

-  Again more spelling cleanups have been done, to make the code cleaner
   to read and search.

-  Unified how plugins treat iteration over their value list, and how
   the ``when`` condition is applied for the various kinds of sections.

-  Output compilation command that failed during coverage taking, which
   makes it unnecessary to attempt to reconstruct what happened from
   test modes.

Tests
=====

-  Added coverage for comparisons that need argument swaps.

-  Allow more time in onefile keyboard signal test, otherwise it can be
   a race on slow machines, e.g. emulated machines.

-  Tests: Added support for running a local web server.

Summary
=======

This release is mainly a consolidation of previous release. Optimization
added in previous release did in fact introduce regressions, that needed
to be addressed and were cause for relatively many hotfixes.

The Yaml nuitka package configuration feature is getting ever more
powerful, but is not one bit more documented, such that the community as
a whole is not yet capable of adding missing dependencies, data files,
DLLs, and even anti-bloat patches.

New optimization was focused around compatibility with very few
exceptions, where the non-automatic standard library work is standing
out, and allows for smaller binaries in many cases.

Scalability has seen improvements through a few optimization, but mainly
again with anti-bloat work being done. This is owed to the fact that
consolidation was the name of the game.

For Anaconda specifically, a lot more software is covered, and
generally, ``cv2`` and ``torch`` related tools are now working better,
but it seems DLL handling will remain problematic in many instances.

The compilation report contains much more information and is getting
there is terms of completeness. At some point, we should ask for it in
bug reports.

********************
 Nuitka Release 1.0
********************

This release contains a large amount of new features, while
consolidating what we have with many bug fixes. Scalability should be
dramatically better, as well as new optimization that will accelerate
some code quite a bit. See the summary, how this release is paving the
way forward.

Bug Fixes
=========

-  Python3: Fix, ``bytes.decode`` with only ``errors`` argument given
   was not working. Fixed in 0.9.1 already.

-  MSYS2: Fix, the accelerate mode ``.cmd`` file was not working
   correctly. Fixed in 0.9.1 already.

-  Onefile: Fix, the bootstrap when waiting for the child, didn't
   protect against signals that interrupt this call. This only affected
   users of the non-public ``--onefile-tempdir`` option on Linux, but
   with that becoming the default in 1.0, this was discovered. Fixed in
   0.9.1 already.

-  Fix, ``pkg_resources`` compile time generated ``Distribution`` values
   could cause issues with code that put it into calls, or in tried
   blocks. Fixed in 0.9.1 already.

-  Standalone: Added implicit dependencies of ``Xlib`` package. Fixed in
   0.9.1 already.

-  macOS: Fix, the package configuration for ``wx`` had become invalid
   when restructuring the Yaml with code and schema disagreeing on
   allowed values. Fixed in 0.9.1 already.

-  Fix: The ``str.format`` with a single positional argument didn't
   generate proper code and failed to compile on the C level. Fixed in
   0.9.1 already.

-  Fix, the type shape of ``str.count`` result was wrong. Fixed in 0.9.1
   already.

-  UI: Fix, the warning about collision of just compiled package and
   original package in the same folder hiding the compiled package
   should not apply to packages without an ``__init__.py`` file, as
   those do **not** take precedence. Fixed in 0.9.2 already.

-  Debugging: Fix, the fallback to ``lldb`` from ``gdb`` when using the
   option ``--debugger`` was broken on anything but Windows. Fixed in
   0.9.2 already.

-  Python3.8: The module ``importlib.metadata`` was not recognized
   before 3.9, but actually 3.8 already has it, causing the compile time
   resolution of package versions to not work there. Fixed in 0.9.3
   already.

-  Standalone: Fix, at least on macOS we should also scan from parent
   folders of DLLs, since they may contain sub-directories in their
   names. This is mostly the case, when using frameworks. Fixed in 0.9.2
   already.

-  Standalone: Added package configuration for ``PyQt5`` to require
   onefile bundle mode on macOS, and recommend to disable console for
   PyQt6. This is same as we already do for ``PySide2`` and ``PySide6``.
   Fixed in 0.9.2 already.

-  Standalone: Removed stray macOS onefile bundle package configuration
   for ``pickle`` module which must have been added in error. Fixed in
   0.9.2 already.

-  UI: Catch user error of attempting to compile the ``__init__.py``
   rather than the package directory. Fixed in 0.9.2 already.

-  Fix, hard name import nodes failed to clone, causing issues in
   optimization phase. Fixed in 0.9.2 already.

-  Fix, avoid warnings given with gcc 11. Fixed in 0.9.2 already.

-  Fix, dictionary nodes where the operation itself has no effect, e.g.
   ``dict.copy`` were not properly annotating that their dictionary
   argument could still cause a raise and have side effects, triggering
   an assertion violation in Nuitka. Fixed in 0.9.2 already.

-  Standalone: Added ``pynput`` implicit dependencies on Linux. Fixed in
   0.9.2 already.

-  Fix, boolean condition checks on variables converted immutable
   constant value assignments to boolean values, leading to incorrect
   code execution. Fixed in 0.9.2 already.

-  Python3.9: Fix, could crash on generic aliases with non-hashable
   values. Fixed in 0.9.3 already.

   .. code:: python

      dict[str:any]

-  Python3: Fix, an iteration over ``sys.version_info`` was falsely
   optimized into a tuple, which is not always compatible. Fixed in
   0.9.3 already.

-  Standalone: Added support for ``xgboost`` package. Fixed in 0.9.3
   already.

-  Standalone: Added data file for ``text_unidecode`` package. Fixed in
   0.9.4 already.

-  Standalone: Added data files for ``swagger_ui_bundle`` package. Fixed
   in 0.9.4 already.

-  Standalone: Added data files for ``connexion`` package. Fixed in
   0.9.4 already.

-  Standalone: Added implicit dependencies for ``sklearn.utils`` and
   ``rapidfuzz``. Fixed in 0.9.4 already.

-  Python3.10: Fix, the reformulation of ``match`` statements could
   create nodes that are used twice, causing code generation to assert.
   Fixed in 0.9.4 already.

-  Fix, module objects removed from ``sys.modules`` but still used could
   lack a reference to themselves, and therefore crash due to working on
   a released module variables dictionary. Fixed in 0.9.5 already.

-  Fix, the MSVC compiles code generated for SciPy 1.8 wrongly. Added a
   workaround for that code to avoid triggering it. Fixed in 0.9.6
   already.

-  Fix, calls to ``str.format`` where the result is not used, could
   crash the compiler during code generation. Fixed in 0.9.6 already.

-  Standalone: For DLLs on macOS and Anaconda, also consider the ``lib``
   directory of the root environment, as some DLLs are otherwise not
   found.

-  Fix, allow ``nonlocal`` and ``global`` for ``__class__`` to be used
   on the class level.

-  Fix, ``xrange`` with large values didn't work on all platforms. This
   affected at least Python2 on macOS, but potentially others as well.

-  Windows: When scanning for installed Pythons to e.g. run Scons or
   onefile compression, it was attempting to use installations that got
   deleted manually and could crash.

-  macOS: Fix, DLL conflicts are now resolved by checking the version
   information too, also all cases that previously errored out after a
   conflict was reported, will now work.

-  Fix, conditional expressions whose statically decided condition
   picking a branch will raise an exception could crash the compilation.

   .. code:: python

      # Would previously crash Nuitka during optimization.
      return 1/0 if os.name == "nt" else 1/0

-  Windows: Make sure we set C level standard file handles too

   At least newer subprocess was affected by this, being unable to
   provide working handles to child processes that pass their current
   handles through, and also this should help DLL code to use it as
   level.

-  Standalone: Added support for ``pyqtgraph`` data files.

-  Standalone: Added support for ``dipy`` by anti-bloat removal of its
   testing framework that wants to do unsupported stuff.

-  UI: Could still give warnings about modules not being followed, where
   that was not true.

-  Fix, ``--include-module`` was not working for non-automatic standard
   library paths.

New Features
============

-  Onefile: Recognize a non-changing path from
   ``--onefile-tempdir-spec`` and then use cached mode. By default a
   temporary folder is used in the spec value, make it delete the files
   afterwards.

   The cached mode is not necessarily faster, but it is not going to
   change files already there, leaving the binaries there intact. In the
   future it may also become faster to execute, but right now checking
   the validity of the file takes about as long as re-creating it,
   therefore no gain yet. The main point, is to not change where it runs
   from.

-  Standalone: Added option to exclude DLLs. You can npw use
   ``--noinclude-dlls`` to exclude DLLs by filename patterns.

   The may e.g. come from Qt plugins, where you know, or experimented,
   that it is not going to be used in your specific application. Use
   with care, removing DLLs will lead to very hard to recognize errors.

-  Anaconda: Use ``CondaCC`` from environment variables for Linux and
   macOS, in case it is installed. This can be done with e.g. ``conda
   install gcc_linux-64`` on Linux or ``conda install clang_osx-64`` on
   macOS.

-  Added new option ``--nowarn-mnemonic`` to disable warnings that use
   mnemonics, there is currently not that many yet, but it's going to
   expand. You can use this to acknowledge the ones you accept, and not
   get that warning with the information pointer anymore.

-  Added method for resolving DLL conflicts on macOS too. This is using
   version information and picks the newer one where possible.

-  Added option ``--user-package-configuration-file`` for user provided
   Yaml files, which can be used to provide package configuration to
   Nuitka, to e.g. add DLLs, data files, do some anti-bloat work, or add
   missing dependencies locally. The documentation for this does not yet
   exist though, but Nuitka contains a Yaml schema in the
   ``misc/nuitka-package-config-schema.json`` file.

-  Added ``nuitka-project-else`` to avoid repeating conditions in Nuitka
   project configuration, this can e.g. be used like this:

   .. code:: python

      # nuitka-project-if: os.getenv("TEST_VARIANT", "pyside2") == "pyside2":
      #   nuitka-project: --enable-plugin=no-qt
      # nuitka-project-else:
      #   nuitka-project: --enable-plugin=no-qt
      #   nuitka-project: --noinclude-data-file=*.svg

   Previously, the inverted condition had to be used in another
   ``nuitka-project-if`` which is no big deal, but less readable.

-  Added support for deep copying uncompiled functions. There is now a
   section in the User Manual that explains how to clone compiled
   functions. This allows a workaround like this:

   .. code:: python

      def binder(func, name):
         try:
            result = func.clone()
         except AttributeError:
            result = types.FunctionType(func.__code__, func.__globals__, name=func.__name__, argdefs=func.__defaults__, closure=func.__closure__)
            result = functools.update_wrapper(result, func)
            result.__kwdefaults__ = func.__kwdefaults__

         result.__name__ = name
         return result

-  Plugins: Added explicit deprecation status of a plugin. We now have a
   few that do nothing, and are just there for compatibility with
   existing users, and this now informs the user properly rather than
   just saying it is not relevant.

-  Fix, some Python installations crash when attempting to import
   modules, such as ``os`` with a ``ModuleName`` object, because we
   limit string operations done, and e.g. refuse to do ``.startswith``
   which of course, other loaders that your installation has added,
   might still use.

-  Windows: In case of not found DLLs, we can still examine the run time
   of the currently compiling Python process of Nuitka, and locate them
   that way, which helps for some Python configurations to support
   standalone, esp. to find CPython DLL in unusual spots.

-  Debian: Workaround for ``lib2to3`` data files. These are from stdlib
   and therefore the patched code from Debian needs to be undone, to
   make these portable again.

Optimization
============

-  Scalability: Avoid merge traces of initial variable versions, which
   came into play when merging a variable used in only one branch. These
   are useless and only made other optimization slower or impossible.

-  Scalability: Also avoid merge traces of merge traces, instead flatten
   merge traces and avoid the duplication doing so. There were
   pathological cases, where this reduced optimization time for
   functions from infinite to instant.

-  For comparison helpers, switch comparison where possible, such that
   there are only 3 variants, rather than 6. Instead the boolean result
   is inverted, e.g. changing ``>=`` into ``not <`` effectively. Of
   course this can only be done for types, where we know that nothing
   special, i.e. no method overloads of ``__gte__`` is going on.

-  For binary operations that are commutative with the selected types,
   in mixed type cases, swap the arguments during code generation, such
   that e.g. ``long_a + float_b`` is actually computed as ``float_b +
   long_a``. This again avoids many helpers. It also can be done for
   ``*`` with integers and container types.

-  In cases, where a comparison (or one of the few binary operation
   where we consider it useful), is used in a boolean context, but we
   know it is impossible to raise an exception, a C boolean result type
   is used rather than a ``nuitka_bool`` which is now only used when
   necessary, because it can indicate the exception result.

-  Anti-Bloat: More anti-bloat work was done for popular packages,
   covering also uses of ``setuptools_scm``, ``nose`` and ``nose2``
   package removals and warnings. There was also a focus on making
   ``mmvc``, ``tensorflow`` and ``tifffile`` compile well, removing e.g.
   the uses of the tensorflow testing framework.

-  Faster comparison of ``int`` values with constant values, this uses
   helpers that work with C ``long`` values that represent a single
   "digit" of a value, or ones that use the full value space of C
   ``long``.

-  Faster comparison of ``float`` values with constant values, this uses
   helpers that work with C ``float`` values, avoiding the useless
   Python level constant objects.

-  Python2: Comparison of ``int`` and ``long`` now has specialized
   helpers that avoids converting the ``int`` to a ``long`` through
   coercion. This takes advantage of code to compare C ``long`` values
   (which are at the core of Python2 ``int`` objects, with ``long``
   objects.

-  For binary operation on mixed types, e.g. ``int * bytes`` the slot of
   the first function was still considered, and called to give a
   ``Py_NotImplemented`` return value for no good reason. This also
   applies to mixed operations of ``int``, ``long``, and ``float``
   types, and for ``str`` and ``unicode`` values on Python2.

-  Added missing helper for ``**`` operation with floats, this had been
   overlooked so far.

-  Added dedicated nodes for ``ctypes.CDLL`` which aims to allow us to
   detect used DLLs at compile time in the future, and to move closer to
   support its bindings more efficiently.

-  Added specialized nodes for ``dict.popitem`` as well. With this, now
   all of the dictionary methods are specialized.

-  Added specialized nodes for ``str.expandtabs``, ``str.translate``,
   ``str.ljust``, ``str.rjust``, ``str.center``, ``str.zfill``, and
   ``str.splitlines``. While these are barely performance relevant, this
   completes all ``str`` methods, except ``removeprefix`` and
   ``removesuffix`` that are Python3.9 or higher.

-  Added type shape for result of ``str.index`` operation as well, this
   was missing so far.

-  Optimize ``str``, ``bytes`` and ``dict`` method calls through
   variables.

-  Optimize calls through variables containing e.g. mutable constant
   values, these will be rare, because they all become exceptions.

-  Optimize calls through variables containing built-in values,
   unlocking optimization of such calls, where it is assigned to a local
   variable.

-  For generated attribute nodes, avoid local doing import statements on
   the function level. While these were easier to generate, they can
   only be slow at run time.

-  For the ``str`` built-in annotate its value as derived from ``str``,
   which unfortunately does not allow much optimization, since that can
   still change many things, but it was still a missing attribute.

-  For variable value release nodes, specialize them by value type as
   well, enhancing the scalability, because e.g. parameter variable
   specific tests, need not be considered for all other variable types
   as well.

Organisational
==============

-  Plugins: Major changes to the Yaml file content, cleaning up some of
   the DLL configuration to more easy to use.

   The DLL configuration has two flavors, one from code and one from
   filename matching, and these got separated into distinct items in the
   Yaml configuration. Also how source and dest paths get provided got
   simplified, with a relative path now being used consistently and with
   sane defaults, deriving the destination path from where the module
   lives. Also what we called patterns, are actually prefixes, as there
   is still the platform specific DLL file naming appended.

-  Plugins: Move mode checks to dedicated plugin called
   ``options-nanny`` that is always enabled, giving also much cleaner
   Yaml configuration with a new section added specifically for these.
   It controls advice on the optional or required use of
   ``--disable-console`` and the like. Some packages, e.g. ``wx`` are
   known to crash on macOS when the console is enabled, so this advice
   is now done with saner configuration.

-  Plugins: Also for all Yaml configuration sub-items where is now a
   consistent ``when`` field, that allows checking Python version, OS,
   Nuitka modes such as standalone, and only apply configuration when
   matching this criterion, with that the anti-bloat options to allow
   certain bloat, should now have proper effect as well.

-  The use of ``AppImage`` on Linux is no more. The performance for
   startup was always slower, while having lost the main benefit of
   avoiding IO at startup, due to new cached mode, so now we always use
   the same bootstrap binary as on macOS and Windows.

-  UI: Do not display implicit reports reported by plugins by default
   anymore. These have become far too many, esp. with the recent stdlib
   work, and often do not add any value. The compilation report will
   become where to turn to find out why a module in included.

-  UI: Ask the user to install the ordered set package that will
   actually work for the specific Python version, rather than making him
   try one of two, where sometimes only one can work, esp. with Python
   3.10 allowing only one.

-  GitHub: More clear wording in the issue template that ``python -m
   nuitka --version`` output is really required for support to given.

-  Attempt to use Anaconda ``ccache`` binary if installed on
   non-Windows. This is esp. handy on macOS, where it is harder to get
   it.

-  Windows: Avoid byte-compiling the inline copy of Scons that uses
   Python3 when installing for Python2.

-  Added experimental switches to disable certain optimization in order
   to try out their impact, e.g. on corruption bugs.

-  Reports: Added included DLLs for standalone mode to compilation
   report.

-  Reports: Added control tags influencing plugin decisions to the
   compilation report.

-  Plugins: Make the ``implicit-imports`` dependency section in the Yaml
   package configuration a list, for consistency with other blocks.

-  Plugins: Added checking of tags such from the package configuration,
   so that for things dependent on python version (e.g.
   ``python39_or_higher``, ``before_python39``), the usage of Anaconda
   (``anaconda``) or certain OS (e.g. ``macos``), or modes (e.g.
   ``standalone``), expressions in ``when`` can limit a configuration
   item.

-  Quality: Re-enabled string normalization from black, the issues with
   changes that are breaking to Python2 have been worked around.

-  User Manual: Describe using a minimal virtualenv as a possible help
   low memory situations as well.

-  Quality: The yaml auto-format now properly preserves comments, being
   based on ``ruamel.yaml``.

-  Nuitka-Python: Added support for the Linux build with Nuitka-Python
   for our own CPython fork as well, previously only Windows was
   working, amd macOS will follow later.

-  The commit hook when installed from git bash was working, but doing
   so from ``cmd.exe`` didn't find a proper path for shell from the
   ``git`` location.

-  Debugging: A lot of experimental toggles were added, that allow
   control over the use of certain optimization, e.g. use of dict, list,
   iterators, subscripts, etc. internals, to aid in debugging in
   situations where it's not clear, if these are causing the issue or
   not.

-  Added support for Fedora 36, which requires some specific linker
   options, also recognize Fedora based distributions as such.

-  Removed long deprecated option ``--noinclude-matplotlib`` from numpy
   plugin, as it hasn't had an effect for a long time now.

-  Visual Code: Added extension for editing Jinja2 templates. This one
   even detects that we are editing C or Python and properly highlights
   accordingly.

Cleanups
========

-  Standalone: Major cleanup of the dependency analysis for standalone.
   There is no longer a distinction between entry points (main binary,
   extension modules) and DLLs that they depend on. The OS specific
   parts got broken out into dedicated modules as well and decisions are
   now taken immediately.

-  Plugins: Split the Yaml package configuration files into 3 files. One
   contains now Python2 only stdlib configuration, and another one
   general stdlib.

-  Plugins: Also cleanup the ``zmq`` plugin, which was one the last
   holdouts of now removed plugin method, moving parts to the Yaml
   configuration. We therefore no longer have ``considerExtraDlls``
   which used to work on the standalone folder, but instead only plugin
   code that provides included DLL or binary objects from
   ``getExtraDlls`` which gives Nuitka much needed control over DLL
   copying. This was a long lasting battle finally won, and will allow
   many new features to come.

-  UI: Avoid changing whitespace in warnings, where we have intended
   line breaks, e.g. in case of duplicate DLLs. Went over all warnings
   and made sure to either avoid new-lines or have them, depending on
   wanted output.

-  Iterator end check code now uses the same code as rich comparison
   expressions and can benefit from optimization being done there as
   well.

-  Solved TODO item about code generation time C types to specify if
   they have error checking or not, rather than hard coding it.

-  Production of binary helper function set was cleaned up massively,
   but still needs more work, comparison helper function set was also
   redesigned.

-  Changing the spelling of our container package to become more clear.

-  Used ``namedtuple`` objects for storing used DLL information for more
   clear code.

-  Added spellchecker ignores for all attribute and argument names of
   generated fixed attribute nodes.

-  In auto-format make sure the imports float to the top. That very much
   cleans up generated attribute nodes code, allowing also to combine
   the many ones it makes, but also cleans up some of our existing code.

-  The package configuration Yaml files are now sorted according to
   module names. This will help to avoid merge conflicts during hotfixes
   merge back to develop and automatically group related entries in a
   sane way.

-  Moved large amounts of code producing implicit imports to Yaml
   configuration files.

-  Changed the ``tensorflow`` plugin to Yaml based configuration, making
   it a deprecated do nothing plugin, that only remains there for a few
   releases, to not crash existing build scripts.

-  Lots of spelling cleanups, e.g. renaming ``nuitka.codegen`` to
   ``nuitka.code_generation`` for clarity.

Tests
=====

-  Added generated test to cover ``bytes`` method. This would have found
   the issue with ``decode`` potentially.

-  Enhanced standalone test for ``ctypes`` on Linux to actually have
   something to test.

Summary
=======

This release improves on many things at once. A lot of work has been put
into polishing the Yaml configuration that now only lacks documentation
and examples, such that the community as a whole should become capable
of adding missing dependencies, data files, DLLs, and even anti-bloat
patches.

Then a lot of new optimization has been done, to close the missing gaps
with ``dict`` and ``str`` methods, but before completing ``list`` which
is already a work in progress pull request, and ``bytes``, we want to
start and generate the node classes that form the link or basis of
dedicated nodes. This will be an area to work on more.

The many improvements to existing code helpers, and them being able to
pick target types for the arguments of comparisons and binary
operations, is a pre-cursor to universal optimization of this kind. What
is currently only done for constant values, will in the future be
interesting for picking specific C types for use. That will then be a
huge difference from what we are doing now, where most things still have
to use ``PyObject *`` based types.

Scalability has again seen very real improvements, memory usage of
Nuitka itself, as well as compile time inside Nuitka are down by a lot
for some cases, very noticeably. There is never enough of this, but it
appears, in many cases now, large compilations run much faster.

For macOS specifically, the new DLL dependency analysis, is much more
capable or resolving conflicts all by itself. Many of the more complex
packages with some variants of Python, specifically Anaconda will now be
working a lot better.

And then, of course there is the big improvement for Onefile, that
allows to use cached paths. This will make it more usable in the general
case, e.g. where the firewall of Windows hate binaries that change their
path each time they run.

Future directions will aim to make the compilation report more concise,
and given reasons and dependencies as they are known on the inside more
clearly, such that is can be a major tool for testing, bug reporting and
analysis of the compilation result.

********************
 Nuitka Release 0.9
********************

This release has a many optimization improvements, and scalability
improvements, while also adding new features, with also some important
bug fixes.

Bug Fixes
=========

-  Fix, hard module name lookups leaked a reference to that object.
   Fixed in 0.8.1 already.

-  Python2: Fix, ``str.decode`` with ``errors`` as the only argument
   wasn't working. Fixed in 0.8.1 already.

-  Fix, could corrupt created uncompiled class objects ``__init__``
   functions in case of descriptors being used.

-  Standalone: Added support for newer ``torch``. Fixed in 0.8.1
   already.

-  Standalone: Added support for newer ``torchvision``. Fixed in 0.8.1
   already.

-  Fix, could compile time crash during initial parsing phase on
   constant dictionary literals with non-hashable keys.

   .. code:: python

      { {}:1, }

-  Fix, hard imported sub-modules of hard imports were falsely resolved
   to their parent. Fixed in 0.8.3 already.

   .. code:: python

      importlib.resources.read_bytes() # gave importlib has no attribute...

-  Windows: Fix, outputs with ``--force-stdout-spec`` or
   ``--force-stderr-spec`` were created with the file system encoding on
   Python3, but they nee to be ``utf-8``.

-  Fix, didn't allow zero spaces in Nuitka project options, which is not
   expected.

-  Modules: Fix, the ``del __file__`` in the top level module in module
   mode caused crashes at run time, when trying to restore the original
   ``__file__`` value, after the loading CPython corrupted it.

-  Python2.6: Fixes for installations without ``pkg_resources``.

-  Windows: Fix for very old Python 2.6 versions, these didn't have a
   language assigned that could be used.

-  Security: Fix for `CVE-2022-2054
   <https://security-tracker.debian.org/tracker/CVE-2022-2054>`__ where
   environment variables used for transfer of information between Nuitka
   restarting itself, could be used to execute arbitrary code at compile
   time.

-  Anaconda: Fix, the torch plugin was not working on Linux due to
   missing DLL dependencies.

-  Fix, static optimization of ``importlib.import_module`` with a
   package given, for an absolute import was optimized into the wrong
   import, package was not ignored as it should be.

-  Windows: Installed Python scan could crash on trying installation
   paths from registry that were manually removed in the mean time, but
   not through an uninstaller.

-  Standalone: Added missing implicit dependency for ``pyreadstat``
   because parts of standard library it uses are no more automatically
   included.

-  Windows: Could still crash when no ``powershell`` is available with
   symlinks, handle this more gracefully.

-  Standalone: Added more missing Plotly dependencies, but more work
   will be needed to complete this.

-  Standalone: Add missing stdlib dependency on ``multiprocessing`` by
   ``concurrent.futures.process``.

-  Standalone: Fix, implicit dependencies assigned to ``imageio`` on PIL
   plugins should actually be assigned to ``PIL.Image`` that actually
   loads them, so it works outside of ``imageio`` too.

New Features
============

-  UI: Added new option ``--user-package-configuration-file`` to allow
   users to provide extra Yaml configuration files for the Nuitka plugin
   mechanism to add hidden dependencies, anti-bloat, or data files, for
   packages. This will be useful for developing PRs to the standard file
   of Nuitka. Currently the schema is available, but it is not
   documented very well yet, so not really ready for end users just yet.

-  Standalone: Added new ``no-qt`` plugin as an easy way to prevent all
   of the Qt bindings from being included in a compilation.

-  Include module search path in compilation report.

Optimization
============

-  Faster dictionary iteration with our own replacement for
   ``PyDict_Next`` that avoids the DLL call overhead (in case of
   non-static libpython) and does less unnecessary checks.

-  Added optimization for ``str.count`` and ``str.format`` methods as
   well, this should help in some cases with compile time optimization.

-  The node for ``dict.update`` with only an iterable argument, but no
   keyword arguments, was in fact unused due to wrongly generated code.
   Also the form with no arguments wasn't yet handled properly.

-  Scalability: Use specialized nodes for pair values, i.e. the
   representation of ``x = y`` in e.g. dictionary creations. With
   constant keys, and values, these avoid full constant value nodes, and
   therefore save memory and compile time for a lot of code.

-  Anti-Bloat: Added more scalability work to avoid including modules
   that make compilation unnecessarily big.

-  Python3.9+: Faster calls in case of mixed code, i.e. compiled code
   calling uncompiled code.

-  Removing duplicates and non-existent entries from modules search path
   should improve performance when locating modules.

-  Optimize calls through variables as well. These are needed for the
   package resource nodes to properly resolve at compile time from their
   hard imports to the called function.

-  Hard imported names should also be considered very trusted
   themselves, so they are e.g. also optimized in calls.

-  Anti-Bloat: Avoid more useless imports in Pandas, Numba, Plotly, and
   other packages, improving the scalability some more.

-  Added dedicated nodes for ``pkg_resources.require``,
   ``pkg_resources.get_distribution``, ``importlib.metadata.version``,
   and ``importlib_metadata.version``, so we can use compile time
   optimization to resolve their argument values where possible.

-  Avoid annotating control flow escape for all release statements.
   Sometimes we can tell that ``__del__`` will not execute outside code
   ever, so this then avoids marking values as escaped, and taking the
   time to do so.

-  Calls of methods through variables on ``str``, ``dict``, ``bytes``
   that have dedicated nodes are now also optimized through variables.

-  Boolean tests through variables now also are optimized when the
   original assignment is a compile time constant that is not mutable.
   This is only basic, but will allow tests on ``TYPE_CHECKING`` coming
   from a ``from typing import TYPE_CHECKING`` statement to be
   optimized, avoiding this overhead.

Cleanups
========

-  Changed to ``torch`` plugin to Yaml based configuration, making it
   obsolete, it only remains there for a few releases, to not crash
   existing build scripts.

-  Moved older package specific hacks to the Yaml file. Some of these
   were from hotfixes where the Yaml file wasn't yet used by default,
   but now there is no need for them anymore.

-  Removed most of the ``pkg-resources`` plugin work. This is now done
   during optimization phase and rather than being based on source code
   matches, it uses actual value tracing, so it immediately covers many
   more cases.

-  Continued spelling improvements, renaming identifiers used in the
   source that the cspell based extension doesn't like. This aims at
   producing more readable and searchable code.

-  Generated attribute nodes no longer do local imports of the operation
   nodes they refer to. This also avoids compile time penalties during
   optimization that are not necessary.

-  Windows: Avoid useless bytecode of inline copy used by Python3 when
   installing for Python2, this spams just a lot of errors.

Organisational
==============

-  Removed MSI installers from the download page. The MSI installers are
   discontinued as Python has deprecated their support for them, as well
   as Windows 10 is making it harder for users to install them. Using
   the PyPI installation is recommended on Windows.

-  Merged our Yaml files into one and added schema description, for
   completion and checking in Visual Code while editing. Also check the
   schema in ``check-nuitka-with-yamllint`` which is now slightly
   misnamed. The schema is in no way final and will see improvements in
   future releases.

-  UI: Nicer progress bar layout that avoids flicker when optimizing
   modules.

-  UI: When linking, output the total number of object files used, to
   have that knowledge after the progress bar for C compilation is gone.

-  Quality: Auto-format the package configuration Yaml file for
   anti-bloat, implicit dependencies, etc.

-  GitHub: Point out the commit hook in the PR template.

-  UI: Nicer output in case of no commercial version is used.

-  Updated the MinGW64 winlibs download used on Windows to the latest
   version based on gcc 11, the gcc 12 is not yet ready.

-  Git: Make sure we are not affected by ``core.autocrlf`` setting, as
   it interferes with auto-format enforcing Unix newlines.

-  Removed the MSI downloads. Windows 10 has made them harder to install
   and Python itself is discontinuing support for them, while often it
   was only used by beginners, for which it was not intended.

-  Anaconda: Make it more clear how to install static libpython with
   precise command.

-  UI: Warn about using module from Debian packages. These can be made
   non-portable to other OSes. Read more on `the info page
   <https://nuitka.net/info/debian-dist-packages.html>`__ for detailed
   information.

-  Quality: The auto-format now floats imports to the top for
   consistency. With few exceptions, it was already done like this. But
   it makes things easier for generated code.

Tests
=====

-  The reflected test was adapted to preserve ``PYTHONPATH`` now that
   module presence influences optimization.

Summary
=======

This release marks a point, that will allow us to open up the
compatibility work for implicit dependencies and anti-bloat stuff even
further. The Yaml format will need documentation and potentially more
refinement, but will open up a future, where latest packages can be
supported with just updating this configuration.

The scalability improvements really make a difference for many libraries
and are a welcome improvement on both memory usage and compile time.
They are achieved by an accord of static optimization of

One optimization aimed at optimizing tuple unpacking, was not finished
in time for this release, but will be subject of a future release. It
has driven many other improvements though.

Generally, also from the UI, this is a huge step forward. With links to
the website for complex topics being started, and the progress bar
flicker being removed, the tool has yet again become more user friendly.

********************
 Nuitka Release 0.8
********************

This release has a massive amount of bug fixes, builds on existing
features, and adds new ones.

Bug Fixes
=========

-  Windows: Fix, need to ignore cases where shorting in path for
   external use during compilation gives an permission error. Fixed in
   0.7.1 already.

-  Compatibility: Added workaround for ``scipy.stats`` function copying.
   Fixed in 0.7.1 already.

-  Windows: Fix, detect ARM64 arch of MSVC properly, such that we can
   give a proper mismatch for the Python architecture. Fixed in 0.7.1
   already.

-  Standalone: Fix, using ``importlib.metadata`` module failed to
   include ``email`` from standard library parts no longer included by
   default. Fixed in 0.7.1 already.

-  macOS: Fix, the dependency parser was using normalized paths where
   original paths must be used. Fixed in 0.7.1 already.

-  Standalone: Fix, using ``shiboken6`` module (mostly due to
   ``PySide6``) failed to include ``argparse`` from the standard library
   from standard library parts no longer included by default. Fixed in
   0.7.1 already.

-  Onefile: Fix, the detection of a usable Python for compression could
   crash. Fixed in 0.7.2 already.

-  Onefile: Adding the payload on Windows could run into locks still
   being held, need to wait in that case. Fixed in 0.7.2 already.

-  Fix, need to include ``pkg_resources`` as well, we need it for when
   we use Jinja2, which is more often now. For Python3 this was fixed in
   0.7.3 already. Later a version to use with Python2 was added as well.

-  Release: The wheels built for Nuitka when installed through URLs were
   not version specific, but due to different inline copies per OS and
   Python version, they must not be reused. Therefore we now pretend to
   contain an extension module, which handles that. Fixed in 0.7.3
   already.

-  Standalone: Fix, using ``urllib.requests`` module failed to include
   ``http.client`` from standard library parts no longer included by
   default. Fixed in 0.7.3 already. Later ``http.cookiejar`` was added
   too.

-  Standalone: Do not compress MSVC run time library when using ``upx``
   plugin, that is not going to work. Fixed in 0.7.4 already.

-  Standalone: Fix, on Windows more files should be included for TkInter
   to work with all software. Fixed in 0.7.5 already.

-  Distutils: Added support for ``package_dir`` directive to specify
   where source code lives. Fixed in 0.7.6 already.

-  Standalone: Fix, using ``shelve`` module failed to include ``dbm``
   from standard library parts no longer included by default. Fixed in
   0.7.6 already.

-  Standalone: Added support for ``arcade`` data files. Fixed in 0.7.7
   already.

-  Standalone: Fix, bytecode demotions should use relative filenames
   rather than original ones. Fixed in 0.7.7 already.

-  Standalone: Fix, must remove extension module objects from
   ``sys.modules`` before executing an extension module that will create
   it. This fixes cases of cyclic dependencies from modules loaded by
   the extension module.

-  Windows: In case of an exception, ``clcache`` was itself triggering
   one during its handling, hiding the real exception behind a
   ``TypeError``.

-  Windows: Improved ``clcache`` locking behavior, avoiding a race. Also
   increase characters used for key from 2 to 3 chars, making collisions
   far more rare.

-  Standalone: Added support for ``persistent`` package.

-  Standalone: Added support for newer ``tensorflow`` package.

-  Module: Fix, need to restore the ``__file__`` and ``__spec__`` values
   of top level module. It is changed by CPython after import to an
   incompatible file name, and not our loader, preventing package
   resources to be found.

-  Standalone: Added support for ``Crpytodome.Cipher.PKCS1_v1_5``.

-  Fix, ``pkgutil.iter_modules`` without arguments was not working
   properly with our meta path based loader.

-  Windows: Fix, could crash on when the Scons report was written due to
   directories in ``PATH`` that failed to encode.

-  Compatibility: Fix, positive ``divmod`` and modulo ``%`` with
   negative remainders of positive floats was not correct.

-  Fix, ``str.encode`` with only ``errors`` value, but default value for
   encoding was crashing the compilation.

-  Python3.10+: Fix, ``match`` statement sliced values must be lists,
   not tuples.

-  Standalone: Added support for newer ``glfw`` and ``OpenGL`` packages.

-  Python3: Fix, failed to read bytecode only stdlib files. This affect
   mostly Fedora Python which does this for encodings.

-  Python3.5+: Fix, two phase loading of modules could release it
   immediately.

-  Standalone: Added missing dependency for ``pydantic``.

-  Fix, the ``str.split`` rejected default ``sep`` value with only
   ``maxsplit`` given as a keyword argument.

-  Standalone: Added missing dependency of ``wsgiref`` module.

-  Standalone: Added support for ``falcon`` module.

-  Standalone: Added support for ``eliot`` module.

-  Fix, need to mark assigned from variables as escaped. Without it,
   some aliased loop variables could be misunderstood and falsely
   statically optimized.

-  Standalone: Added support for newer ``uvicorn`` package.

-  Standalone: Added data files for the ``accessible_output2``,
   ``babel``, ``frozendict``, and ``sound_lib`` package.

-  Standalone: Added support for newer ``sklearn`` package.

-  Standalone: Added support for ``tkinterdnd2`` package.

-  Python3.7+: Fix, the error message wasn't fully compatible for
   unsubscriptable type exception messages.

-  Standalone: Fix, ``idlelib`` from stdlib was always ignored.

-  Python3.4+: Fix, the ``__spec__.origin`` as produced by ``find_spec``
   of our meta path based loader, didn't have the correct ``origin``
   attribute value.

-  Standalone: Disable QtPDF plugin of PySide 6.3.0, because it's
   failing dependency checks. On macOS this was blocking, we will change
   it to detection if that is necessary in a future release.

-  Standalone: Added support for ``orderedmultidict``.

-  Standalone: Added support for ``clr`` module.

-  Standalone: Added support for newer ``cv2`` package.

New Features
============

-  Added new option ``--module-name-choice`` to select what value
   ``__name__`` and ``__package__`` are going to be. With
   ``--module-name-choice=runtime`` (default for ``--module`` mode), the
   created module uses the parent package to deduce the value of
   ``__package__``, to be fully compatible. The value
   ``--module-name-choice=original`` (default for other modes) allows
   for more static optimization to happen.

-  Added support for ``get_resource_reader`` to our meta path based
   loader. This allows to avoid useless temporary files in case
   ``importlib.resources.path`` is used, due to a bad interaction with
   the fallback implementation used without it.

-  Added support for ``--force-stdout-spec```and ``--force-stderr-spec``
   on all platforms, this was previously limited to Windows.

-  Added support for requiring and suggesting modes. In part this was
   added to 0.7.3 already, and is used e.g. to enforce that on macOS the
   ``wx`` will only work as a GUI program and crash unless
   ``--disable-console`` is specified. These will warn the user or
   outright error the compilation if something is known to be needed or
   useful.

-  Debian: Detect version information for "Debian Sid". Added in 0.7.4
   already, and also improved how Debian/Ubuntu versions are output.

-  Added new option ``--noinclude-data-files`` to instruct Nuitka to not
   include data files matching patterns given. Also attached loggers and
   tags to included data file and include them in the compilation
   report.

-  Distutils: When using ``pyproject.toml`` without ``setup.py`` so far
   it was not possible to pass arguments. This is now possible by adding
   a section like this.

   .. code:: toml

      [tool.nuitka]
      # options without an argument are passed as boolean value
      show-scons = true

      # options with single values, e.g. enable a plugin of Nuitka
      enable-plugin = "pyside2"

      # options with several values, e.g. avoiding including modules, accepts
      # list argument.
      nofollow-import-to = ["*.tests", "*.distutils"]

   The option names are the same, but without leading dashes. Lists are
   only needed when passing multiple values with the same option.

-  macOS: Add support for specifying signing identity with
   ``--macos-sign-identity`` and access to protected resources
   ``--macos-app-protected-resource``.

-  Included data files are now reported in the compilation report XML as
   well.

-  Accept absolute paths for searching paths of binaries. This allows
   e.g. the ``upx`` plugin to accept both a folder path and the full
   path including the binary name to work when you specify the binary
   location with ``--upx-binary`` making it more user friendly.

-  Python3.10: Added support for positional matching of classes, so far
   only keyword matching was working.

-  Added support for path spec values ``%CACHE_DIR``, ``%COMPANY%``,
   ``%PRODUCT%``, ``%VERSION%``, and ``%HOME`` in preparation of onefile
   once again being able to be cached and not unpacked repeatedly for
   each execution.

-  Standalone: Detect missing ``tk-inter`` plugin at run time. When TCL
   fails to load, it then outputs a more helpful error. This ought to be
   done for all plugins, where it's not clear if they are needed.

-  Anti-Bloat: Added support for plain replacements in the
   ``anti-bloat.yml`` file. Before with ``replacement```, the new value
   had to be produced by an ``eval``, which makes for less readable
   values due to extra quoting. for plain values.

Optimization
============

-  Python3.10+: Added support for ``ordered-set`` PyPI package to speed
   up compilation on these versions too, adding a warning if no
   accelerated form of ``OrderedSet`` is used, but believed to be
   usable.

-  Optimization: Added ``bytes.decode`` operations. This is only a start
   and we needed this for internal usage, more should follow later.

-  Much more ``anti-bloat`` work was added. Avoiding ``ipython``,
   ``unittest``, and sometimes even ``doctest`` usage for some more
   packages.

-  The ``ccache`` was not always used, sometimes it believed to catch a
   potential race, that we need to tell it to ignore. This will speed up
   re-compilation of the C side in many cases.

-  Do not compile the meta path based loader separate, which allows us
   to not expose functions and values only used by it. Also spares the C
   compiler one file.

-  Added various dedicated nodes for querying package resources data,
   e.g. ``pkgutil.get_data``. This will make it easier to detect cases
   of missing data files in the future.

-  Added more hard imports, some of which help scalability in the
   compilation, because these are then known to exist in standalone
   mode, others are used for package resource specific operations.

-  Onefile: Releasing decompression buffers avoiding unnecessary high
   memory usage of bootstrap binary.

-  Standalone: Avoid proving directories with no DLLs (e.g. from
   packages) towards ``ldd``, this should avoid exceeding command line
   limits.

-  For ``clcache`` remove writing of the stats file before Scons has
   completed, which avoids IO and locking churn.

-  Standalone: Avoid including ``wsgiref`` from stdlib by default.

Cleanups
========

-  Removed references to ``chrpath`` and dead code around it, it was
   still listed as a dependency, although we stopped using it a while
   ago.

-  Removed uses of ``anti-bloat`` in examples and tests, it is now
   enabled by default.

-  Made standard plugin file naming consistent, their name should be
   ``*Plugin.py``.

-  Cleaned up ``tensorflow`` plugin. The source modification was moved
   to ``anti-bloat`` where it is easy to do. The implicit dependencies
   are now in the config file of ``implicit-imports`` plugin.

-  Massive cleanups of data file handling in plugins. Adding methods for
   producing the now required objects.

-  The Scons file handling got further cleaned up and unified, doing
   more things in common code.

-  Avoid ``#ifdefs`` usages with new helper function
   ``Nuitka_String_FromFormat`` that implies them for more readable
   code.

-  Split the allowance check from the encountering. Allow plugins and
   options all to say if an import should be followed, and only when
   that is decided, to complain about it. Previously the attempt was
   causing an error, even if another plugin were to decide against it
   later.

-  Python2.6: Avoid warnings from MSVC for out specialized ``long``
   code. In testing it worked correctly, but this is more explicit and
   doesn't rely on C implementation specific behavior, although it
   appears to be universal.

Organisational
==============

-  UI: Warning tests are now wrapped to multiple lines if necessary.
   That makes it more accessible for larger messages that contain more
   guiding information.

-  Documented how to use local Nuitka checkout with ``pyproject.toml``
   files, this makes debugging Nuitka straightforward in these setups.

-  Added instructions on how to pass extra C and linker flags and to the
   User Manual.

-  Made our auto-format usable for the Nuitka website code too.

-  Removed dependencies on ``chrpath`` and the now dead code that would
   use it, we are happy with ``patchelf``.

-  Updated to latest versions of requirements for development, esp.
   ``black`` and ``pylint``.

-  Renamed ``--macos-onefile-icon`` to ``--macos-app-icon`` because that
   is what it is really used for.

-  Unified how dependencies are installed in GitHub actions.

-  Updated man page contents for option name changes from last releases.

-  Updated the MinGW64 winlibs download used on Windows to the latest
   version.

-  Updated the ``ccache`` binary used on Windows with MinGW64. This is
   in preparation of using it potentially for MSVC as well.

-  Updated Visual Code C config to use Python3.10 and MSVC 2022 include
   paths.

Tests
=====

-  Better outputs from standalone library compilation test, esp. when
   finding a problem, present the script to reproduce it immediately.

-  Enhanced generated tests to cover ``str`` methods to use keyword
   arguments.

-  Added automatic execution of ``pyproject.toml`` driven test case.

-  Enhanced output in case of ``optimization`` test failures, dumping
   what value is there that has not become a compile time constant.

Summary
=======

This release has seen a lot of consolidation. The plugins layer for data
files is now all powerful, allowing much nicer handling of them by the
plugins, they are better reported in normal output, and they are also
part of the report file that Nuitka can create. You may now also inhibit
their inclusion from the command line, if you decide otherwise.

The ``pyproject.toml`` now supporting Nuitka arguments is closing an
important gap.

Generally many features got more polished, e.g. non-automatic inclusion
of stdlib modules has most problems fixed up.

An important area of improvement, are the hard imports. These will be
used to replace the source based resolution of package requirements with
ones that are proper nodes in the tree. Getting these hard imports to
still retain full compatibility with existing imports, that are more or
less ``__import__`` uses only, was revealing quite a bit of technical
debt, that has been addressed with this release.

For onefile, the cached mode is being prepared with the variables added,
but will only be in a later release.

Also a bunch of new or upgraded packages are working now, and the push
for ``anti-bloat`` work has increased, making many compilations even
more lean, but scalability is still an issue.

********************
 Nuitka Release 0.7
********************

This release is massively improving macOS support, esp. for M1 and the
latest OS releases, but it also has massive improvements for usability
and bug fixes in all areas.

Bug Fixes
=========

-  Fix, ``set`` creation wasn't annotating its possible exception exit
   from hashing values and is not as free of side effects as ``list``
   and ``tuple`` creations are. Fixed in 0.6.19.1 already.

-  Windows: Fix, ``--experimental`` option values got lost for the C
   compilation when switching from MSVC to MinGW64, making them have no
   effect. Fixed in 0.6.19.1 already.

-  Windows: Fix, Clang from MinGW64 doesn't support LTO at this time,
   therefore default to ``no`` for it. Fixed in 0.6.19.1 already.

-  Debian: Fix, failed to detect Debian unstable as suitable for
   linking, it doesn't have the release number. Fixed in 0.6.19.1
   already.

-  Standalone: Added data files for ``pygsheets`` package. Fixed in
   0.6.19.2 already.

-  Fix, paths from plugin related file paths need to be made absolute
   before used internally, otherwise the cache can fail to deduplicate
   them. Fixed in 0.6.19.2 already.

-  Python3: With gcc before version 5, e.g. on CentOS 7, where we switch
   to using ``g++`` instead, the gcc version checks could crash. Fixed
   in 0.6.19.2 already.

-  Windows: Disable MinGW64 wildcard expansion for command line
   arguments. This was breaking command lines with arguments like
   ``--filename *.txt``, which under ``cmd.exe`` are left alone by the
   shell, and are to be expanded by the program. Fixed in 0.6.19.2
   already.

-  Standalone: Added missing implicit dependency needed for
   ``--follow-stdlib`` with Python for some uses of the ``locale``
   module. Fixed in 0.6.19.2 already.

-  Standalone: Added workarounds for newest ``numpy`` that wants to set
   ``__code__`` objects and required improvements for macOS library
   handling. Fixed in 0.6.19.3 already.

-  Windows: Caching of DLL dependencies for the main programs was not
   really working, requiring to detect them anew for every standalone
   compilation for no good reason. Fixed in 0.6.19.3 already.

-  Windows: Fix, CTRL-C from a terminal was not propagated to child
   processes on Windows. Fixed in 0.6.19.4 already.

-  Standalone: With ``certifi`` and Python3.10 the
   ``importlib.resource`` could trigger Virus scanner inflicted file
   access errors. Fixed in 0.6.19.4 already.

-  Python3.10: Reverted error back iteration past end of generator
   change for Python 3.10.2 or higher to become compatible with that
   too. Fixed in 0.6.19.5 already.

-  Standalone: Added support for ``anyio`` and by proxy for Solana.
   Fixed in 0.6.19.5 already.

-  Fix, compilation with resource mode ``incbin`` and ``--debugger`` was
   not working together. Fixed in 0.6.19.5 already.

-  Fix, format optimization of known ``str`` objects was not properly
   annotating an exception exit when being optimized away, causing
   consistency checks to complain. Fixed in 0.6.19.5 already.

-  Windows: Fix, ``clcache`` didn't work for non-standard encoding
   source paths due to using th direct mode, where wrong filenames are
   output by MSVC. Fixed in 0.6.19.5 already.

-  Windows: Fix, ``ccache`` cannot handle source code paths for
   non-standard encoding source paths. Fixed in 0.6.19.5 already.

-  Python2.6: Fix, calls to ``iteritems`` and ``iterkeys`` on known
   dictionary values could give wrong values. Fixed in 0.6.19.5 already.

-  Fix, the value of ``__module__`` if set by the metaclass was
   overwritten when creating types. Fixed in 0.6.19.6 already.

-  Plugins: Add support for the latest version of ``pkg_resources`` that
   has "vendored" even more packages. Fixed in 0.6.19.6 already.

-  Onefile: The onefile binary was locked during run time and could not
   be renamed, preventing in-place updates. This has been resolved and
   now on Windows, the standard trick for updating a running binary of
   renaming it, then placing the new file works.

-  Fix, wasn't checking the ``zstandard`` version and as a result could
   crash if too old versions of it. This is now checked.

-  macOS: Large amounts of bug fixes for the dependency scanner. It got
   cleaned up and now handles many more cases correctly.

-  Windows: Fix, was not properly detecting wrong ClangCL architecture
   mismatch with the Python architecture. This could result in strange
   errors during C compilation in this setup.

-  Standalone: Added implicit dependencies for the ``asyncpg`` module.

-  Linux: Detect Debian or Ubuntu base and distribution name more
   reliably. This helps esp. with static libpython optimization being
   recognized automatically.

New Features
============

-  We now disallow options that take arguments to be provided without
   using ``=``.

-  Previously ``--lto no`` worked just as well as ``--lto=no`` did. And
   that was the cause of problems when ``--lto`` first became a choice.

   Recently similar, but worse problems were observed, where e.g.
   ``--include-module`` could swallow trailing other arguments when
   users forgot to specify the name by accident. Therefore this style of
   giving options is now explicitly rejected.

-  Compiled types of Nuitka now inherit from uncompiled types. This
   should allow easier and more complete compatibility, making even code
   in extension modules that uses ``PyObject_IsInstance`` work, e.g.
   ``pydantic``.

-  macOS: Added signing of application bundles and standalone binaries
   for deployment to newer macOS platforms and esp. M1 where these are
   mandatory for execution.

-  macOS: Added support for selecting the single macOS target arch to
   create a binary for. The ``universal`` architecture is not yet
   supported though, but will be added in a future release.

-  Added support for compression in onefile mode through the use of an
   other Python installation, that has the ``zstandard`` module
   installed. With this it will work with 2.6 or higher, but require a
   3.5 or higher Python with it installed in either ``PATH`` or on
   Windows in the registry alternatively.

-  Added UPX plugin to compress created extension modules and binaries
   and for standalone mode, the included DLLs. For onefile, the
   compression is not useful since it has the payload already
   compressed.

-  Added a more explicit way to list usable MSVC versions with
   ``--msvc=list`` rather than requiring an invalid value. Check values
   given in the same way that Scons will do.

-  Added support for ``--python-flag=-u`` which disabled outputs
   buffers, so that these outputs are written immediately.

-  Plugins: Always on plugins now can have command line options. We want
   this for the ``anti-bloat`` plugin that is enabled by default in this
   release.

-  Plugins: Added ability for plugin to provide fake dependencies for a
   module. We want the this for the ``multiprocessing`` plugin, that is
   now enabled by default in this release too.

-  Plugins: Added ability for plugins to modify DLLs after copy for
   standalone. We will be using this in the new ``upx`` plugin.

-  Added retry for file copies that fail due to still running program.
   This can happen on Windows with DLLs in standalone mode. For
   interactive compilation, this allows a retry to happen after
   prompting the user.

-  UI: Added ability to list MSVC versions with ``--msvc=list``, and
   detect illegal values given to ``--msvc=`` before Scons sees them, it
   also crashes with a relative unhelpful error message.

-  UI: When linking, close the C compilation progress bar and state that
   that linking is going on. For some very large LTO compilations, it
   was otherwise at 100% and still taking a long time, confusing users.

-  Plugins: Added new plugin that is designed to handle DLL dependencies
   through a configuration file that can both handle filename patterns
   as well as code provided DLL locations.

-  Optimization: Exclude parts of the standard library by default. This
   allows for much smaller standalone distributions on modules, that can
   be expected to never be an implicit dependency of anything, e.g.
   ``argparse`` or ``pydoc``.

Optimization
============

-  Standalone: Do not include ``encodings.bz2_codec`` and
   ``encodings.idna`` anymore, these are not file system encodings, but
   require extension modules.

-  Make sure we use proper ``(void)`` arguments for C functions without
   arguments, as for C functions, that makes a real difference, they are
   variable args functions and more expensive to call otherwise.

-  For standalone, default to using ``--python-flag=no_site`` to avoid
   the overhead that the typically unused ``site`` module incurs. It
   often includes large parts of the standard library, which we now want
   to be more selective about. There is new Python flag added called
   ``--python-flag=site`` that restores the inclusion of ``site``
   module.

-  Standalone: Exclude non-critical codec modules from being technical,
   i.e. have to be available at program startup. This removes the need
   for e.g. ``bz2`` related extension modules previously included.

-  In reformulations, use dictionary methods directly, we have since
   introduced dictionary specific methods, and avoid the unnecessary
   churn during optimization.

-  The complex call helper could trigger unnecessary passes in some
   cases. The pure functions were immediately optimized, but usages in
   other modules inside loops sometimes left them in incomplete states.

-  Windows: Avoid repeated hashing of the same files over and over for
   ``clcache``.

-  Cache dependencies of bytecode demoted modules in first compile and
   reuse that information in subsequent compilations.

-  Linux: Added option for switching compression method for onefile
   created with ``AppImage``. The default is also now ``gzip`` and not
   ``xz`` which has been observed to cause much slower startup for
   little size gains.

-  Standalone: For failed relative imports, during compiled time
   absolute imports were attempted still and included if successful, the
   imports would not be use them at run time, but lead to more modules
   being included than necessary.

Organisational
==============

-  There is now a `Discord server for Nuitka community
   <https://discord.gg/nZ9hr9tUck>`__ where you can hang out with the
   developers and ask questions. It is mirrored with the Gitter
   community chat, but offers more features.

-  The ``anti-bloat`` is now on by default. It helps scalability by
   changing popular packages to not provide test frameworks,
   installation tools etc. in the resulting binary. This oftentimes
   reduces the compilation by thousands of modules.

-  Also the ``multiprocessing`` plugin is now on by default. Detecting
   its need automatically removes a source of problems for first time
   users, that didn't know to enable it, but had all kinds of strange
   crashes from multiprocessing malfunctioning. This should enhance the
   out of the box experience by a lot.

-  With this release, the version numbering scheme will be changed. For
   a long time we have used 4 digits, where one is a leading zero. That
   was initially done to indicate that it's not yet ready. However, that
   is just untrue these days. Therefore, we switch to 3 digits, and a
   first hotfix with now be 0.7.1 rather than 0.6.19.1, which is too
   long.

   It has been observed that people disregard differences in the third
   digit, but actually for Nuitka these have oftentimes been very
   important updates. This change is to rectify it, and a new release
   will be ``0.8``, and there will be a ``1.0`` release after ``0.9``.

-  Added a new section to User Manual that explains how to manually load
   files, such that it is cleaner and compatible code. Using paths
   relative to current directory is not the right way, but there are
   nice helpers that make it very simple and correct with all kinds of
   contexts.

-  Report the MSVC version in Scons output during compilation. The 2022
   version is required, but we support everything back to 2008, to work
   on very old systems as well. This will help identifying differences
   that arise from there.

-  Quality: Find Clang format from MSVC 2022 too. We use in auto format
   of Nuitka source code, but need to also search that as a new path.

-  Added a spellchecker extension for Visual Code, resulting in many
   spelling fixes in all kinds of documentation and code. This finds
   more things than ``codespell``, but also has a lot of false alarms.

-  Check value of ``--onefile-tempdir-spec`` for typical user errors. It
   cannot be ``.`` as that would require to overwrite the onefile binary
   on Windows, and will generally behave very confusing. Warn about
   absolute or relative paths going outside of where the binary lives.
   Can be useful in controlled setups, but not generally. Also warn
   about using no variables, making non-unique paths.

-  macOS: Flavor detection was largely expanded. The ``Apple`` flavor is
   recognized on more systems. ``Homebrew`` was newly added, and we
   actually can detect ``CPython`` reliably as a first.

-  Added a tool from leo project to create better ``.pyi`` files for
   modules. We will make use of it in the future to enhance the files
   created by Nuitka to not only contain hidden dependencies, but
   optionally also module signatures.

-  Plugins: Clearer information from ``pyside2`` that patched wheels
   might be mandatory and workarounds only patches cannot be done for
   older Python.

-  Added progress bars for DLL dependency detection and DLL copying for
   standalone. These both can end up using take a fair bit of time
   depending on project size, and it's nice to know what's going on.

-  macOS: Added support for using both ``--onefile`` and
   ``--macos-create-app-bundle`` as it is needed for PySide2 due to
   issues with signing code now.

-  Added warning when attempting to include extension modules in an
   accelerated compilation.

-  Modules: Catch the user error of following all imports when creating
   a module. This is very unlikely to produce usable results.

-  Start integrating `Sourcery <https://sourcery.ai>`__ for improved
   Nuitka code. It will comment on PRs and automatically improve Nuitka
   code as we develop it.

-  Debugging: Added command line tool ``find-module`` that outputs how
   Nuitka locates a module in the Python environment it's ran with. That
   removes the need to use Python prompt to dump ``__file__`` of
   imported modules. Some modules even hide parts of their namespace
   actively during run-time, the tool will not be affected by that.

Cleanups
========

-  Refactored Python scan previously used for Scons usage on versions
   that need to run in with another Python to be more generally usable.

-  Use explicit ``nuitka.utils.Hashing`` module that allows the core to
   perform these operations with simpler code.

-  macOS: Use ``isPathBelow`` for checking if something is a system
   library for enhanced robustness and code clarity.

-  macOS: Make sure to use our proper error checking wrappers for
   command execution when using tools like ``otool`` or ``codesign``.

-  Standalone: Avoid a temporary file with a script during technical
   import detection. These have been observed to potentially become
   corrupted, and this avoids any chance of that happening, while also
   being simpler code.

-  Avoid naming things ``shlib`` and call them ``extension`` instead.
   Inspired by the spell checker disliking the former term, which is
   also less precise.

-  Removed the dead architecture selection option for Windows, it was
   unused for a long time.

-  Moved Windows ``SxS`` handling of DLLs to a more general place where
   also macOS specific tasks are applied, to host standard modification
   of DLLs during their copying.

Tests
=====

-  Better matching of relative filenames for search modes of the
   individual test suite runners.

-  Debugger outputs on segfaults were no longer visible and have been
   restored.

Summary
=======

This release is tremendous progress for macOS. Finally biting the bullet
and paying obscene amounts of money to rent an M1 machine, it was
possible to enhance the support for this platform. Currently typical
packages for macOS are being made compatible as well, so it can now be
expected to perform equally well.

On the quality side, the spell checker has had some positive effects,
finding typos and generally misspelled code, that ``codespell`` does
not, due to it being very conservative.

The trend to enhance plugins has continued. The copying of DLLs is very
nearly finalized. Making more plugins enabled by default is seeing a lot
of progress, with 2 important ones addressed.

Work on the size of distributions has seen a lot of positive results, in
that now standalone distributions are often very minimal, with many
extension modules from standard library no longer being present.

***********************
 Nuitka Release 0.6.19
***********************

This release adds support for 3.10 while also adding very many new
optimization, and doing a lot of bug fixes.

Bug Fixes
=========

-  Calls to ``importlib.import_module`` with expressions that need
   releases, i.e. are not constant values, could crash the compilation.
   Fixed in 0.6.18.1 already.

-  After a fix for the previous release, modules that fail to import are
   attempted again when another import is executed. However, during this
   initialization for top level module in ``--module`` mode, this was
   was done repeatedly, and could cause issues. Fixed in 0.6.18.1
   already.

-  Standalone: Ignore warning given by ``patchelf`` on Linux with at
   least newer OpenSUSE. Fixed in 0.6.18.1 already.

-  Fix, need to avoid computing large values out of ``<<`` operation as
   well. Fixed in 0.6.18.2 already.

   .. code:: python

      # This large value was computed at run time and then if used, also
      # converted to a string and potentially hashed, taking a long time.
      1 << sys.maxint

-  Standalone: Ignore warning given by ``patchelf`` on Linux about a
   workaround being applied.

-  Fix, calls to ``importlib.import_module`` were not correctly creating
   code for dynamic argument values that need to be released, causing
   the compilation to report the error. Fixed in 0.6.18.1 already.

-  MSYS2: Fix, the console scripts are actually good for it as opposed
   to CPython, and the batch scripts should not be installed. Fixed in
   0.6.18.2 already.

-  Setuptools: Added support older version of ``setuptools`` in meta
   ``build`` integration of Nuitka.

-  Fix, calls to ``importlib.import_module`` with 2 arguments that are
   dynamic, were not working at all. Fixed in 0.6.18.2 already.

-  Windows: Compiling with MinGW64 without ``ccache`` was not working
   due to issues in Scons. Fixed in 0.6.18.2 already.

-  Fix, the ``repr`` built-in was falsely annotated as producing a
   ``str`` value, but it can be also derived or ``unicode`` in Python2.

-  Fix, attribute nodes were not considering the value they are looking
   up on. Now that more values will know to have the attributes, that
   was causing errors. Fixed in 0.6.18.2 already.

-  Fix, left shifting can also produce large values and needs to be
   avoided in that case, similar to what we do for multiplications
   already. Fixed in 0.6.18.2 already.

-  UI: The new option ``--disable-ccache`` didn't really have the
   intended effect. Fixed in 0.6.18.3 already.

-  UI: The progress bar was causing tearing and corrupted outputs, when
   outputs were made, now using proper ``tqdm`` API for doing it, this
   has been solved. Fixed in 0.6.18.4 already.

-  Fix, the constant value ``sys.version_info`` didn't yet have support
   for its type to be also a compile time constant in e.g. tuples. Fixed
   in 0.6.18.4 already.

-  Onefile: Assertions were not disabled, and on Windows with MinGW64
   this lead to including the C filenames of the ``zstd`` inline copy
   files and obviously less optimal code. Fixed in 0.6.18.4 already.

-  Standalone: Added support for ``bottle.ext`` loading extensions to
   resolve at compile time. Fixed in 0.6.18.5 already.

-  Standalone: Added support for ``seedir`` required data file. Fixed in
   0.6.18.5 already.

-  MSYS2: Failed to link when using the static libpython, which is also
   now the default for MSYS2. Fixed in 0.6.18.5 already.

-  Python3.6+: Fix, the intended finalizer of compiled ``asyncgen`` was
   not present and in fact associated to help type. This could have
   caused corruption, but that was also very unlikely. Fixed in 0.6.18.5
   already.

-  Python3: Fix, need to set ``__file__`` before executing modules, as
   some modules, e.g. newer PyWin32 use them to locate things during
   their initialization already.

-  Standalone: Handle all PyWin32 modules that need the special DLLs and
   not just a few.

-  Fix, some ``.pth`` files create module namespaces with ``__path__``
   that does not exist, ignore these in module importing.

-  Python2.6-3.4: Fix, modules with an error could use their module name
   after it was released.

-  Distutils: When providing arguments, the method suggested in the docs
   is not compatible with all other systems, e.g. not
   ``setuptools_rust`` for which a two elements tuple form needs to be
   used for values. Added support for that and documented its use as
   well in the User Manual.

-  Python3.7+: Do no longer allow deleting cell values, this can lead to
   corruption and should be avoided, it seems unlikely outside of tests
   anyway.

-  Standalone: Added support for more ciphers and hashes with
   ``pycryptodome`` and ``pycryptodomex``, while also only including
   Ciphers when needed.

-  Distutils: Was not including modules or packages only referenced in
   the entry point definition, but not in the list of packages. That is
   not compatible and has been fixed.

-  Fix, must not expose the constants blob from extension modules, as
   loading these into a compiled binary can cause issues in this case.

-  Standalone: Added support for including OpenGL and SSL libraries with
   ``PySide2`` and ``PySide6`` packages.

-  Windows: Fix, the ``cmd`` files created for uninstalled Python and
   accelerated programs to find the Python installation were not passing
   command line arguments.

-  Windows: Executing modules with ``--run`` was not working properly
   due to missing escaping of file paths.

-  Fix, parsing ``.pyi`` files that make relative imports was not
   resolving them correctly.

-  Python3: Fix, when disabling the console on Windows, make sure the
   file handles still work and are not ``None``.

-  Windows: Fix, need to claim all OS versions of Windows as supported,
   otherwise e.g. high DPI features are not available.

New Features
============

-  Programs that are to be executed with the ``-m`` flag, can now be
   compiled with ``--python-flag=-m`` and will then behave in a
   compatible way, i.e. load the containing package first, and have a
   proper ``__package__`` value at run time.

-  We now can write XML reports with information about the compilation.
   This is initially for use in PGO tests, to decide if the expected
   forms of inclusions have happened and should grow into a proper
   reporting tool over time. At this point, the report is not very
   useful yet.

-  Added support for Python 3.10, only ``match`` statements are not
   completely supported. Variations with ``|`` matches that also assign
   are not allowed currently.

-  Windows: Allow using ``--clang`` with ``--mingw64`` to e.g. use the
   ``clang.exe`` that is contained in the Nuitka automatic download
   rather than ``gcc.exe``.

-  Added support for Kivy. Works through a plugin that is automatically
   enabled and needs no other inputs, detecting everything from using
   Kivy at compile time.

-  Added initial support for Haiku OS, a clone of BeOS with a few
   differences in their Python installation.

-  Added experimental plugin ``trio`` that works around issues with that
   package.

Optimization
============

-  Also trust hard imports made on the module level in function level
   code, this unlocks many more static optimization e.g. with
   ``sys.version_info`` when the import and the use are not on the same
   level.

-  For the built-in type method calls with generic implementation, we
   now do faster method descriptor calls. These avoid creating a
   temporary ``PyCFunction`` object, that the normal call slot would,
   this should make these calls faster. Checking them for compiled
   function, etc. was only wasteful, so this makes it more direct.

-  Loop and normal merge traces were keeping assignments made before the
   loop or inside a branch, that was otherwise unused alive. This should
   enable more optimization for code with branches and loops. Also
   unused loop traces are now recognized and removed as well.

-  Avoiding merges of escaped traces with the unescaped trace, there is
   no point in them. This was actually happening a lot and should mean a
   scalability improvement and unlock new optimization as well.

-  Avoid escaping un-init traces. Unset values need not be considered as
   potentially modified as that cannot be done.

-  The ``str`` shape is now detected through variables, this enables
   many optimization on the function level.

-  Added many ``str`` operation nodes.

   These are specifically all methods with no arguments, as these are
   very generic to add, introduced a base class for them, where we know
   they all have no effect or raise, as these functions are all
   guaranteed to succeed and can be served by a common base class.

   This covers the ``str.capitalize``, ``str.upper``, ``str.lower``,
   ``str.swapcase``, ``str.title``, ``str.isalnum``, ``str.isalpha``,
   ``str.isdigit``, ``str.islower``, ``str.isupper``, ``str.isspace``,
   and ``str.istitle`` functions.

   For static optimization ``str.find`` and ``str.rfind`` were added, as
   they are e.g. used in a ``sys.version.find(...)`` style in the ``os``
   module, helping to decide to not consider ``OS/2`` only modules.

   Then, support for ``str.index`` and ``str.rindex`` was added, as
   these are very similar to ``str.find`` forms, only that these may
   raise an exception.

   Also add support for ``str.split`` and ``str.rsplit`` which will be
   used sometimes for code needed to be compile time computed, to e.g.
   detect imports.

   Same goes for ``endswith`` and ``startswith``, the later is e.g.
   popular with ``sys.platform`` checks, and can remove a lot of code
   from compilation with them now being decided at compile time.

   .. note::

      A few ``str`` methods are still missing, with time we will achieve
      all of them, but this will take time.

-  Added trust for ``sys.builtin_module_names`` as well. The ``os``
   module is using it to make platform determinations.

-  When writing constant values, esp. ``tuple``, ``list``, or ``dict``
   values, an encoding of "last value" has been added, avoiding the need
   to repeat the same value again, making many values more compact.

-  When starting Nuitka, it usually restarts itself with information
   collected in a mode without the ``site`` module loaded, and with hash
   randomization disabled, for deterministic behaviour. There is a
   option to prevent this from happening, where the goal is to avoid it,
   e.g. in testing, say for the coverage taking, but that meant to parse
   the options twice, which also loads a lot of code.

   Now only a minimal amount of code is used, and the options are parsed
   only on the restart, and then an error is raised when it notices, it
   was not allowed to do so. This also makes code a lot cleaner.

-  Specialized comparison code for Python2 ``long`` and Python3 ``int``
   code, making these operations much faster to use.

-  Specialized comparison code for Python2 ``unicode`` and Python3
   ``str`` code, making these operations much faster to use, currently
   only ``==`` and ``!=`` are fully accelerated, the other comparisons
   will follow.

-  Enable static libpython with Python3 Debian packages too. As with
   Python2, this will improve the performance of the created binary a
   lot and reduce size for standalone distribution.

-  Comparisons with ``in`` and ``not in`` also consider value traces and
   go through variables as well where possible. So far only the rich
   comparisons and ``is`` and ``is not`` did that.

-  Create fixed import nodes in re-formulations rather than
   ``__import__`` nodes, avoiding later optimization doing that, and of
   course that's simpler code too.

-  Python 3.10: Added support for ``union`` types as compiled time
   constants.

-  Modules are now fully optimized before considering which modules they
   are in turn using, this avoids temporary dependencies, that later
   turn out unused, and can shorten the compilation in some cases by a
   lot of time.

-  On platforms without a static link library, in LTO mode, and with
   gcc, we can use the ``-O3`` mode, which doesn't work for
   ``libpython``, but that's not used there. This also includes fake
   static libpython, as used by MinGW64 and Anaconda on Windows.

-  The ``anti-bloat`` plugin now also handles newer ``sklearn`` and
   knows more about the standard library, and its runners which it will
   exclude from compilation if use for it. Currently that is not the
   default, but it should become that.

Organisational
==============

-  Migrated the Nuitka blog from Nikola to Sphinx based ABlog and made
   the whole site render with Sphinx, making it a lot more usable.

-  Added a small presentation about Nuitka on the Download page, to make
   sure people are aware of core features.

-  The ``gi`` plugin is now always on. The copying of the ``typelib``
   when ``gi`` is imported is harmless and people can disable the plugin
   if that's not needed.

-  The ``matplotlib`` plugin is new and also always on. It previously
   was part of the ``numpy`` plugin, which is doing too many unrelated
   things. Moving this one out is part of a plan to split it up and have
   it on by default without causing issues.

-  MSYS2: Detecting ``MinGW`` and ``POSIX`` flavors of this Python. For
   the ``MinGW`` flavor of MSYS2, the option ``--mingw64`` is now the
   default, before it could attempt to use MSVC, which is not going to
   work for it. And also the Tcl and Tk installations of it are being
   detected automatically for the ``tk-inter`` plugin.

-  Added Windows version to Nuitka version output, so we have this for
   bug reports.

-  User Manual: Added example explaining how to access values from your
   code in Nuitka project options.

-  UI: For Python flavors where we expect a static libpython, the error
   message will now point out how to achieve it for each flavor.

-  UI: Disable progress bar when ``--show-scons`` is used, it makes
   capturing the output from the terminal only harder.

-  UI: Catch error of specifying both ``--msvc=`` and ``--mingw64``
   options.

-  Distutils: Improved error messages when using ``setuptools`` or
   ``build`` integration and failing to provide packages to compile.

-  Plugins: Removed now unused feature to rename modules on import, as
   it was only making the code more complex, while being no more needed
   after recently adding a place for meta path based importers to be
   accounted for.

-  Twitter: Use embedded Tweet in Credits, and regular follow button in
   User Manual.

-  Warnings about imports not done, are now only given when optimization
   can not remove the usage, and no options related to following have
   been given.

-  Added Windows version to ``--version`` output of Nuitka. This is to
   more clearly recognize Windows 10 from Windows 11 report, and also
   the odd Windows 7 report, where tool chain will be different.

-  In Visual Code, the default Python used is now 3.9 in the "Linux" C
   configuration. This matches Debian Bullseye.

-  Nicer outputs from check mode of the auto-format as run for CI
   testing, displays problematic files more clearly.

-  Remove broken links to old bug tracker that is no longer online from
   the Changelog.

-  UI: When hitting CTRL-C during initial technical import detection, no
   longer ask to submit a bug report with the exception stack, instead
   exit cleanly.

-  Windows: Enable LTO mode for MinGW64 and other gcc by default. We
   require a version that can do it, so take advantage of that.

-  For cases, where code generation of a module takes long, make sure
   its name is output when CTRL-C is hit.

-  Windows: Splash screen only works with MSVC, added error indicator
   for MinGW64 that states that and asks for porting help.

Cleanups
========

-  Generate all existing C code for generic builtin type method calls
   automatically, and use those for method attribute lookups, making it
   easier to add more.

-  Changed ``TkInter`` module to data file providing interface, yielding
   the 2 directories in question, with a filter for ``demos``.

-  The importing code got a major overhaul and no longer works with
   relative filenames, or filenames combined with package names, and
   module names, but always only with module names and absolute
   filenames. This cleans up some of the oldest and most complex code in
   Nuitka, that had grown to address various requirements discovered
   over time.

-  Major cleanup of Jinja2 template organisation.

   Renamed all C templates from ``.j2`` to ``.c.j2`` for clarity, this
   was not done fully consistent before. Also move all C templates to
   ``nuitka.codegen`` package data, it will be confusing to make a
   difference between ones used during compile time and for the static
   generation, and the lines are going to become blurry.

   Added Jinja2 new macro ``CHECK_OBJECTS`` to avoid branches on
   argument count in the call code templates. More of these things
   should be added.

   Cleanup of code that generates header declarations, there was some
   duplication going on, that made it hard to generate consistent code.

-  Removed ``nuitka.finalizatios.FinalizationBase``, we only have one
   final visitor that does everything, and that of course makes a lot of
   sense for its performance.

-  Major cleanup of the Scons C compiler configuration setup. Moved
   things to the dedicate function, and harmonized it more.

-  Resolved deprecation warnings given by with ``--python-debug`` for
   Nuitka.

Tests
=====

-  Started test suite for Python PGO, not yet completely working though,
   it's not yet doing what is needed though.

-  Added generated test that exercises str methods in multiple
   variations.

-  Revived ``reflected`` test suite, that had been removed, because of
   Nuitka special needs. This one is not yet passing again though, due
   to a few details not yet being as compatible as needed.

-  Added test suite for CPython 3.10 and enable execution of tests with
   this version on GitHub actions.

Summary
=======

This release is another big step forward.

The amount of optimization added is again very large, some of which yet
again unlocks more static optimization of module imports, that
previously would have to be considered implicit. Now analyzing these on
the function level as well, we can start searching for cases, where it
could be done, but is not done yet.

After starting with ``dict``, method optimization has focused on ``str``
which is esp. important for static optimization of imports. The next
goal will here be to cover ``list`` which are important for run time
performance and currently not yet optimized. Future releases will
progress there, and also add more types.

The C type specialization for Python3 has finally progressed, such that
it is also covering the ``long`` and ``unicode`` and as such not limited
to Python2 as much. The focus now needs to turn back to not working with
``PyObject *`` for these types, but e.g. with ``+= 1`` to make it
directly work with ``CLONG`` rather than ``LONG`` for which structural
changes in code generation will be needed.

For scalability, the ``anti-bloat`` work has not yet progressed as much
as to be able to enable it by default. It needs to be more possible to
disable it where it causes problems, e.g. when somebody really wants to
include ``pytest`` and test frameworks generally, that's something that
needs to be doable. Compiling without ``anti-bloat`` plugin is something
that is immediately noticeable in exploding module amounts. It is very
urgently recommended to enable it for your compilations.

The support for Windows has been further refined, actually fixing a few
important issues, esp. for the Qt bindings too.

This release adds support for 3.10 outside of very special ``match``
statements, bringing Nuitka back to where it works great with recent
Python. Unfortunately ``orderedset`` is not available for it yet, which
means it will be slower than 3.9 during compilation.

Overall, Nuitka is closing many open lines of action with this. The
``setuptools`` support has yet again improved and at this point should
be very good.

***********************
 Nuitka Release 0.6.18
***********************

This release has a focus on new features of all kinds, and then also new
kinds of performance improvements, some of which enable static
optimization of what normally would be dynamic imports, while also
polishing plugins and adding also many new features and a huge amount of
organisational changes.

Bug Fixes
=========

-  Python3.6+: Fixes to asyncgen, need to raise ``StopAsyncIteration``
   rather than ``StopIteration`` in some situations to be fully
   compatible.

-  Onefile: Fix, LTO mode was always enabled for onefile compilation,
   but not all compilers support it yet, e.g. MinGW64 did not. Fixed in
   0.6.17.1 already.

-  Fix, ``type`` calls with 3 arguments didn't annotate their potential
   exception exit. Fixed in 0.6.17.2 already.

-  Fix, trusted module constants were not working properly in all cases.
   Fixed in 0.6.17.2 already.

-  Fix, ``pkg-resources`` exiting with error at compile time for
   unresolved requirements in compiled code, but these can of course
   still be optional, i.e. that code would never run. Instead give only
   a warning, and run time fail on these. Fixed in 0.6.17.2 already.

-  Standalone: Prevent the inclusion of ``drm`` libraries on Linux, they
   have to come from the target OS at run time. Fixed in 0.6.17.2
   already.

-  Standalone: Added missing implicit dependency for ``ipcqueue``
   module. Fixed in 0.6.17.3 already.

-  Fix, Qt webengine support for everything but ``PySide2`` wasn't
   working properly. Partially fixed in 0.6.17.3 already.

-  Windows: Fix, bootstrap splash screen code for Windows was missing in
   release packages. Fixed in 0.6.17.3 already.

-  Fix, could crash on known implicit data directories not present.
   Fixed in 0.6.17.3 already.

-  macOS: Disable download of ``ccache`` binary for M1 architecture and
   systems before macOS 10.14 as it doesn't work on these. Fixed in
   0.6.17.3 already.

-  Standalone: The ``pendulum.locals`` handling for Python 3.6 was
   regressed. Fixed in 0.6.17.4 already.

-  Onefile: Make sure the child process is cleaned up even after its
   successful exit. Fixed in 0.6.17.4 already.

-  Standalone: Added support for ``xmlschema``. Fixed in 0.6.17.4
   already.

-  Standalone: Added support for ``curses`` on Windows. Fixed in
   0.6.17.4 already.

-  Standalone: Added support for ``coincurve`` module. Fixed in 0.6.17.5
   already.

-  Python3.4+: Up until Python3.7 inclusive, a workaround for stream
   encoding (was ASCII), causing crashes on output of non-ASCII, other
   Python versions are not affected. Fixed in 0.6.17.5 already.

-  Python2: Workaround for LTO error messages from older gcc versions.
   Fixed in 0.6.17.5 already.

-  Standalone: Added support for ``win32print``. Fixed in 0.6.17.6
   already.

-  Fix, need to prevent usage of static ``libpython`` in module mode or
   else on some Python versions, linker errors can happen. Fixed in
   0.6.17.6 already.

-  Standalone: Do not load ``site`` module early anymore. This might
   have caused issues in some configurations, but really only would be
   needed for loading ``inspect`` which doesn`t depend on it in
   standalone mode. Fixed in 0.6.17.6 already.

-  Fix, could crash with generator expressions in finally blocks of
   tried blocks that return. Fixed in 0.6.17.7 already.

   .. code:: python

      try:
         return 9
      finally:
         "".join(x for x in b"some_iterable")

-  Python3.5+: Compatibility of comparisons with ``types.CoroutineType``
   and ``types.AsyncGeneratorType`` types was not yet implemented. Fixed
   in 0.6.17.7 already.

   .. code:: python

      # These already worked:
      assert isinstance(compiledCoroutine(), types.CoroutineType) is True
      assert isinstance(compiledAsyncgen(), types.AsyncGeneratorType) is True

      # These now work too:
      assert type(compiledCoroutine()) == types.CoroutineType
      assert type(compiledAsyncgen()) == types.AsyncGeneratorType

-  Standalone: Added support for ``ruamel.yaml``. Fixed in 0.6.17.7
   already.

-  Distutils: Fix, when building more than one package, things could go
   wrong. Fixed in 0.6.17.7 already.

-  Fix, for module mode filenames are used, and for packages, you can
   specify a directory, however, a trailing slash was not working. Fixed
   in 0.6.17.7 already.

-  Compatibility: Fix, when locating modules, a package directory and an
   extension module of the same name were not used according to
   priority. Fixed in 0.6.17.7 already.

-  Standalone: Added workaround ``importlib_resources`` insisting on
   Python source files to exist to be able to load datafiles. Fixed in
   0.6.17.7 already.

-  Standalone: Properly detect usage of hard imports from standard
   library in ``--follow-stdlib`` mode.

-  Standalone: Added data files for ``opensapi_spec_validator``.

-  MSYS2: Fix, need to normalize compiler paths before comparing.

-  Anaconda: For accelerated binaries, the created ``.cmd`` file wasn't
   containing all needed environment.

-  macOS: Set minimum OS version derived from the Python executable
   used, this should make it work on all supported platforms (of that
   Python).

-  Standalone: Added support for automatic inclusion of ``xmlschema``
   package datafiles.

-  Standalone: Added support for automatic inclusion of ``eel`` package
   datafiles.

-  Standalone: Added support for ``h5py`` package.

-  Standalone: Added support for ``phonenumbers`` package.

-  Standalone: Added support for ``feedparser`` package, this currently
   depends on the ``anti-bloat`` plugin to be enabled, which will become
   enabled by default in the future.

-  Standalone: Added ``gi`` plugin for said package that copies
   ``typelib`` files and sets the search path for them in standalone
   mode.

-  Standalone: Added necessary datafiles for ``eel`` package.

-  Standalone: Added support for ``QtWebEngine`` to all Qt bindings and
   also make it work on Linux. Before only PySide2 on Windows was
   supported.

-  Python3: Fix, the ``all`` built-in was wrongly assuming that bytes
   values could not be false, but in fact they are if they contain
   ``\0`` which is actually false. The same does not happen for string
   values, but that's a difference to be considered.

-  Windows: The LTO was supposed to be used automatically on with MSVC
   14.2 or higher, but that was regressed and has been repaired now.

-  Standalone: Extension modules contained in packages, depending on
   their mode of loading had the ``__package__`` value set to a wrong
   value, which at least impacted new matplotlib detection of Qt
   backend.

-  Windows: The ``python setup.py install`` was installing binaries for
   no good reason.

New Features
============

-  Setuptools support. Documented ``bdist_nuitka`` and ``bdist_wheel``
   integration and added support for Nuitka as a ``build`` package
   backend in ``pyproject.toml`` files. Using Nuitka to build your
   wheels is supposed to be easy now.

-  Added experimental support for Python 3.10, there are however still
   important issues with compatibility with the CPython 3.9 test suite
   with at least asyncgen and coroutines.

-  macOS: For app bundles, version information can be provided with the
   new option ``--macos-app-version``.

-  Added Python vendor detection of ``Anaconda``, ``pyenv``, ``Apple
   Python``, and ``pyenv`` and output the result in version output, this
   should make it easiert to analyse reported issues.

-  Plugins: Also handle the usage of ``__name__`` for metadata version
   resolution of the ``pkg-resources`` standard plugin.

-  Plugins: The ``data-files`` standard plugin now reads configuration
   from a Yaml file that ``data-files.yml`` making it more accessible
   for contributions.

-  Windows: Allow enforcing usage of MSVC with ``--msvc=latest``. This
   allows you to prevent accidental usage of MinGW64 on Windows, when
   MSVC is intended, but achieves that without fixing the version to
   use.

-  Windows: Added support for LTO with MinGW64 on Windows, this was
   previously limited to the MSVC compiler only.

-  Windows: Added support for using ``--debugger`` with the downloaded
   MinGW64 provided ``gdb.exe``.

   .. note::

      It doesn`t work when executed from a Git bash prompt, but e.g.
      from a standard command prompt.

-  Added new experimental flag for compiled types to inherit from
   uncompiled types. This should allow easier and more complete
   compatibility, making even code in extension modules that uses
   ``PyObject_IsInstance`` work, providing support for packages like
   ``pydantic``.

-  Plugins: The Qt binding plugins now resolve ``pyqtgraph`` selection
   of binding by hard coding ``QT_LIB``. This will allow to resolve its
   own dynamic imports depending on that variable at compile time. At
   this time, the compile time analysis is not covering all cases yet,
   but we hope to get there.

-  macOS: Provide ``minOS`` for standalone builds, derived from the
   setting of the Python used to create it.

-  UI: Added new option ``--disable-ccache`` to prevent Nuitka from
   injecting ``ccache`` (Clang, gcc) and ``clcache`` (MSVC) for caching
   the C results of the compilation.

-  Plugins: Added experimental support for ``PyQt6``. While using
   ``PySide2`` or ``PySide6`` is very much recommended with Nuitka, this
   allows its use.

-  UI: Added option ``--low-memory`` to allow the user to specify that
   the compilation should attempt to use less memory where possible,
   this increases compile times, but might enable compilation on some
   weaker machines.

Optimization
============

-  Added dedicated attribute nodes for attribute values that match names
   of dictionary operations. These are optimized into dedicate nodes for
   methods of dictionaries should their expression have an exact
   dictionary shape. These in turn optimize calls on them statically
   into dictionary operations. This is done for all methods of ``dict``
   for both Python2 and Python3, namely ``get``, ``items``,
   ``iteritems``, ``itervalues``, ``iterkeys``, ``viewvalues``,
   ``viewkeys``, ``pop``, ``setdefault``, ``has_key``, ``clear``,
   ``copy``, ``update``.

   The new operation nodes also add compile time optimization for being
   used on constant values where possible.

-  Also added dedicated attribute nodes for string operations. For
   operations, currently only part of the methods are done. These are
   currently only ``join``, ``strip``, ``lstrip``, ``rstrip``,
   ``partition``, ``rpartition``. Besides performance, this subset was
   enough to cover compile time evaluation of module name computation
   for ``importlib.import_module`` as done by SWIG bindings, allowing
   these implicit dependencies to be discovered at compile time without
   any help, marking a significant improvement for standalone usage.

-  Annotate type shape for dictionary ``in``/``not in`` nodes, this was
   missing unlike in the generic ``in``/``not in`` nodes.

-  Faster processing of "expression only" statement nodes. These are
   nodes, where a value is computed, but then not used, it still needs
   to be accounted for though, representing the value release.

   .. code:: python

      something() # ignores return value, means statement only node

-  Windows: Enabled LTO by default with MinGW64, which makes it produce
   much faster results. It now yield faster binaries than MSVC 2019 with
   pystone.

-  Windows: Added support for C level PGO (Profile Guided Optimization)
   with MSVC and MinGW64, allowing extra speed boosts from the C
   compilation on Windows as well.

-  Standalone: Better handling of ``requests.packages`` and
   ``six.moves``. The old handling could duplicate their code. Now uses
   a new mechanism to resolve metapath based importer effects at compile
   time.

-  Avoid useless exception checks in our dictionary helpers, as these
   could only occur when working with dictionary overloads, which we
   know to not be the case.

-  For nodes, have dedicated child mixin classes for nodes with a single
   child value and for nodes with a tuple of children, so that these
   common kind of nodes operate faster and don't have to check at run
   time what type they are during access.

-  Actually make use of the egg cache. Nuitka was unpacking eggs in
   every compilation, but in wheel installs, these can be quite common
   and should be faster.

-  Star arguments annotated their type shape, but the methods to check
   for dictionary exactly were not affected by this preventing
   optimization in some cases.

-  Added ``anti-bloat`` configuration for main programs present in the
   modules of the standard library, these can be removed from the
   compilation and should lower dependencies detected.

-  Using static libpython with ``pyenv`` automatically. This should give
   both smaller (standalone mode) and faster results as is the case when
   using this feature..

-  Plugins: Added improvements to the ``anti-bloat`` plugin for
   ``gevent`` to avoid including its testing framework.

-  Python3.9+: Faster calls into uncompiled functions from compiled code
   using newly introduced API of that version.

-  Statically optimize ``importlib.import_module`` calls with constant
   args into fixed name imports.

-  Added support for ``sys.version_info`` to be used as a compile time
   constant. This should enable many checks to be done at compile time.

-  Added hard import and static optimization for
   ``typing.TYPE_CHECKING``.

-  Also compute named import lookup through variables, expanding their
   use to more cases, e.g. like this:

   .. code::

      import sys
      ...
      if sys.version_info.major >= 3:
         ...

-  Also optimize compile time comparisons through variable names if
   possible, i.e. the value cannot have changed.

-  Faster calls of uncompiled code with Python3.9 or higher avoiding DLL
   call overhead.

Organisational
==============

-  Commercial: There are ``Buy Now`` buttons available now for the
   direct purchase of the `Nuitka Commercial </pages/commercial.html>`__
   offering. Finally Credit Card, Google Pay, and Apple Pay are all
   possible. This is using Stripe. Get in touch with me if you want to
   use bank transfer, which is of course still best for me.

-  The main script runners for Python2 have been renamed to ``nuitka2``
   and ``nuitka2-run``, which is consistent with what we do for Python3,
   and avoids issues where ``bin`` folder ends up in ``sys.path`` and
   prevents the loading of ``nuitka`` package.

-  Windows: Added support for Visual Studio 2022 by updating the inline
   copy of Scons used for Windows to version 4.3.0, on non Windows, the
   other ones will keep being used.

-  Windows: Requiring latest MinGW64 with version 11.2 as released by
   winlibs, because this is known to allow LTO, where previous releases
   were missing needed binaries.

-  Reject standalone mode usage with Apple Python, as it works only with
   the other supported Pythons, avoiding pitfalls in attempting to
   distribute it.

-  Move hosting of documentation to Sphinx, added Changelog and some
   early parts of API documentation there too. This gives much more
   readable results than what we have done so far with Nikola. More
   things will move there.

-  User Manual: Add description how to access code attributes in
   ``nuitka-project`` style options.

-  User Manual: Added commands used to generate performance numbers for
   Python.

-  User Manual: List other Python's for which static linking is supposed
   to work.

-  Improved help for ``--include-package`` with a hint how to exclude
   some of the subpackages.

-  Started using Jinja2 in code templates with a few types, adding basic
   infrastructure to do that. This will be expanded in the future.

-  Updated plugin documentation with more recent information.

-  Added Python flavor as detected to the ``--version`` output for
   improved bug reports.

-  Linux: Added distribution name to ``--version`` output for improved
   bug reports.

-  Always enable the ``gevent`` plugin, we want to achieve this for all
   plugins, and this is only a step in that direction.

-  Added project URLs for PyPI, so people looking at it from there have
   some immediate places to checkout.

-  Debian: Use common code for included PDF files, which have page
   styles and automatic corrections for ``rst2pdf`` applied.

-  Updated to latest ``black``, ``isort``, ``pylint`` versions.

-  The binary names for Python2 changed from ``nuitka`` and
   ``nuitka-run`` to ``nuitka2`` and ``nuitka2-run``. This harmonizes it
   with Python2 and avoids issues, where the ``bin`` folder in
   ``sys.path`` can cause issues with re-execution of Nuitka finding
   those to import.

   .. note::

      You ought to be using ``python -m nuitka`` style of calling Nuitka
      anyway, as it gives you best control over what Python is used to
      run Nuitka, you can pick ``python2`` there if you want it to run
      with that, even with full path. Check the relevant section in the
      User Manual too.

-  Added support for Fedora 34 and Fedora 35.

Cleanups
========

-  In a change of mind ``--enable-plugin`` has become the only form to
   enable a plugin used in documentation and tests.

-  Massive cleanup of ``numpy`` and Qt binding plugins, e.g.
   ``pyside2``. Data files and DLLs are now provided through proper
   declarative objects rather than copied manually. The handling of
   PyQt5 from the plugin should have improved as a side effect.

-  Massive cleanups of all documentation in ReST format. Plenty of
   formatting errors were resolved. Many typos were identified and
   globally fixed. Spellings e.g. of "Developer Manual" are now enforced
   with automatic replacements. Also missing or wrong quotes were turned
   to proper methods. Also enforce code language for shell scripts to be
   the same everywhere.

-  Removed last usages of ``getPythonFlags()`` and made the function
   private, replacing their use with dedicated function to check for
   individual flags.

-  Avoid string comparison with ``nuitka.utils.getOS()`` and instead add
   accessors that are more readable, e.g. ``nuitka.utils.isMacOS()`` and
   put them to use where it makes sense.

-  Replaced usages of string tests in list of python flags specified,
   with functions that check for a specific name with a speaking
   function name.

-  Added mixin for expressions that have no side effect outside of their
   value, providing common method implementation more consistently.

-  Remove code geared to using old PyLint and on Python2, we no longer
   use that. Also removed annotations only used for overriding Python2
   builtins from Nuitka code.

-  The PDF specific annotations were moved into being applied only in
   the PDF building step, avoiding errors for raw PDF directives.

-  Apply Visual Code auto-format to our Yaml files. This is
   unfortunately not and automatic formatting yet.

-  Introduce dedicated ``nuitka.utils.Json`` module, as we intend to
   expand its usage, e.g. for caching.

-  Replacing remaining usages of ``print`` functions with uses of
   ``nuitka.Tracing`` instead.

-  Massive cleanup of the ``gevent`` plugin, user proper method to
   execute code after module load, rather than source patching without
   need. The plugin no longer messes with inclusions that other code
   already provides for standalone.

-  Using own helper to update ``sys`` module attributes, to avoid errors
   from old C compilers, and also cleaning up using code to not have to
   cast on string constants.

-  More consistent naming of plugin classes, and enforce a relationship
   of detector class names to the names of detected plugins. The new
   naming consistency is now enforced.

Tests
=====

-  Added CPython 3.10 test suite, it needs more work though.

-  Added generated test that exercises dictionary methods in multiple
   variations.

-  Test suite names were specified wrongly in a few of them.

Summary
=======

This release is again a huge step forward. It refines on PGO and LTO for
C level to work with all relevant compilers. Internally Python level PGO
is prepared, but only a future release will feature it. With that,
scalability improvements as well as even more performance improvements
will be unlocked.

The amount of optimization added this time is even bigger, some of which
unlocks static optimization of module imports, that previously would
have to be considered implicit. This work will need one extra step,
namely to also trace hard imports on the function level, then this will
be an extremely powerful tool to solve these kinds of issues in the
future. The next release will have this and go even further in this
area.

With the dictionary methods, and some string methods, also a whole new
kind of optimization has been started. These will make working with
``dict`` containers faster, but obviously a lot of ground is to cover
there still, e.g. ``list`` values are a natural target not yet started.
Future releases will progress here.

Type specialization for Python3 has not progressed though, and will have
to be featured in a future releases though.

For scalability, the ``anti-bloat`` work has continued, and this should
be the last release, where this is not on by default. Compiling without
it is something that is immediately noticeable in exploding module
amounts. It is very urgently recommended to enable it for your
compilations.

The support for macOS has been refined, with version information being
possible to add, and adding information to the binary about which OSes
are supported, as well as rejecting Apple Python, which is only a trap
if you want to deploy to other OS versions. More work will be needed to
support ``pyenv`` or even Homebrew there too, for now CPython is still
the recommended platform to use.

This release achieves major compatibility improvements. And of course,
the experimental support for 3.10 is not the least. The next release
will strive to complete the support for it fully, but this should be
usable at least, for now please stay on 3.9 if you can.

***********************
 Nuitka Release 0.6.17
***********************

This release has a focus on performance improvements, while also
polishing plugins and adding many new features.

Bug Fixes
=========

-  Fix, plugins were not catching being used on packages not installed.
   Fixed in 0.6.16.2 already.

-  macOS: Fix weaknesses in the ``otool`` parsing to determine DLL
   dependency parsing. Fixed in 0.6.16.2 already.

-  Linux: Allow onefile program args with spaces contained to be
   properly passed. Fixed in 0.6.16.3 already.

-  Windows: Avoid using less portable C function for ``%PID%``
   formatting, which restores compilation on Windows 7 with old
   toolchains. Fixed in 0.6.16.3 already.

-  Standalone: Added support for ``fstrings`` package. Fixed in 0.6.16.3
   already.

-  Compatibility: Fix, need to import ``.pth`` files after ``site``
   module, not before. This was causing crashes on CentOS7 with Python2.
   Fixed in 0.6.16.3 already.

-  Compatibility: Fix, when extension modules failed to load, in some
   cases the ``ImportError`` was lost to a ``KeyError``. Fixed in
   0.6.16.3 already.

-  Fix, linker resource modes ``code`` and ``linker`` were not working
   anymore, but are needed with LTO mode at least. Fixed in 0.6.16.3
   already.

-  Standalone: Bytecode modules with null bytes in standard library,
   typically from disk corruption, were not handled properly. Fixed in
   0.6.16.3 already.

-  Fix, failed ``.throw()`` into generators could cause corruption.
   Fixed in 0.6.16.4 already.

-  Python2: Fix, the bytecode compilation didn't respect the
   ``--python-flag=no_asserts`` mode. Fixed in 0.6.16.4 already.

-  Fix, calls were not annotating their arguments as escaped, causing
   corruption of mutable in static optimization. Fixed in 0.6.16.5
   already.

-  Fix, some sequence objects, e.g. ``numpy.array`` actually implement
   in-place add operations that need to be called. Fixed in 0.6.16.5
   already.

-  Windows: Fix, onefile binaries were not working after being signed.
   This now works.

-  Standalone: Added missing implicit dependency for ``sklearn``.

-  Compatibility: Modules giving ``SyntaxError`` from source were not
   properly handled, giving run time ``ImportError``. Now they are
   giving ``SyntaxError``.

-  Fix, the LTO mode has issues with ``incbin`` usage on older gcc, so
   use ``linker`` mode when it is enabled.

-  Python3: Fix, locals dict codes were not properly checking errors
   that the mapping might raise when setting values.

-  Fix, modules named ``entry`` were causing compile time errors in the
   C stage.

-  macOS: Never include files from OS private frameworks in standalone
   mode.

-  Fix, the python flag ``--python-flag=no_warning`` wasn't working on
   all platforms.

-  Compatibility: Fix, the main code of the ``site`` module wasn't
   executing, so that its added builtins were not there. Of course, you
   ought to use ``--python-flag=no_site`` to not have it in the normal
   case.

-  Python2: Added code path to handle edited standard library source
   code which then has no valid bytecode file.

-  Anaconda: In module mode, the CondaCC wasn't recognized as form of
   gcc.

-  Fix, bytecode modules could shadow compiled modules of the same name.

-  Onefile: Fix, expansion of ``%PID%`` wasn't working properly on
   non-Windows, making temp paths less unique. The time stamp is not
   necessarily enough.

-  Fix, ``multiprocessing`` error exits from slave processes were not
   reporting tracebacks.

-  Standalone: Added ``xcbglintegrations`` to the list of sensible Qt
   plugins to include by default, otherwise rendering will be inferior.

-  Standalone: Added ``platformthemes`` to the list of sensible Qt
   plugins to include by default, otherwise file dialogs on non-Windows
   would be inferior.

-  Fix, created ``.pyi`` files were not ordered deterministically.

-  Standalone: Added support for ``win32file``.

-  Fix, namespace packages were not using run time values for their
   ``__path__`` value.

-  Python3.7+: Fix, was leaking ``AttributeError`` exceptions during
   name imports.

-  Fix, standard library detection could fail for relative paths.

New Features
============

-  Added experimental support for C level PGO (Profile Guided
   Optimization), which runs your program and then uses feedback from
   the execution. At this time only gcc is supported, and only C
   compiler is collecting feedback. Check the User Manual for a table
   with current results.

-  macOS: Added experimental support for creating application bundles.
   For these, icons can be specified and console can be disabled. But at
   this time, onefile and accelerated mode are not yet usable with it,
   only standalone mode works.

-  Plugins: Add support for ``pkg_resources.require`` calls to be
   resolved at compile time. These are not working at run time, but this
   avoids the issue very nicely.

-  Plugins: Massive improvements to the ``anti-bloat`` plugin, it can
   now make ``numpy``, ``scipy``, ``skimage``, ``pywt``, and
   ``matplotlib`` use much less packages and has better error handling.

-  Plugins: Added ``anti-bloat`` ability ability to append code to a
   module, which might get used in the future by other plugins that need
   some sort of post load changes to be applied.

-  Plugins: Added ability to replace code of functions at parse time,
   and use this in ``anti-bloat`` plugin to replace functions that do
   unnecessary stuff with variants that often just do nothing. This is
   illustrated here.

   .. code:: yaml

      gevent._util:
      description: "remove gevent release framework"
      change_function:
         "prereleaser_middle": "'(lambda data: None)'"
         "postreleaser_before": "'(lambda data: None)'"

   This example is removing ``gevent`` code that loads dependencies used
   for their CI release process, that need not be part of normal
   programs.

-  Added ability to persist source code changes done by plugins in the
   Python installation. This is considered experimental and needs write
   access to the Python installation, so this is best done in a
   virtualenv and it may confuse plugins.

-  Added support for ``multiprocessing.tracker`` and spawn mode for all
   platforms. For non-default modes outside of Windows, you need to
   ``--enable-plugin=multiprocessing`` to use these.

-  Plugins: Allow multiple entry points to be provided by one or several
   plugins for the same modules. These are now merged into one
   automatically.

-  Standalone: Fix for numpy not working when compiling with
   ``--python-flag=no_docstrings``.

-  Fix, method calls were not respecting descriptors provided by types
   with non-generic attribute lookups.

-  Windows: Add support for using self-compiled Python3 from the build
   folder too.

-  Added support for Nuitka-Python 2.7, which will be our faster Python
   fork.

-  Colorized output for error outputs encountered in Scons, these are
   now yellow for better recognition.

Optimization
============

-  Faster threading code was used for Python3.8 or higher, and this has
   been extended to 3.7 on Windows, but we won't be able to have it
   other platforms and not on earlier Python3 versions.

-  Faster calls esp. with keyword arguments. Call with keywords no
   longer create dictionaries if the call target supports that, and with
   3.8 or higher, non-compiled code that allows vectorcall is taken
   advantage of.

-  Faster class creation that avoids creation of argument tuples and
   dictionaries.

-  Faster attribute check code in case of non-present attributes.

-  Faster unbound method calls, unlike bound methods calls these were
   not optimized as well yet.

-  Type shapes for star arguments are now known and used in
   optimization.

   .. code:: python

      def f(*args, **kwargs):
         type(args) # Statically known to be tuple
         type(kwargs) # Statically known to be dict

-  Python2: Faster old-style class creation. These are classes that do
   not explicitly inherit from ``object``.

-  Python2: Faster string comparisons for Python by specializing for the
   ``str`` type as well.

-  Python3: Added specialization for ``bytes`` comparisons too. These
   are naturally very much the same as ``str`` comparisons in Python2.

-  Added specialization for ``list`` comparisons too. We had them for
   ``tuples`` only so far.

-  Faster method calls when called from Python core, our ``tp_call``
   slot wasn't as good as it can be.

-  Optimization: Faster deep copies of constants. This can speed up
   constant calls with mutable types. Before it was checking the type
   too often to be fast.

-  Allow using static linking with Debian Python giving much better
   performance with the system Python. This is actually a huge
   improvement as it makes things much faster. So far it's only
   automatically enabled for Python2, but it seems to work for Python3
   on Debian too. Needs more tweaking in the future.

-  Optimization: Added ``functools`` module to the list of hard imports
   in preparation of optimizing ``functools.partial`` to work better
   with compiled functions.

-  Python2: Demote to ``xrange`` when iterating over ``range`` calls,
   even for small ranges, they are always faster. Previously this was
   only done for values with at least 256 values.

-  Enable LTO automatically for Debian Python, this also allows more
   optimization.

-  Enable LTO automatically for Anaconda with CondaCC on non-Windows,
   also allowing more optimization.

Organisational
==============

-  Added section in the User Manual on how to deal with memory issues
   and C compiler bugs. This is a frequent topic and should serve as a
   pointer for this kind of issue.

-  The ``--lto`` option was changed to require an argument, so that it
   can also be disabled. The default is ``auto`` which is the old
   behaviour where it's enabled if possible.

-  Changed ``--no-progress`` to ``--no-progressbar`` in order to make it
   more clear what it's about. Previously it was possible to relate it
   to ``--show-progress``.

-  No longer require specific versions of dependencies in our
   ``requirements.txt`` and relegate those to only being in
   ``requirements-devel.txt`` such that by default Nuitka doesn't
   collide with user requirements on those same packages which
   absolutely all the time don't really make a difference.

-  Added ability to check all unpushed changes with pylint with a new
   ``./bin/check-nuitka-with-pylint --unpushed`` option. Before it was
   only possible to make the check (quickly) with ``--diff``, but that
   stopped working after commits are made.

-  Revived support for ``vmprof`` based analysis of compiled programs,
   but it requires a fork of it now.

-  Make Windows specific compiler options visible on all platforms.
   There is no point in them being errors, instead warnings are given
   when they are specified on non-Windows.

-  Added project variable ``Commercial`` for use in Nuitka project
   syntax.

-  Consistent use of metavars for nicer help output should make it more
   readable.

-  Avoid ``ast`` tree dumps in case of ``KeyboardInterrupt`` exceptions,
   they are just very noisy. Also not annotate where Nuitka was in
   optimization when a plugin is asking to ``sysexit``.

Cleanups
========

-  Encoding names for UTF-8 in calls to ``.encode()`` were used
   inconsistent with and without dashes in the source code, added
   cleanup to auto-format that picks the one blessed.

-  Cleanup taking of run time traces of DLLs used in preparation for
   using it in main code eventually, moving it to a dedicated module.

-  Avoid special names for Nuitka options in test runner, this only adds
   a level of confusion. Needs more work in future release.

-  Unify implementation to create modules into single function. We had 3
   forms, one in recursion, one for main module, and one for plugin
   generated code. This makes it much easier to understand and use in
   plugins.

-  Further reduced code duplication between the two Scons files, but
   more work will be needed there.

-  Escaped variables are still known to be assigned/unassigned rather
   than unknown, allowing for many optimizations to still work on them.,
   esp. for immutable value

-  Enhanced auto-format for rest documents, bullet list spacing is now
   consistent and spelling of organisational is unified automatically.

-  Moved icon conversion functionality to separate module, so it can be
   reused for other platforms more easily.

Tests
=====

-  Removed ``reflected`` test, because of Nuitka special needs to
   restart with variable Python flags. This could be reverted though,
   since Nuitka no longer needs anything outside inline copies, and
   therefore no longer loads from site packages.

-  Use ``anti-bloat`` plugin in standalone tests of Numpy, Pandas and
   tests to reduce their compile times, these have become much more
   manageable now.

-  Enhanced checks for used files to use proper below path checks for
   their ignoring.

-  Remove reflected test, compiling Nuitka with Nuitka has gotten too
   difficult.

-  Verify constants integrity at program end in debug mode again, so we
   catch corruption of them in tests.

Summary
=======

This release is one of the most important ones in a long time. The PGO
and LTO, and static libpython work make a big different for performance
of created binaries.

The amount of optimization added is also huge, calls are much faster
now, and object creations too. These avoiding to go through actual
dictionaries and tuples in most cases when compiled code interacts gives
very significant gains. This can be seen in the increase of pystone
performance.

The new type specializations allow many operations to be much faster.
More work will follow in this area and important types, ``str`` and
``int`` do not have specialized comparisons for Python3, holding it back
somewhat to where our Python2 performance is for these things.

For scalability, the ``anti-bloat`` work is extremely valuable, and this
plugin should become active by default in the future, for now it must be
strongly recommended. It needs more control over what parts you want to
deactivate from it, in case of it causing problems, then we can and
should do it.

The support for macOS has been enhanced a lot, and will become perfect
in the next release (currently develop). The bundle mode is needed for
all kinds of GUI programs to not need a console. This platform is
becoming as well supported as the others now.

Generally this release marks a huge step forward. We hope to add Python
level PGO in the coming releases, for type knowledge retrofitted without
any annotations used. Benchmarks will become more fun clearly.

***********************
 Nuitka Release 0.6.16
***********************

This release is mostly polishing and new features. Optimization looked
only at threading performance, and LTO improvements on Windows.

Bug Fixes
=========

-  Fix, the ``pkg-resources`` failed to resolve versions for
   ``importlib.metadata`` from its standard library at compile time.
   Fixed in 0.6.15.1 already.

-  Standalone: Fix, ``--include-module`` was not including the module if
   it was an extension modules, but only for Python modules. Fixed in
   0.6.15.1 already.

-  Standalone: Added missing implicit dependencies for ``gi.overrides``.
   Fixed in 0.6.15.1 already.

-  Python3.9: Fix, could crash when using generic aliases in certain
   configurations. Fixed in 0.6.15.2 already.

-  Fix, the tensorflow plugin needed an update due to changed API. Fixed
   in 0.6.15.3 already.

-  When error exiting Nuitka, it now closes any open progress bar for
   cleaner display.

-  Standalone: Added missing dependency for ``skimage``.

-  Standalone: The ``numpy`` plugin now automatically includes Qt
   backend if any of the Qt binding plugins is active.

New Features
============

-  Python3.5+: Added support for onefile compression. This is using
   ``zstd`` which is known to give very good compression with very high
   decompression, much better than e.g. ``zlib``.

-  macOS: Added onefile support.

-  FreeBSD: Added onefile support.

-  Linux: Added method to use tempdir onefile support as used on other
   platforms as an alternative to ``AppImage`` based.

-  Added support for recursive addition of files from directories with
   patterns.

-  Attaching the payload to onefile now has a progress bar too.

-  Windows: Prelimary support for the yet unfinished Nuitka-Python that
   allows static linking and higher performance on Windows, esp. with
   Nuitka.

-  Windows: In acceleration mode, for uninstalled Python, now a CMD file
   is created rather than copying the DLL to the binary directory. That
   avoids conflicts with architectures and of course useless file
   copies.

-  New abilities for plugin ``anti-bloat`` allow to make it an error
   when certain modules are imported. Added more specific options for
   usual trouble makes, esp. ``setuptools``, ``pytest`` are causing an
   explosion for some programs, while being unused code. This makes it
   now easier to oversee this.

-  It's now possible to override ``appdirs`` decision for where cache
   files live with an environment variable ``NUITKA_CACHE_DIR``.

-  The ``-o`` option now also works with onefile mode, it previously
   rejected anything but acceleration mode. Fixed in 0.6.15.3 already.

-  Plugins: It's now possible for multiple plugins to provide pre or
   post load code for the same module.

-  Added indications for compilation modes ``standalone`` and
   ``onefile`` to the ``__compiled__`` attribute.

-  Plugins: Give nicer error message in case of colliding command line
   options.

Optimization
============

-  Faster threading code is now using for Python3.8 or higher and not
   only 3.9, giving a performance boost, esp. on Windows.

-  Using ``--lto`` is now the default with MSVC 2019 or higher. This
   will given smaller and faster binaries. It has been available for
   some time, but not been the default yet.

Cleanups
========

-  Using different progress bar titles for C compilation of Python code
   and C compilation of onefile bootstrap.

-  Moved platform specific detections, for FreeBSD/OpenBSD/macOS out of
   the Scons file and to common Nuitka code, sometimes eliminating
   duplications with one version being more correct than the other.

-  Massive cleanup of datafile plugin, using pattern descriptions, so
   more code duplication can be removed.

-  More cleanup of the scons files, sharing more common code.

Organisational
==============

-  Under the name Nuitka-Python we are now also developing a fork of
   CPython with enhancements, you can follow and joint it at
   https://github.com/Nuitka/Nuitka-Python but at this time it is not
   yet ready for prime time.

-  Onefile under Windows now only is temporary file mode. Until we
   figure out how to solve the problems with locking and caching, the
   mode where it installs to the AppData of the user is no longer
   available.

-  Renamed the plugin responsible for PyQt5 support to match the names
   of others. Note however, that at this time, PySide2 or PySide6 are to
   be recommended.

-  Make it clear that PySide 6.1.2 is actually going to be the supported
   version of PySide6.

-  Use MSVC in GitHub actions.

Summary
=======

This release had a massive focus on expanding existing features, esp.
for onefile, and plugins API, such that we can now configure
``anti-bloat`` with yaml, have really nice datafile handling options,
and have onefile on all OSes practically.

***********************
 Nuitka Release 0.6.15
***********************

This release polished previous work with bug fixes, but there are also
important new things that help make Nuitka more usable, with one
important performance improvement.

Bug Fixes
=========

-  Fix, hard imports were not automatically used in code generation
   leading to errors when used. Fixed in 0.6.14.2 already.

-  Windows: Fix, ``clcache`` was disabled by mistake. Fixed in 0.6.14.2
   already.

-  Standalone: Added data files for ``jsonschema`` to be copied
   automatically.

-  Standalone: Support for ``pendulum`` wasn't working anymore with the
   last release due to plugin interface issues.

-  Retry downloads without SSL if that fails, as some Python do not have
   working SSL. Fixed in 0.6.14.5 already.

-  Fix, the ``ccache`` path wasn't working if it contained spaces. Fixed
   in 0.6.14.5 already.

-  Onefile: For Linux and ARM using proper download off appimage. Fixed
   in 0.6.14.5 already.

-  Standalone: Added support for ``pyreadstat``. Fixed in 0.6.14.5
   already.

-  Standalone: Added missing dependencies for ``pandas``. Fixed in
   0.6.14.6 already.

-  Standalone: Some preloaded packages from ``.pth`` do not have a
   ``__path__``, these can and must be ignored.

-  Onefile: On Linux, the ``sys.argv[0]`` was not the original file as
   advertised.

-  Standalone: Do not consider ``.mesh`` and ``.frag`` files as DLls in
   the Qt bindings when including the qml support. This was causing
   errors on Linux, but was generally wasteful.

-  Fix, project options could be injected twice, which could lead to
   errors with options that were only allowed once, e.g.
   ``--linux-onefile-icon``.

-  Windows: When updating the resources in created binaries, treat all
   kinds of ``OSError`` with information output.

-  Onefile: Remove onefile target binary path at startup as well, so it
   cannot cause confusion after error exit.

-  Onefile: In case of error exit from ``AppImage``, preserve its
   outputs and attempt to detect if there was a locking issue.

-  Standalone: Scan package folders on Linux for DLLs too. This is
   necessary to properly handle ``PyQt5`` in case of Qt installed in the
   system as well.

-  Standalone: On Linux, standard QML files were not found.

-  Standalone: Enforce C locale when detecting DLLs on Linux, otherwise
   whitelisting messages didn't work properly on newer Linux.

-  Standalone: Added support for ``tzdata`` package data files.

-  Standalone: Added support for ``exchangelib``.

-  Python3.9: Fix, type subscripts could cause optimization errors.

-  UI: Project options didn't properly handle quoting of arguments,
   these are normally removed by the shell.

-  Linux: The default icon for Python in the system is now found with
   more version specific names and should work on more systems.

-  Standalone: Do not include ``libstdc++`` as it should come from the
   system rather.

New Features
============

-  Added plugin ``anti-bloat`` plugin, intended to fight bloat. For now
   it can make including certain modules an error, a warning, or force
   ``ImportError``, e.g. ``--noinclude-setuptools-mode=nofollow`` is
   very much recommended to limit compilation size.

-  The ``pkg-resources`` builtin now covers ``metadata`` and
   importlib_metadata packages for compile time version resolution as
   well.

-  Added support for ``PySide2`` on Python version before 3.6, because
   the patched code needs no workarounds. Fixed in 0.6.14.3 already.

-  Windows: Convert images to icon files on the fly. So now you can
   specify multiple PNG files, and Nuitka will create an icon out of
   that automatically.

-  macOS: Automatically download ``ccache`` binary if not present.

-  Plugins: New interface to query the main script path. This allows
   plugins to look at its directory.

-  UI: Output the versions of Nuitka and Python during compilation.

-  UI: Added option to control static linking. So far this had been
   enabled only automatically for cases where we are certain, but this
   allows to force enable or disable it. Now an info is given, if Nuitka
   thinks it might be possible to enable it, but doesn't do it
   automatically.

-  UI: Added ``--no-onefile`` to disable ``--onefile`` from project
   options.

Optimization
============

-  Much enhanced GIL interaction with Python3.9 giving a big speed boost
   and better threading behaviour.

-  Faster conversion of iterables to ``list``, if size can be know,
   allocation ahead saves a lot of effort.

-  Added support for ``GenericAlias`` objects as compile time constants.

Organisational
==============

-  Enhanced GitHub issue raising instructions.

-  Apply ``rstfmt`` to all documentation and make it part of the commit
   hook.

-  Make sure to check Scons files as well. This would have caught the
   code used to disable ``clcache`` temporarily.

-  Do not mention Travis in PR template anymore, we have stopped using
   it.

-  Updated requirements to latest versions.

-  Bump requirements for development to 3.7 at least, toosl like black
   do not work with 3.6 anymore.

-  Started work on Nuitka Python, a CPython fork intended for enhanced
   performance and standalone support with Nuitka.

Cleanups
========

-  Determine system prefix without virtualenv outside of Scons, such
   that plugins can share the code. There was duplication with the
   ``numpy`` plugin, and this will only be more complete using all
   approaches. This also removes a lot of noise from the scons file
   moving it to shared code.

-  The Qt plugins now collect QML files with cleaner code.

Tests
=====

-  Nicer error message if a wrong search mode is given.

-  Windows: Added timeout for determining run time traces with
   dependency walker, sometimes this hangs.

-  Added test to cover the zip importer.

-  Making use of project options in onefile tests, making it easier to
   execute them manually.

Summary
=======

For Windows, it's now easier than ever to create an icon for your
deployment, because you can use PNG files, and need not produce ICO
files anymore, with Nuitka doing that for you.

The onefile for Linux had some more or less severe problems that got
addressed, esp. also when it came to QML applications with PySide.

On the side, we are preparing to greatly improve the caching of Nuitka,
starting with retaining modules that were demoted to bytecode. There are
changes in this release, to support that, but it's not yet complete. We
expect that scalability will then be possible to improve even further.

Generally this is mostly a maintenance release, which outside of the
threading performance improvement has very little to offer for faster
execution, but that actually does a lot. Unfortunately right now it's
limited to 3.9, but some of the newer Python's will also be supported in
later releases.

***********************
 Nuitka Release 0.6.14
***********************

This release has few, but important bug fixes. The main focus was on
expanding standalone support, esp. for PySide2, but also and in general
with plugins added that workaround ``pkg_resources`` usage for version
information.

Also an important new features was added, e.g. the project configuration
in the main file should prove to be very useful.

Bug Fixes
=========

-  Compatibility: Fix, modules that failed to import, should be retried
   on next import.

   So far we only ever executed the module body once, but that is not
   how it's supposed to be. Instead, only if it's in ``sys.modules``
   that should happen, which is the case after successful import.

-  Compatibility: Fix, constant ``False`` values in right hand side of
   ``and``/``or`` conditions were generating wrong code if the left side
   was of known ``bool`` shape too.

-  Standalone: Fix, add ``styles`` Qt plugins to list of sensible
   plugins.

   Otherwise no mouse hover events are generated on some platforms.

-  Compatibility: Fix, relative ``from`` imports beyond level 1 were not
   loadingg modules from packages if necessary. Fixed in 0.6.13.3
   already.

-  Standalone: The ``crypto`` DLL check for Qt bindings was wrong. Fixed
   in 0.6.13.2 already.

-  Standalone: Added experimental support for PySide6, but for good
   results, 6.1 will be needed.

-  Standalone: Added support for newer matplotlib. Fixed in 0.6.12.1
   already.

-  Standalone: Reverted changes related to ``pkg_resources`` that were
   causing regressions. Fixed in 0.6.13.1 already.

-  Standalone: Adding missing implicit dependency for ``cytoolz``
   package. Fixed in 0.6.13.1 already.

-  Standalone: Matching for package names to not suggest recompile for
   was broken and didn't match. Fixed in 0.6.13.1 already.

New Features
============

-  Added support for project options.

   When found in the filename provided, Nuitka will inject options to
   the commandline, such that it becomes possible to do a complex
   project with only using

   .. code:: bash

      python -m nuitka filename.py

   .. code:: python

      # Compilation mode, support OS specific.
      # nuitka-project-if: {OS} in ("Windows", "Linux"):
      #    nuitka-project: --onefile
      # nuitka-project-if: {OS} not in ("Windows", "Linux"):
      #    nuitka-project: --standalone

      # The PySide2 plugin covers qt-plugins
      # nuitka-project: --enable-plugin=pyside2
      # nuitka-project: --include-qt-plugins=sensible,qml

      # The pkg-resources plugin is not yet automatic
      # nuitka-project: --enable-plugin=pkg-resources

      # Nuitka Commercial only features follow:

      # Protect the constants from being readable.
      # nuitka-project: --enable-plugin=data-hiding

      # Include datafiles for Qt into the binary directory.
      # nuitka-project: --enable-plugin=datafile-inclusion
      # nuitka-project: --qt-datadir={MAIN_DIRECTORY}
      # nuitka-project: --qt-datafile-pattern=*.js
      # nuitka-project: --qt-datafile-pattern=*.qml
      # nuitka-project: --qt-datafile-pattern=*.svg
      # nuitka-project: --qt-datafile-pattern=*.png

   Refer to the User Manual for a table of directives and the variables
   allowed to be used.

-  Added option to include whole data directory structures in
   standalone.

   The new option ``--include-data-dir`` was added and is mostly
   required for onefile mode, but recommended for standalone too.

-  Added ``pkg-resources`` plugin.

   This one can resolve code like this at compile time without any need
   for pip metadata to be present or used.

   .. code:: python

      pkg_resources.get_distribution("module_name").version
      pkg_resources.get_distribution("module_name").parsed_version

-  Standalone: Also process early imports in optimization.

   Otherwise plugins cannot work on standard library modules. This makes
   it possible to handle them as well.

Optimization
============

-  Faster binary operations.

   Applying lessons learnt during the enhancements for in-place
   operations that initially gave worse results than some manual code,
   we apply the same tricks for all binary operations, which speeds them
   up by significant margins, e.g. 30% for float addition, 25% for
   Python int addition, and still 6% for Python int addition.

-  More direct optimization of unary operations on constant value.

   Without this, ``-1`` was not directly a constant value, but had to go
   through the unary ``-`` operation, which it still does, but now it's
   done at tree building time.

-  More direct optimization for ``not`` in branches.

   Invertible comparisons, i.e. ``is``/``is not`` and ``in``/``not in``
   do not have do be done during optimization. This mainly avoids noise
   during optimization from such unimportant steps.

-  More direct optimization for constant slices.

   These are used in Python3 for all subscripts, e.g. ``a[1:2]`` will
   use ``slice(1,2)`` effectively. For Python2 they are used less often,
   but still. This also avoids a lot of noise during optimization,
   mostly on Python3

-  Scons: Avoid writing database to disk entirely.

   This saves a bit of disk churn and makes it unnecessary to specify
   the location such that it doesn't collide between Python versions.

-  For optimization passes, use previous max total as minimum for next
   pass. That will usually be a more accurate result, rather than
   starting from 1 again. Part of 0.6.13.1 already.

-  Enhancements to the branch merging improve the scalability of Nuitka
   somewhat, although the merging itself is still not very scalable,
   there are some modules that are very slow to optimize still.

-  Use ``orderset`` if available over the inline copy for ``OrderedSet``
   which is much faster and improves Nuitka compile times.

-  Make ``pkgutil`` a hard import too, this is in preparation of more
   optimization for its functions.

Organisational
==============

-  Upstream patches for ``PySide6`` have been contributed and merged
   into the development branch ``dev``. Full support should be available
   once this is released as part of 6.1 which is waiting for Qt 6.1
   naturally.

-  Patches for ``PySide2`` are available to commercial customers, see
   `PySide2 support <https://nuitka.net/pages/pyside2.html>`__ page.

-  Formatted all documents with ``rstfmt`` and made that part of the
   commit hook for Nuitka. It now works for all documents we have.

-  Updated inline copy of ``tqdm`` to 4.59.0 which ought to address
   spurious errors given.

-  User Manual: Remove ``--show-progress`` from the tutoral. The default
   progress bar is then disabled, and is actually much nicer to use.

-  Developer Manual: Added description of how context managers should be
   named.

-  Cleanup language for some warnings and outputs.

   It was still using obsolete "recursion" language rather than talking
   about "following imports", which is the new one.

Cleanups
========

-  Remove dead code related to constants marshal, the data composer has
   replaced this.

-  Avoid internal API usage for loading extension modules on Linux,
   there is a function in ``sys`` module to get the ld flags.

Tests
=====

-  Fix, the ``only`` mode wasn't working properly.

-  Use new project options feature for specific options in basic tests
   allowing to remove them from the test runner.

Summary
=======

For PySide2 things became more perfect, but it takes upstream patches
unfortunately such that only PySide6.1 will be working out of the box
outside of the commercial offering. We will also attempt to provide
workarounds, but there are some things that cannot be done that way.

This release added some more scalability to the optimization process,
however there will be more work needed to make efficient branch merges.

For onefile, a feature to include whole directories had been missing,
and could not easily be achieved with the existing options. This further
rounds this up, now what's considered missing is compression and macOS
support, both of which should be coming in a future release.

For the performance side of things, the binary operator work can
actually yield pretty good gains, with double digit improvements, but
this covers only so much. Much more C types and better type tracing
would be needed, but there was no progress on this front. Future
releases will have to revisit the type tracing to make sure, we know
more about loop variables, etc. so we can achieve the near C speed we
are looking for, at least in the field of ``int`` performance.

This release has largely been driven by the `Nuitka Commercial
</doc/commercial.html>`__ offering and needs for compatibility with more
code, which is of course always a good thing.

***********************
 Nuitka Release 0.6.13
***********************

This release follows up with yet again massive improvement in many ways
with lots of bug fixes and new features.

Bug Fixes
=========

-  Windows: Icon group entries were not still not working properly in
   some cases, leading to no icon or too small icons being displayed.
   Fixed in 0.6.12.2 already.

-  Windows: Icons and version information were copied from the
   standalone executable to the onefile executable, but that failed due
   to race situations, sometimes reproducible. Instead we now apply
   things to both independently. Fixed in 0.6.12.2 already.

-  Standalone: Fixup scanning for DLLs with ``ldconfig`` on Linux and
   newer versions making unexpected outputs. Fixed in 0.6.12.2 already.

-  UI: When there is no standard input provided, prompts were crashing
   with ``EOFError`` when ``--assume-yes-for-downloads`` is not given,
   change that to defaulting to ``"no"`` instead. Fixed in 0.6.12.2
   already.

-  Windows: Detect empty strings for company name, product name, product
   and file versions rather than crashing on them later. Them being
   empty rather than not there can cause a lot of issues in other
   places. Fixed in 0.6.12.2 already.

-  Scons: Pass on exceptions during execution in worker threads and
   abort compilation immediately. Fixed in 0.6.12.2 already.

-  Python3.9: Still not fully compatible with typing subclasses, the
   enhanced check is now closely matching the CPython code. Fixed in
   0.6.12.2 already.

-  Linux: Nicer error message for missing ``libfuse`` requirement.

-  Compatibility: Lookups on dictionaries with ``None`` value giving a
   ``KeyError`` exception, but with no value, which is not what CPython
   does.

-  Python3.9: Fix, future annotations were crashing in debug mode. Fixed
   in 0.6.12.3 already.

-  Standalone: Corrections to the ``glfw`` were made. Fixed in 0.6.12.3
   already.

-  Standalone: Added missing ìmplicit dependency for ``py.test``. Fixed
   in 0.6.12.3 already.

-  Standalone: Adding missing implicit dependency for ``pyreadstat``.

-  Windows: Added workaround for common clcache locking problems. Since
   we use it only inside a single Scons process, we can avoiding using
   Windows mutexes, and use a process level lock instead.

-  Plugins: Fix plugin for support for ``eventlet``. Fixed in 0.6.12.3
   already.

-  Standalone: Added support for latest ``zmq`` on Windows.

-  Scons: the ``--quiet`` flag was not fully honored yet, with Scons
   still making a few outputs.

-  Standalone: Added support for alternative DLL name for newer
   ``PyGTK3`` on Windows. Fixed in 0.6.12.4 already.

-  Plugins: Fix plugin for support for ``gevent``. Fixed in 0.6.12.4
   already.

-  Standalone: Added yet another missing implicit dependency for
   ``pandas``.

-  Plugins: Fix, the ``qt-plugins`` plugin could stumble over ``.mesh``
   files.

-  Windows: Fix, dependency walker wasn't properly working with unicode
   ``%PATH%`` which could e.g. happen with a virtualenv in a home
   directory that requires them.

-  Python3: Fixed a few Python debug mode warnings about unclosed files
   that have sneaked into the codebase.

New Features
============

-  Added new options ``--windows-force-stdout-spec`` and
   ``--windows-force-stderr-spec`` to force output to files. The paths
   provided at compile time can resolve symbolic paths, and are intended
   to e.g. place these files near the executable. Check the User Manual
   for a table of the currently supported values. At this time, the
   feature is limited to Windows, where the need arose first, but it
   will be ported to other supported OSes eventually. These are most
   useful for programs run as ``--windows-disable-console`` or with
   ``--enable-plugin=windows-service``.

   .. note::

      These options have since been renamed to ``--force-stdout`` and
      ``--force-stderr`` and have been made to work on all OSes.

-  Windows: Added option ``--windows-onefile-tempdir-spec`` (since
   renamed to ``--onefile-tempdir-spec``) to provide the temporary
   directory used with ``--windows-onefile-tempdir`` in onefile mode,
   you can now select your own pattern, and e.g. hardcode a base
   directory of your choice rather than ``%TEMP``.

-  Added experimental support for ``PySide2`` with workarounds for
   compiled methods not being accepted by its core. There are known
   issues with ``PySide2`` still, but it's working fine for some people
   now. Upstream patches will have to be created to remove the need for
   workarounds and full support.

Optimization
============

-  Use binary operation code for their in-place variants too, giving
   substantial performance improvements in all cases that were not dealt
   with manually already, but were covered in standard binary
   operations. Until now only some string, some float operations were
   caught sped up, most often due to findings of Nuitka being terribly
   slower, e.g. not reusing string memory for inplace concatenation, but
   now all operations have code that avoids a generic code path, that is
   also very slow on Windows due calling to using the embedded Python
   via API being slow.

-  For mixed type operations, there was only one direction provided,
   which caused fallbacks to slower forms, e.g. with ``long`` and
   ``float`` values leading to inconsistent results, such that ``a - 1``
   and ``1 - a`` being accelerated or not.

-  Added C boolean optimization for a few operations that didn't have
   it, as these allow to avoid doing full computation of what the object
   result would have to do. This is not exhausted fully yet.

-  Python3: Faster ``+``/``-``/``+=``/``-=`` binary and in-place
   operations with ``int`` values providing specialized code helpers
   that are much faster, esp. in cases where no new storage is allocated
   for in-place results and where not a lot of digits are involved.

-  Python2: The Python3 ``int`` code is the Python2 ``long`` type and
   benefits from the optimization of ``+``/``-``/``+=``/``-=`` code as
   well, but of course its use is relatively rare.

-  Improved ``__future__`` imports to become hard imports, so more
   efficient code is generated for them.

-  Counting of instances had a run time impact by providing a
   ``__del__`` that was still needed to be executed and limits garbage
   collection on types with older Python versions.

-  UI: Avoid loading ``tqdm`` module before it's actually used if at all
   (it may get disabled by the user), speeding up the start of Nuitka.

-  Make sure to optimize internal helpers only once and immediately,
   avoiding extra global passes that were slowing down Python level
   compilation by of large programs by a lot.

-  Make sure to recognize the case where a module optimization can
   provide no immediate change, but only after a next run, avoiding
   extra global passes originating from these, that were slowing down
   compilation of large programs by a lot. Together with the other
   change, this can improve scalability by a lot.

-  Plugins: Remove implicit dependencies for ``pkg_resources.extern``
   and use aliases instead. Using one of the packages, was causing all
   that might be used, to be considered as used, with some being
   relatively large. This was kind of a mistake in how we supported this
   so far.

-  Plugins: Revamped the ``eventlet`` plugin, include needed DNS modules
   as bytecode rather than as source code, scanning them with
   ``pkgutil`` rather than filesystem, with much cleaner code in the
   plugin. The plugin is also now enabled by default.

Organisational
==============

-  Removed support for ``pefile`` dependency walker choice and inline
   copy of the code. It was never as good giving incomplete results, and
   after later improvements, slower, and therefore has lost the original
   benefit over using Dependency Walker that is faster and more correct.

-  Added example for onefile on Windows with the version information and
   with the temporary directory mode.

-  Describe difference in file access with onefile on Windows, where
   ``sys.argv[0]`` and ``os.path.dirname(__file__)`` will be different
   things.

-  Added inline copy of ``tqdm`` to make sure it's available for
   progress bar output for 2.7 or higher. Recommend having it in the
   Debian package.

-  Added inline copy of ``colorama`` for use on Windows, where on some
   terminals it will give better results with the progress bar.

-  Stop using old PyLint for Python2, while it would be nice to catch
   errors, the burden of false alarms seems to high now.

-  UI: Added even more checks on options that make no sense, made sure
   to do this only after a possible restart in proper environment, so
   warnings are not duplicated.

-  For Linux onefile, keep appimage outputs in case of an error, that
   should help debugging it in case of issues.

-  UI: Added traces for plugin provided implicit dependencies leading to
   inclusions.

-  Added inline copy of ``zstd`` C code for use in decompression for the
   Windows onefile bootstrap, not yet used though.

-  Added checks to options that accept package names for obvious
   mistakes, such that ``--include-package-data --mingw64`` will not
   swallow an option, as that is clearly not a package name, that would
   hide that option, while also not having any intended effect.

-  Added ignore list for decision to recompile extension modules with
   available source too. For now, Nuitka will not propose to recompile
   ``Cython`` modules that are very likely not used by the program
   anyway, and also not for ``lxml`` until it's clear if there's any
   benefit in that. More will be added in the future, this is mostly for
   cases, where Cython causes incompatibilities.

-  Added support for using abstract base classes in plugins. These are
   not considered for loading, and allow nicer implementation of shared
   code, e.g. between ``PyQt5`` and ``PySide2`` plugins, but allow e.g.
   to enforce the provision of certain overloads.

-  User Manual: Remove the instruction to install ``clcache``, since
   it's an inline copy, this makes no sense anymore and that was
   obsolete.

-  Updated PyLint to latest versions, and our requirements in general.

Cleanups
========

-  Started removal of PyLint annotations used for old Python2 only. This
   will be a continuous action to remove these.

-  Jinja2 based static code generation for operations was cleaned up, to
   avoid code for static mismatches in the result C, avoiding language
   constructs like ``if (1 && 0)`` with sometimes larger branches,
   replacing it with Jinja2 branches of the ``{% if ... %}`` form.

-  Jinja2 based Python2 ``int`` code was pioniering the use of macros,
   but this was expanded to allow kinds of types for binary operations,
   allow their reuse for in-place operation, with these macros making
   returns via goto exits rather than return statements in a function.
   Landing pads for these exits can then assign target values for
   in-place different from what those for binary operation result return
   do.

-  Changed the interfacing of plugins with DLL dependency detection,
   cleaning up the interactions considerably with more unified code, and
   faster executing due to cached plugin decisions.

-  Integrate manually provided slot function for ``unicode`` and ``str``
   into the standard static code generation. Previously parts were
   generated and parts could be generated, but also provided with manual
   code. The later is now all gone.

-  Use a less verbose progress bar format with less useless infos,
   making it less likely to overflow.

-  Cleanup how payload data is accessed in Windows onefile bootstrap,
   preparing the addition of decompression, doing the reading from the
   file in only one dedicated function.

-  When Jinja2 generated exceptions in the static code, it is now done
   via proper Jinja2 macros rather than Python code, and these now avoid
   useless Python version branches where possible, e.g. because a type
   like ``bytes`` is already Python version specific, with the goal to
   get rid of ``PyErr_Format`` usage in our generated static code. That
   goal is future work though.

-  Move safe strings helpers (cannot overflow) to a dedicated file, and
   remove the partial duplication on the Windows onefile bootstrap code.

-  The Jinja2 static code generation was enhanced to track the usage of
   labels used as goto targets, so that error exits, and value typed
   exits from operations code no longer emitted when not used, and
   therefore labels that are not used are not present.

-  For implicit dependencies, the parsing of the ``.pyi`` file of a
   module no longer emits a dependency on the module itself. Also from
   plugins, these are now filtered away.

Tests
=====

-  Detect if onefile mode has required downloads and if there is user
   consent, otherwise skip onefile tests in the test runner.

-  Need to also allow accesses to files via short paths on Windows if
   these are allowed long paths.

-  The standalone tests on Windows didn't actually take run time traces
   and therefore were ineffective.

-  Added standalone test for ``glfw`` coverage.

-  Construct based tests for in-place operations are now using a value
   for the first time, and then a couple more times, allowing for real
   in-place usage, so we are sure we measure correctly if that's
   happening.

Summary
=======

Where the big change of the last release were optimization changes to
reduce the global passes, this release addresses remaining causes for
extra passes, that could cause these to still happen. That makes sure,
Nuitka scalability is very much enhanced in this field again.

The new features for forced outputs are at this time Windows only and
make a huge difference when it comes to providing a way to debug Windows
Services or programs in general without a console, i.e. a GUI program.
These will need even more specifiers, e.g. to cover program directory,
rather than exe filename only, but it's a very good start.

On the tooling side, not a lot has happened, with the clcache fix, it
seems that locking issues on Windows are gone.

The plugin changes from previous releases had left a few of them in a
state where they were not working, but this should be restored.
Interaction with the plugins is being refined constantly, and this
releases improved again on their interfaces. It will be a while until
this becomes stable.

Adding support for PySide2 is a headline feature actually, but not as
perfect as we are used to in other fields. More work will be needed,
also in part with upstream changes, to get this to be fully supported.

For the performance side of things, the in-place work and the binary
operations work has taken proof of concept stuff done for Python2 and
applied it more universally to Python3. Until we cover all long
operations, esp. ``*`` seems extremely important and is lacking, this
cannot be considered complete, but it gives amazing speedups in some
cases now.

Future releases will revisit the type tracing to make sure, we know more
about loop variables, to apply specific code helpers more often, so we
can achieve the near C speed we are looking for in the field of ``int``
performance.

***********************
 Nuitka Release 0.6.12
***********************

This release is yet again a massive improvement in many ways with lots
of bug fixes and new features.

Bug Fixes
=========

-  Windows: Icon group entries were not working properly in some cases,
   leading to no icon or too small icons being displayed.

-  Standalone: The PyQt implicit dependencies were broken. Fixed in
   0.6.11.1 already.

-  Standalone: The datafile collector plugin was broken. Fixed in
   0.6.11.3 already.

-  Standalone: Added support for newer forms of ``matplotlib`` which
   need a different file layout and config file format. Fixed in
   0.6.11.1 already.

-  Plugins: If there was an error during loading of the module or
   plugin, it could still be attempted for use. Fixed in 0.6.11.1
   already.

-  Disable notes given by gcc, these were treated as errors. Fixed in
   0.6.11.1 already.

-  Windows: Fix, spaces in gcc installation paths were not working.
   Partially fixed in 0.6.11.4 already.

-  Linux: Fix, missing onefile icon error message was not complete.
   Fixed in 0.6.11.4 already.

-  Standalone: Workaround ``zmq`` problem on Windows by duplicating a
   DLL in both expected places. Fixed in 0.6.11.4 already.

-  Standalone: The ``dill-compat`` plugin wasn't working anymore. Fixed
   in 0.6.11.4 already.

-  Windows: Fix mistaken usage of ``sizeof`` for wide character buffers.
   This caused Windows onefile mode in temporary directory. Fixed in
   0.6.11.4 already.

-  Windows: Fix, checking subfolder natured crashed with different
   drives on Windows. Fixed in 0.6.11.4 already.

-  Windows: Fix, usage from MSVC prompt was no longer working, detect
   used SDK properly. Fixed in 0.6.11.4 already.

-  Windows: Fix, old clcache installation uses pth files that prevented
   our inline copy from working, workaround was added.

-  Windows: Also specify stack size to be used when compiling with gcc
   or clang.

-  Fix, claim of Python 3.9 support also in PyPI metadata was missing.
   Fixed in 0.6.11.5 already.

-  Python3.9: Subscripting ``type`` for annotations wasn't yet
   implemented.

-  Python3.9: Better matching of types for metaclass selection, generic
   aliases were not yet working, breaking some forms of type annotations
   in base classes.

-  Windows: Allow selecting ``--msvc-version`` when a MSVC prompt is
   currently activated.

-  Windows: Do not fallback to using gcc when ``--msvc-version`` has
   been specified. Instead it's an error if that fails to work.

-  Python3.6+: Added support for ``del ()`` statements, these have no
   effect, but were crashing Nuitka.

   .. code:: python

      del a  # standard form
      del a, b  # same as del a; del b
      del (a, b)  # braces are allowed
      del ()  # allowed for consistency, but wasn't working.

-  Standalone: Added support for ``glfw`` through a dedicated plugin.

-  macOS: Added support for Python3 from system and CPython official
   download for latest OS version.

New Features
============

-  UI: With ``tqdm`` installed alongside Nuitka, experimental progress
   bars are enabled. Do not use `` --show-progress`` or ``--verbose`` as
   these might have to disable it.

-  Plugins: Added APIs for final processing of the result and onefile
   post processing.

-  Onefile: On Windows, the Python process terminates with
   ``KeyboardInterrupt`` when the user sends CTRL-break, CTRL-C,
   shutdown or logoff signals.

-  Onefile: On Windows, in case of the launching process terminating
   unexpectedly, e.g. due to Taskmanager killing it, or a ``os.sigkill``
   resulting in that, the Python process still terminates with
   ``KeyboardInterrupt``.

-  Windows: Now can select icons by index from files with multiple
   icons.

Optimization
============

-  Avoid global passes caused by module specific optimization. The
   variable completeness os now traced per module and function scope,
   allowing a sooner usage. Unused temporary variables and closure
   variables are remove immediately. Recognizing possible auto releases
   of parameter variables is also instantly.

   This should bring down current passes from 5-6 global passes to only
   2 global passes in the normal case, reducing frontend compile times
   in some cases massively.

-  Better unary node handling. Dedicated nodes per operation allow for
   more compact memory usage and faster optimization.

-  Detect flow control and value escape for the repr of node based on
   type shape.

-  Enhanced optimization of caught exception references, these never
   raise or have escapes of control flow.

-  Exception matching operations are more accurately annotated, and may
   be recognized to not raise in more cases.

-  Added optimization for the ``issubclass`` built-in.

-  Removed scons caching as used on Windows entirely. We should either
   be using ``clcache`` or ``ccache`` automatically now.

-  Make sure to use ``__slots__`` for all node classes. In some cases,
   mixins were preventing the feature from being it. We now enforce
   their correct specification of slots, which makes sure we can't miss
   it anymore. This should again gain more speed and save memory at
   frontend compile time.

-  Scons: Enhanced gcc version detection with improved caching behavior,
   this avoids querying the same gcc binary twice.

Organisational
==============

-  The description of Nuitka on PyPI was absent for a while. Added back
   by adding long description of the project derived from the README
   file.

-  Avoid terms ``blacklist``, ``whilelist`` and ``slave`` in the Nuitka
   code preferring ``blocklist``, ``ignorelist`` and ``child`` instead,
   which are actually more clear anyway. We follow a general trend to do
   this.

-  Configured the inline copy of Scons so pylance has an easier time to
   find it.

-  The git commit hook had stopped applying diffs with newest git,
   improved that.

-  Updated description for adding new CPython test suite.

-  Using https URLs for downloading dependency walker, for it to be more
   secure.

-  The commit hook can now be disabled, it's in the Developer Manual how
   to do it.

Cleanups
========

-  Moved unary operations to their own module, the operators module was
   getting too crowded.

-  The scons files for Python C backend and Windows onefile got cleaned
   up some more and moved more common code to shared modules.

-  When calling external tools, make sure to provide null input where
   possible.

-  Unified calling ``install_name_tool`` into a single method for adding
   rpath and name changes both at the same time.

-  Unified how tools like ``readelf``, ``ldconfig`` etc. are called and
   error exits and outputs checked to make sure we don't miss anything
   as easily.

Tests
=====

-  Adapted for some openSUSE specific path usages in standalone tests.

-  Basic tests for onefile operation and with termination signal sent
   were added.

Summary
=======

The big changes in this release are the optimization changes to reduce
the global passes and the memory savings from other optimization. These
should again make Nuitka more scalable with large projects, but there
definitely is work remaining.

Adding nice stopping behaviour for the Onefile mode on Windows is
seemingly a first, and it wasn't easy, but it will make it more reliable
to users.

Also tooling of gcc and MSVC on Windows got a lot more robust, covering
more cases, and macOS support has been renewed and should be a lot
better now.

The progress bar is a nice touch and improves the overall feel of the
compilation process, but obviously we need to aim at getting faster
overall still. For projects using large dependencies, e.g. Pandas the
compilation is still far too slow and that will need work on caching
frontend results, and better optimization and C code generation for the
backend.

***********************
 Nuitka Release 0.6.11
***********************

This release is a massive improvement in many ways with lots of bug
fixes and new features.

Bug Fixes
=========

-  Fix, the ``.pyi`` file parser didn't handle relative imports. Fixed
   in 0.6.10.1 already.

-  Windows: Fix, multiprocessing plugin was not working reliable
   following of imports from the additional entry point. Fixed in
   0.6.10.1 already.

-  Pipenv: Workaround parsing issue with our ``setup.py`` to allow
   installation from GitHub. Fixed in 0.6.10.1 already.

-  Merging of branches in optimization could give nondeterministic
   results leading to more iterations than necessary. Fixed in 0.6.10.1
   already.

-  Windows: Avoid profile powershell when attempting to resolve
   symlinks. Fixed in 0.6.10.1 already.

-  Windows: Fix, always check for stdin, stdout, and stderr presence.
   This was so far restricted to gui mode applications, but it seems to
   be necessary in other situations too. Fixed in 0.6.10.1 already.

-  Python2: Fix, ``--trace-execution`` was not working for standalone
   mode but can be useful for debugging. Fixed in 0.6.10.1 already.

-  Windows: Onefile could run into path length limits. Fixed in 0.6.10.3
   already.

-  Windows: The winlib gcc download link became broken and was updated.
   Fixed in 0.6.10.3 already.

-  Plugins: The "__main__" module was not triggering all plugin hooks,
   but it needs to for completeness.

-  Standalone: Fix, symlinked Python installations on Windows were not
   working, with dependency walker being unable to look into these.
   Fixed in 0.6.10.4 already.

-  Standalone: Fix support for numpy on Windows and macOS, the plugin
   failed to copy important DLLs. Fixed in 0.6.10.4 already.

-  Python3: For versions before 3.7, the symlink resolution also needs
   to be done, but wasn't handling the bytes output yet. Fixed in
   0.6.10.4 already.

-  Fix, folder based inclusion would both pick up namespace folders and
   modules of the same name, crashing the compilation due to conflicts.
   Fixed in 0.6.10.4 already.

-  Fix, the ``--lto`` wasn't used for clang on non-Windows yet.

-  Fix, the order of locals dict releases wasn't enforced, which could
   lead to differences that break caching of C files potentially. Fixed
   in 0.6.10.5 already.

-  Fix, ``hash`` nodes didn't consider if their argument was raising,
   even if the type of the argument was ``str`` and therefore the
   operation should not. Fixed in 0.6.10.5 already.

-  Fix, need to copy type shape and escape description for the
   replacement inverted comparisons when used with ``not``, otherwise
   the compilation can crash as these are expected to be present at all
   times. Fixed in 0.6.10.5 already.

-  Fix, some complex constant values could be confused, e.g. ``-0j`` and
   ``0j``. These corner cases were not properly considered in the
   constant loading code, only for ``float`` so far.

-  Standalone: Fix, bytecode only standard library modules were not
   working. This is at least used with Fedora 33.

-  Linux: Fix, extension modules compiled with ``--lto`` were not
   working.

-  Windows: Retry if updating resources fails due to Virus checkers
   keeping files locked.

-  Plugins: Pre- and postload code of modules should not be allowed to
   cause ``ImportError``, as these will be invisible to the other parts
   of optimization, instead make them unraisable error traces.

-  Standalone: Adding missing import for SciPy 1.6 support.

-  Windows: Fix, only export required symbols when using MinGW64 in
   module mode.

New Features
============

-  Python3.9: Added official support for this version.

-  Onefile: Added command line options to include data files. These are
   ``--include-package-data`` which will copy all non-DLLs and
   non-Python files of package names matching the pattern given. And
   ``--include-data-file`` takes source and relative target file paths
   and copies them. For onefile this is the only way to include files,
   for standalone mode they are mostly a convenience function.

-  Onefile: Added mode where the file is unpacked to a temporary folder
   before running instead of doing it to appdata.

-  Onefile: Added linux specific options ``--linux-onefile-icon`` to
   allow provision of an icon to use in onefile mode on Linux, so far
   this was only available as the hard coded path to a Python icon,
   which also didn't exist on all platforms.

-  UI: Major logging cleanup. Everything is now using our tracing
   classes and even error exits go through there and are therefore
   colored if possible.

-  Plugins: Make it easier to integrate commercial plugins, now only an
   environment variable needs to point to them.

-  UI: Enhanced option parsing gives notes. This complains about options
   that conflict or that are implied in others. Trying to catch more
   usage errors sooner.

-  Plugins: Ignore exceptions in buggy plugin code, only warn about them
   unless in debug mode, where they still crash Nuitka.

-  Scons: More complete scons report files, includes list values as well
   and more modes used.

-  Windows: The ``clcache`` is now included and no longer used from the
   system.

-  Output for ``clcache`` and ``ccache`` results got improved.

-  Enhanced support for ``clang``, on Windows if present near a
   ``gcc.exe`` like it is the case for some winlibs downloads, it will
   be used. To use it provide ``--mingw64 --clang`` both. Without the
   first one, it will mean ``clangcl.exe`` which uses the MSVC compiler
   as a host.

Optimization
============

-  Some modules had very slow load times, e.g. if they used many list
   objects due to linear searches for memory deduplication of objects.
   We now have dictionaries of practically all constant objects loaded,
   making these more instant.

-  Use less memory at compile time due using ``__slots__`` for all node
   types, finally figured out, how to achieve this with multiple
   inheritance.

-  Use hedley for compiler macros like ``unlikely`` as they know best
   how to do these.

-  Special case the merging of 2 branches avoiding generic code and
   being much faster.

-  Hard imports have better code generated, and are being optimized into
   for the few standard library modules and builtin modules we handle,
   they also now annotate the type shape to be module.

-  No longer annotate hard module import attribute lookups as control
   flow escapes. Not present attributes are changed into static raises.
   Trust for values is configured for a few values, and experimental.

-  Avoid preloaded packages for modules that have no side effects and
   are in the standard library, typically ``.pth`` files will use e.g.
   ``os`` but that's not needed to be preserved.

-  Use ``incbin`` for including binary data through inline assembly of
   the C compiler. This covers many more platforms than our previous
   linker option hacks, and the fallback to generated C code. In fact
   everything but Windows uses this now.

Organisational
==============

-  Windows: For Scons we now require a Python 3.5 or higher to be
   installed to use it.

-  Windows: Removed support for gcc older than version 8. This
   specifically affects CondaCC and older MinGW64 installations. Since
   Nuitka can now download the MinGW64 10, there is no point in having
   these and they cause issues.

-  We took over the maintenance of clcache as Nuitka/clcache which is
   not yet ready for public consumption, but should become the new
   source of clache in the future.

-  Include an inline copy of clcache in Nuitka and use it on Windows for
   MSVC and ClangCL.

-  Removed compatibility older aliases of follow option, ``--recurse-*``
   and require ``--follow-*`` options to be used instead.

-  For pylint checking, the tool now supports a ``--diff`` mode where
   only the changed files get checked. This is much faster and allows to
   do it more often before commit.

-  Check the versions of isort and black when doing the auto-format to
   avoid using outdated versions.

-  Handling missing pylint more gracefully when checking source code
   quality.

-  Make sure to use the codespell tool with Python3 and make sure to
   error exit when spelling problems were found, so we can use this in
   GitHub actions too.

-  Removed Travis config, we now only use GitHub actions.

-  Removed landscape config, it doesn't really exist anymore.

-  Bumped all PyPI dependnecies to their latest versions.

-  Recommend ccache on Debian, as we now consider the absence of ccache
   something to warn about.

-  Plugins: The DLLs asked for by plugins that are not found are no
   longer warned about.

-  Allow our checker and format tools to run on outside of tree code. We
   are using that for Nuitka/clcache.

-  Added support for Fedora 33 and openSUSE 15.3, as well as Ubuntu
   Groovy.

-  Windows: Check if Windows SDK is installed for MSVC and ClangCL.

-  Windows: Enhanced wording in case no compiler was found. No longer
   tell people how to manually install MinGW64, that is no longer
   necessary and ``pywin32`` is not needed to detect MSVC, so it's not
   installed if not found.

